#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <cmath>
#include <string>
#include <vector>
#include <bitset>
#include <iomanip>

#define sp << " "
#define sps << " " <<
#define ln << "\n"
#define vi vector<int>
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define rall(a) a.rbegin(), a.rend()
#define optimise cin.sync_with_stdio(false); cout.sync_with_stdio(false); cin.tie(NULL);

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

template<class T>
istream& operator>> (istream& is, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)is >> vec[i]; return is; }
template<class T>
ostream& operator<< (ostream& os, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)os << vec[i] sp; return os; }
template<class T>
istream& operator>> (istream& is, pair<T, T>& a) { is >> a.first >> a.second; return is; }

const double pi = acos(-1.0);
const ll mod = (1ll << 30); //(int)1e9 + 7;
const ll INF = 2e18;
const int inf = 1e9;
const int maxlen = (int)1e5 + 10;
const double eps = 1e-4;
//--------------------------

int pr[maxlen];
int col[maxlen];
int u = 0, mx = 1;
bool rec(int a, int b, int p = -1) {
    if (!a && !b) return true;
    if (b % 2 == 0 && !a) return false;
    u++;
    pr[u] = p;

    bool res = true;
    int v = u;
    if (b & 1) {
        col[u] = 2;
        res &= rec(a / 2, (b - 1) / 2, v);
        res &= rec((a + 1) / 2, (b - 1) / 2, v);
    }
    else {
        col[u] = 1;
        mx += 2;
        res &= rec((a - 1) / 2, b / 2, v);
        res &= rec(a / 2, b / 2, v);
    }
    return res;
}


void solve() {
    int a, b; cin >> a >> b;

    if (rec(a, b)) {
        vector<vi> ch(a + b + 1);
        for (int u = 1; u <= a + b; ++u) {
            if (pr[u] > 0) {
                ch[pr[u]].push_back(u);
            }
        }
        for (int u = 1; u <= a + b; ++u) {
            while (ch[u].size() < 2) ch[u].push_back(0);
        }

        for (int u = 1; u <= a + b; ++u) {
            cout << col[u] sps ch[u][0] sps ch[u][1] ln;
        }
    }
    else {
        cout << -1;
    }
}

int main() {
    optimise
#ifdef _DEBUG
        freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#else
        //freopen("output.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}