#pragma comment(linker, "/STACK:1000000000")
#include <vector>
#include <map>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <set>
#include <sstream>
#include <functional>
#include <iterator>
#include <random>
#include <list>
#include <queue>
#include <cstdlib>
#include <string>
#include <memory.h>
#include <cstdint>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <fstream>
#include <deque>
#include <cmath>
#include <numeric>
#include <stack>
#include <stdarg.h>
#include <cstdio>
using namespace std;
#pragma region custom templates
#define fi(n) for (int i = 0; i < int (n); i++)
#define fj(n) for (int j = 0; j < int (n); j++)
#define fk(n) for (int k = 0; k < int (n); k++)
#define f1(_n) for (auto&i1 : _n)
#define f2(_n) for (auto&i2 : _n)
#define f3(_n) for (auto&i3 : _n)
#define all(n) n.begin(), n.end()
#define break(_x)    {_x;break;}
#define continue(_x) {_x;continue;}
#define _sort(_x)    sort(_x.begin(), _x.end())
#define r_sort(_x)   sort(_x.rbegin(), _x.rend())
#define MAX_VAL_OF(_x) std::numeric_limits<decltype(_x)>::max()
#define eb(_x)	emplace_back(_x)

#define rep(_i,_b,_e) for(auto _i = _b; _i < _e; ++_i)
#define fa(_i,_v) for(auto&_i:_v) 

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace {
	const ll MOD7 = 1000000007LL, MOD9 = 1000000007LL;
	enum class START_OPTION { NOTHING = 0, FILE_INPUT = 1, FILE_OUTPUT = (1 << 1), FILE_OUTHERE = (1 << 2) };
	inline START_OPTION operator| (START_OPTION a, START_OPTION b)
	{
		return static_cast<START_OPTION>(static_cast<int>(a) | static_cast<int>(b));
	}
	inline int operator& (START_OPTION a, START_OPTION b)
	{
		return static_cast<int>(a)& static_cast<int>(b);
	}
	template<typename T1, typename T2> istream& operator>> (istream& i, pair<T1, T2>& p)
	{
		return i >> p.first >> p.second;
	}
	template<typename T1, typename T2> ostream& operator<< (ostream& i, pair<T1, T2>& p)
	{
		return i << p.first << " " << p.second;
	}
	template<typename T>istream& operator>> (istream& i, vector<T>& v)
	{
		for (auto& e : v)i >> e;
		return i;
	}
	template<typename T>ostream& operator<< (ostream& i, vector<T>& v)
	{
		for (size_t ii = 0; ii < v.size(); ii++) {
			i << v[ii];
			if (ii + 1 != v.size())
				i << ' ';
		}
		return i/* << endl*/;
	}
	void _start(START_OPTION opt = START_OPTION::NOTHING, string fileIn = "input.txt", string fileOut = "output.txt")
	{
#ifdef LOCAL_FREOPEN
		if (opt & START_OPTION::FILE_INPUT)  freopen(fileIn.c_str(), "r", stdin);
		if (opt & START_OPTION::FILE_OUTPUT) freopen(fileOut.c_str(), "w", stdout);
#endif
		if ((opt & START_OPTION::FILE_OUTHERE) && (opt & START_OPTION::FILE_INPUT))  freopen(fileIn.c_str(), "r", stdin);
		if ((opt & START_OPTION::FILE_OUTHERE) && (opt & START_OPTION::FILE_OUTPUT)) freopen(fileOut.c_str(), "w", stdout);
		cin.sync_with_stdio(false);
		cout.sync_with_stdio(false);
		cin.tie(0);
	}
	template<typename T = string> void _end(T out = "", int returnValue = 0)
	{
		cin.sync_with_stdio(0);
		cout.sync_with_stdio(0);
		cout << out;
#ifdef LOCAL_FREOPEN
		cerr << endl << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC * 1000 << " ms." << endl;
#endif
		exit(returnValue);
	}
} 
#pragma endregion custom templates

int total = 0;

bool check(vector<string>& v) {
	int n = v.size();
	fi(n)fj(n)
	{
		if (toupper(v[i][j]) == 'X' && j < n - 1 && j > 0 && toupper(v[i][j - 1]) == 'X' && toupper(v[i][j + 1]) == 'X')
			return false;
		if (toupper(v[i][j]) == 'O' && j < n - 1 && j > 0 && toupper(v[i][j - 1]) == 'O' && toupper(v[i][j + 1]) == 'O')
			return false;
	}
	fj(n)fi(n)
	{
		if (toupper(v[i][j]) == 'X' && i < n - 1 && i > 0 && toupper(v[i - 1][j]) == 'X' && toupper(v[i + 1][j]) == 'X')
			return false;
		if (toupper(v[i][j]) == 'O' && i < n - 1 && i > 0 && toupper(v[i - 1][j]) == 'O' && toupper(v[i + 1][j]) == 'O')
			return false;
	}
	return true;
}

void mark(vector<string>& v) {
	int n = v.size();
	fi(n)fj(n)
	{
		if (toupper(v[i][j]) == 'X' && j < n - 1 && j > 0 && toupper(v[i][j - 1]) == 'X' && toupper(v[i][j + 1]) == 'X')
			v[i][j] = v[i][j - 1] = v[i][j + 1] = 'x';
		if (toupper(v[i][j]) == 'O' && j < n - 1 && j > 0 && toupper(v[i][j - 1]) == 'O' && toupper(v[i][j + 1]) == 'O')
			v[i][j] = v[i][j - 1] = v[i][j + 1] = 'o';
	}
	fj(n)fi(n)
	{
		if (toupper(v[i][j]) == 'X' && i < n - 1 && i > 0 && toupper(v[i - 1][j]) == 'X' && toupper(v[i + 1][j]) == 'X')
			v[i][j] = v[i - 1][j] = v[i + 1][j] = 'x';
		if (toupper(v[i][j]) == 'O' && i < n - 1 && i > 0 && toupper(v[i - 1][j]) == 'O' && toupper(v[i + 1][j]) == 'O')
			v[i][j] = v[i - 1][j] = v[i + 1][j] = 'o';

	}
}


int calc_swap(vector<string>& v, int startX, int startO) {
	int n = v.size();
	int k = startX;
	int cnt = 0;
	for (int i = 0; i < int(n); i++)
	{
		for (int j = k; j < int(n); j += 3) {
			if (v[i][j] == 'x') {
				cnt++;
			}
		}
		k--;
		if (k == -1) k = 2;
	}

	k = startO;
	cnt = 0;
	for (int i = 0; i < int(n); i++)
	{
		for (int j = k; j < int(n); j += 3) {
			if (v[i][j] == 'o') {
				cnt++;
			}
		}
		k--;
		if (k == -1) k = 2;
	}
	return cnt;
}


bool check_swap(vector<string>& v, int startX, int startO) {
	int cnt = calc_swap(v, startX, startO);
	if (cnt > total / 3)return false;
	auto prev = v;
	int n = v.size();
	for (int i = 0; i < int(n); i++)
	{
		for (int j = startX; j < int(n); j += 3) {
			if (v[i][j] == 'x') {
				v[i][j] = 'O';
			}
		}
		startX--;
		if (startX == -1) startX = 2;
	}
	for (int i = 0; i < int(n); i++)
	{
		for (int j = startO; j < int(n); j += 3) {
			if (v[i][j] == 'o') {
				v[i][j] = 'X';
			}
		}
		startO--;
		if (startO == -1) startO = 2;
	}
	if (!check(v))
	{
		v = prev;
		return false;
	}
	v = prev;
	return true;
}

void do_swap(vector<string>& v, int startX, int startO) {
	int n = v.size();
	for (int i = 0; i < int(n); i++)
	{
		for (int j = startX; j < int(n); j += 3) {
			if (v[i][j] == 'x') {
				v[i][j] = 'O';
			}
		}
		startX--;
		if (startX == -1) startX = 2;
	}
	for (int i = 0; i < int(n); i++)
	{
		for (int j = startO; j < int(n); j += 3) {
			if (v[i][j] == 'o') {
				v[i][j] = 'X';
			}
		}
		startO--;
		if (startO == -1) startO = 2;
	}
}

vector<vector<int>> tree(25);
vector<int> ans;

void dfs_calc(int cur_vec, vector<vector<int>>& vecs, vector<int> &ans) {
	if (cur_vec >= vecs.size())
		return;
	dfs_calc(cur_vec + 1, vecs, ans);
	for(int i = vecs[cur_vec].size()-1; i >= 0; i--){
		ans.push_back(vecs[cur_vec][i]);
		int pop = vecs[cur_vec][i];
		//vecs[cur_vec].pop_back();
		dfs_calc(cur_vec + 1, vecs, ans);
		//vecs[cur_vec].push_back(pop);
	}
	reverse(vecs[cur_vec].begin(), vecs[cur_vec].end());

}

vector<int> dfs(int v) {
	vector<int> vec;
	if(v != 1)
		vec.push_back(v);
	if (tree[v].size() > 1) {
		vector < vector<int> > vecs;
		for (int i : tree[v])
		{
			vecs.push_back(dfs(i));
		}
		f1(vecs)
			reverse(i1.begin(), i1.end());
		dfs_calc(0, vecs, vec);
	}
	else if (tree[v].size()){
		vector<int> nex_vec = dfs(tree[v][0]);
		f1(nex_vec) {
			vec.push_back(i1);
		}
	}
	return vec;
}


int main()
{
	_start(START_OPTION::FILE_INPUT
		/*| START_OPTION::FILE_OUTPUT
		| START_OPTION::FILE_OUTHERE,
		"input.txt",
		"output.txt"*/);
	int n; cin >> n;
	fi(n-1) {
		int v; cin >> v;
		tree[v].push_back(i + 2);
	}
	vector<int> vec = dfs(1);
	cout << vec.size() << endl << vec;

	_end();
}