#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forall(it, x) for(auto it = (x).begin(); it != (x).end(); it++)
#define OUT(x) {cout << x; exit(0);}
//#define sz size()
#define ft first
#define sd second
#define pb(x) push_back(x)
#define pb2(x, y) push_back(x, y)
#define mp(x, y) make_pair(x, y)
#define fora0(ITER, LIMIT) for(int ITER = 0; ITER < LIMIT; ITER++)
#define fora1(ITER, LIMIT) for(int ITER = 1; ITER <= LIMIT; ITER++)
#define ford0(ITER, LIMIT) for(int ITER = LIMIT - 1; ITER >= 0; ITER--)
#define ford1(ITER, LIMIT) for(int ITER = LIMIT; ITER >= 1; ITER--)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
#include <iomanip>
#include "assert.h"
#include <stack>
#include <queue>
#include <set>
#include <cstdio>
#include <array>
#include <list>
#include <sstream>
#include <cmath>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace::std;

typedef long long ll;
typedef long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef unsigned int uint;

const int INF = numeric_limits<int>::max();
//const ll INFn = numeric_limits<ll>::min();
//const ll ll_INFn = numeric_limits<ll>::min() / 10;

void problem();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	int tstn = 3;
	while (tstn--) {
#endif
		problem();
#ifdef _DEBUG
		cout << '\n';
	}
#endif
	return 0;
}

int gcd(int a, int b) {
	return b ? gcd(b, a % b) : a;
}

vector<int> p, al;

void fact(int n) {
	for (int i = 2; i * i <= n; i++) {
		if (n % i == 0) {
			p.pb(i);
			al.pb(0);
			while (n % i == 0) {
				al.back()++;
				n /= i;
			}
		}
	}
	if (n != 1) {
		p.pb(n);
		al.pb(0);
	}
}


int n;
vector<vector<int> > inc;

bool ok(int d) {
	vector<int> ass(1e5 + 500, 0);
	vector<int> ans(n, 0);
	ford0(i, n) {
		int now = 0;
		fora0(j, inc[i].size()) {
			now = max(now, ass[inc[i][j]] + 1);
		}
		if (now > d) {
			return false;
		}
		fora0(j, inc[i].size()) {
			ass[inc[i][j]] = now;
		}
		ans[i] = now;
	}
	return true;
	
}

void problem() {
	cin >> n;
	inc.assign(n, vector<int>());
	fora0(i, n) {
		int k;
		cin >> k;
		fora0(j, k) {
			int p;
			cin >> p;
			p--;
			inc[i].pb(p);
		}
	}
	if (n == 0) {
		cout << 0;
		return;
	}
	//r-ok, l-not ok
	int l = 0, r = 1e5 + 500;
	while (l + 1 < r) {
		int mid = (l + r) / 2;
		if (ok(mid)) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	cout << r;
	return;
}
