LINF = 20 ** 18

T = int(input())

def gcd(a, b, x, y):
	if a == 0:
		x = [0]
		y = [1]
		return b
	x1, y1 = [1], [1]
	d = gcd(b % a, a, x1, y1)
	x[0] = y1[0] - (b // a) * x1[0]
	y[0] = x1[0]
	return d

def find_any(a, b, c, x0, y0, g):
	g[0] = gcd(abs(a), abs(b), x0, y0)
	if c % g[0] != 0:
		return False
	x0[0] *= (c // g[0])
	y0[0] *= (c // g[0])
	if a < 0:
		x0[0] *= -1
	if b < 0:
		y0[0] *= -1
	return True

def shift_solution(x, y, a, b, cnt):
	x[0] += cnt * b
	y[0] -= cnt * a

def find_all(a, b, c, minx, maxx, miny, maxy):
	x, y, g = [1], [1], [1]
	if not find_any(a, b, c, x, y, g):
		return 0

	a //= g[0]
	b //= g[0]

	sign_a = a // abs(a)
	sign_b = b // abs(b)

	shift_solution(x, y, a, b, (minx - x[0]) // b)
	if x[0] < minx:
		shift_solution(x, y, a, b, sign_b)
	if x[0] > maxx:
		return 0
	lx1 = x[0]

	shift_solution(x, y, a, b, (maxx - x[0]) // b)
	if x[0] > maxx: 
		shift_solution(x, y, a, b, -sign_b)
	rx1 = x[0]

	shift_solution(x, y, a, b, -1 * (miny - y[0]) // a)
	if y[0] < miny: 
		shift_solution(x, y, a, b, -sign_a)
	if y[0] > maxy: 
		return 0
	lx2 = x[0]

	shift_solution(x, y, a, b, -1 * (maxy - y[0]) // a)
	if y[0] > maxy: 
		shift_solution(x, y, a, b, sign_a)
	rx2 = x[0]

	if lx2 > rx2: 
		lx2, rx2, = rx2, lx2
	lx = max(lx1, lx2)
	rx = min(rx1, rx2)

	return (rx - lx) // abs(b) + 1

for _ in range(T):
	b, d = map(int, input().split())
	b2 = b * b
	print(find_all(d, b, b2, 1, 3 * (10 ** 18), 1, 3 * (10 ** 18)))

