#include <iostream> 
#include <math.h>
#include <vector>
#include <stdio.h>

using namespace std;


#define pb push_back


int cnt;

struct node{
  int x;
  node *left, *right;
  int mx, mn, count;

  node(int key){
    x = key;
    mx = 0;
    mn = 0;
    count = 0;
    left = NULL;
    right = NULL;
  }

  ~node(){
    if (left) delete left;
    if (right) delete right;
  }
};


bool exist(node* root, int val){
  if (NULL == root) return false;
  if (root->x == val) return true;
  if (val < root->x){
    return exist(root->left, val);
  }
  return exist(root->right, val);

}

node* insert(node* root, int val){
  // if (exist(root, val)) return root;
  if (root == NULL) return new node(val);
  root->count++;
  if (val < root->x) root->left = insert(root->left, val);
  if (val > root->x) root->right = insert(root->right, val);
  return root;
}



int findMin(node* root){
  if(root == NULL) return 0;
  if(root->left == NULL) return root->x;
  return findMin(root->left);
}


int findMax(node* root){
  if(root == NULL)
    return 0;
  if(root->right == NULL) {
    return root->x;
  }
  else {
    return findMax(root->right);
  }
}


void print(node *root){
  if (root == NULL) return;
  root->mn = findMin(root);
  root->mx = findMax(root);
  // cout << "MX = " << root->mx << " MN = " << root->mn << endl;
  print(root->left);
  print(root->right);
}


int depth(node* root){
  if (root == NULL) return 0;
  return max(depth(root->right), depth(root->left)) + 1;
}

void check(node *root){
  if (root == NULL) return;
  cout << root->count << endl;
  check(root->left);
  check(root->right);
}

void checkMNMX(node *root){
  if (root == NULL) return;
  cout << root->x << " " << root->mx << " " << root->mn << endl;
  // cout << "WAOJD" << endl;
  checkMNMX(root->left);
  checkMNMX(root->right);
}

int lookup(node *v, int L, int R){
  cnt++;
  if (v == NULL) return 0;
  // cout << "AAA " << v->x << endl;
  if (L <= v->mn && v->mx <= R) return v->count;
  if (v->mx < L || R < v->mn) return 0;
  int res = 0;
  if (L <= v->x && v->x <= R) res++;
  res += lookup(v->left, L, R);
  res += lookup(v->right, L, R);
  return res;
}


int main(){
  // freopen("input.in", "r", stdin);
  int n, N;
  cin >> n;
  N = n;
  int l, r, x;
  // cin >> l >> r >> x;
  scanf("%d%d%d", &l, &r, &x);
  node derevo(x);
  n--;
  // vector<pair<int,int>> pew;
  // pew.pb({l,r});
  while(n--){
    scanf("%d%d%d", &l, &r, &x);
    // cin >> l >> r >> x;
    // pew.pb({l,r});
    insert(&derevo, x);
  }
  int q;
  cin >> q;
  print(&derevo);
  while(q--){
    int l, r;
    cin >> l >> r;
    lookup(&derevo, l, r);
    printf("%d\n", cnt);
    // cout << cnt << endl;
    // cout << "CNT = " << cnt << endl;
    cnt = 0;
  }
  // // checkMNMX(&derevo);
  // cout << endl;
  // cout << pew[0].first << " " << pew[0].second << endl;
  // cout << lookup(&derevo, pew[0].first, pew[0].second) << endl;
  // cout << cnt << endl;

}