#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
#include <algorithm>
#include <unordered_set>
#include <cmath>

using namespace std;

int gcd (long long a, long long b) {
    while (a!=0 && b!=0) {
        if (a>b) {
            a=a%b;
        }
        else b=b%a;
    }
    return a+b;
}

void solve() {
    long long n;
    cin >> n;
    for (size_t i = 0; i < n; i++)
    {
        long long b, d;
        cin >> b >> d;
        long long g = gcd(b, d);
        long long m = b / g;
        long long ans = (b * (b - 1) / (double)d) / m;
        cout << ans << endl;
    }  
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}
