#include <bits/stdc++.h>
#include <ext/rope>
#pragma GCC optimize("O3")
using namespace std;
using namespace __gnu_cxx;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
#define at mutable_reference_at
#define dbg(x) cerr<<#x<<": "<<x<<'\n';
mt19937_64 rnd(time(0));
const int maxn = 3e5 + 100;
const int mod = 1e9 + 7;
// const int mod =  998244353;
const int inf = 1e9;
const ld eps = 1e-9;

vector<int> g[30];
int h[30];
int st[30];
vector<int> vs[30];
vector<int> cur[30];
int code[30];

int gr(int n) {
    return n ^ (n >> 1);
}

void dfs(int v, int ch = 0) {
    h[v] = ch;
    vs[ch].push_back(v);
    for (int i : g[v]) 
        dfs(i, ch + 1);
}

vector<int> ops;

void dfs2(int lvl) {
    if (cur[lvl].empty()) {
        code[lvl] = 0;
        return;
    }
    int dc = (code[lvl] == 0) ? 1 : -1;
    code[lvl] += dc;
    for (; code[lvl] < (1 << cur[lvl].size()) && code[lvl] >= 0; code[lvl] += dc) {
        int prev = gr(code[lvl] - dc);

        int bit = __builtin_ctz(prev ^ gr(code[lvl]));
        bool del = (gr(code[lvl]) & (1 << bit)) == 0;

        ops.push_back(cur[lvl][bit]);
        if (del) {
            vector<int> last = cur[lvl + 1];
            cur[lvl + 1].clear();
            set<int> edges;
            for (int to : g[cur[lvl][bit]])
                edges.insert(to);
            for (int to : last) {
                if (edges.count(to) == 0)
                    cur[lvl + 1].push_back(to);
            }

            if (code[lvl + 1] != 0) {
                code[lvl + 1] = ((code[lvl + 1] + 1) >> edges.size()) - 1;
            }
        }
        else {
            if (code[lvl + 1] == 0) {
                for (int to : g[cur[lvl][bit]])
                    cur[lvl + 1].push_back(to);
            }
            else {
                vector<int> last = cur[lvl + 1];
                int cnt = 0;
                cur[lvl + 1].clear();
                for (int to : g[cur[lvl][bit]]) {
                    cur[lvl + 1].push_back(to);
                    cnt++;
                }
                for (int to : last) cur[lvl + 1].push_back(to);
                code[lvl + 1] = ((code[lvl + 1] + 1) << cnt) - 1;
            }
        }
        dfs2(lvl + 1);
    }
    code[lvl] -= dc;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    // freopen("collect.in", "r", stdin);
    // freopen("collect.out", "w", stdout);
#endif

    int n;
    cin>>n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin>>p;
        p--;
        g[p].push_back(i);
    }
    dfs(0);
    cur[1] = vs[1];
    dfs2(1);
    cout << ops.size() << endl;
    for (int i : ops) cout << i + 1 << " ";
}
