fun main(){
    val n = readInt()
    val res = IntRange(1, n).map { readPack(it) }.filter { checkDigits(it) }.minByOrNull { it.price }?:Pack(0, 0,"")
    println(res.id)
}

fun readPack(id: Int): Pack{
    val line = readStrings()
    val price = line[0].toInt()
    val digits = line[1]
    return Pack(id, price, digits)
}

fun checkDigits(pack: Pack): Boolean{
    val data = pack.digits.groupingBy { it }.eachCount()
    return data['0']?:0 >= 1 && data['1']?:0 >= 1 && data['2']?:0 >= 2
}

data class Pack(val id: Int, val price: Int, val digits: String)

/**
 * IO functions
 */
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLong() = readLn().toLong()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun readLongs() = readStrings().map { it.toLong() }
private fun readDoubles() = readStrings().map { it.toDouble() }