#include <bits/stdc++.h>
using namespace std;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());

struct Vertex {
	int left=0, right=0, key=0, mx=-1e9, mn=1e9, ct=0, parent=0;
};

vector<vector<int>> g;
vector<Vertex> v;
vector<int> dp;
vector<pair<int, int>> vl, vr;
int idx=1, mnL=1e9, mxR=-1e9;

void dfs(int i) {
	if (v[i].left==0&&v[i].right==0) {
		v[i].ct=1;
		v[i].mn=v[i].mx=v[i].key;
		v[i].ct=1;
	}
	if (v[i].left!=0) {
		dfs(v[i].left);
		v[i].ct+=v[v[i].left].ct;
		v[i].mx=max(v[i].mx, v[v[i].left].mx);
		v[i].mn=min(v[i].mn, v[v[i].left].mn);
	}
	if (v[i].right!=0) {
		dfs(v[i].right);
		v[i].ct+=v[v[i].right].ct;
		v[i].mx=max(v[i].mx, v[v[i].right].mx);
		v[i].mn=min(v[i].mn, v[v[i].right].mn);
	}
	v[i].mn=min(v[i].mn, v[i].key);
	v[i].mx=max(v[i].mx, v[i].key);
	if (v[i].mn==mnL) {
		vl.emplace_back(v[i].mx, i);
	}
	if (v[i].mx==mxR) {
		vr.emplace_back(v[i].mn, i);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int i, j, k, m, n, c=1, q, h, x, y, z, ksum=0, mx=20;
	cin>>n;
	g.resize(n+1);
	v.resize(n+1);
	//dp[0]=1;
	for (i=1; i<=n; i++) {
		cin>>x>>y>>z;
		v[x].parent=i;
		v[y].parent=i;
		v[i].left=x;
		v[i].right=y;
		v[i].key=z;
		mnL=min(mnL, z);
		mxR=max(mxR, z);
	}
	dfs(1);
	sort(vl.begin(), vl.end());
	sort(vr.begin(), vr.end());

	cin>>q;
	for (i=0; i<q; i++) {
		cin>>x>>y;
		if (mxR<x||y<mnL) {
			cout<<"1\n";
		}
		else if (x<=mnL&&mxR<=y) {
			cout<<"1\n";
		}
		else {
			auto itL = lower_bound(vl.begin(), vl.end(), make_pair(x, -1));
			int j1 = itL-vl.begin();
			int ct1 = vl.size()-j1;

			auto itR = lower_bound(vr.begin(), vr.end(), make_pair(y, -1));
			int j2 = itR-vr.begin();
			int ct2 = j2;

			cout<<ct1*2+ct2*2-1<<'\n';
		}
	}

	return 0;
}

