class Sol:
    def __init__(self):
        self.count = 0
    
    def lookup(self, v, L, R):
        self.count += 1
        if v == None:
            return 
        if L <= v.min and v.max <= R:
            return 
        if v.max < L or R < v.min:
            return 
        self.lookup(nodes[v.left], L, R)
        self.lookup(nodes[v.right], L, R)
        return 

class Node:
    def __init__(self, left, right, key):
        self.left = left
        self.right = right
        self.key = key
        self.max = None
        self.min = None

def build(root):

    if root.left == 0:
        root.min = root.key
    else:
        build(nodes[root.left])
        root.min = nodes[root.left].min

    if root.right == 0:
        root.max = root.key
    else:
        build(nodes[root.right])
        root.max = nodes[root.right].max



n = abs(int(input()))

nodes = [None]*(2*n+20)
for i in range(1, n+1):    
    l, r, key = [int(x) for x in input().strip().split(" ")]
    nodes[i] = Node(l, r, key)
build(nodes[1])
q = int(input())
s = Sol()
for i in range(q):
    s.count = 0
    l, r = [int(x) for x in input().strip().split(" ")]
    s.lookup(nodes[1], l, r)
    print(s.count)