#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

vector<int> d[2000000+5];

vector<int> a[2000000+5];

int n;

vector<int> get_union(int v, vector<int> src)
{
    vector<int> ans;
    for (int i=0; i<=a[v].size(); i++)
    {
        if (i%2==0) copy(src.begin(), src.end(), back_inserter(ans));
        else copy(src.rbegin(), src.rend(), back_inserter(ans));
        if (i!=a[v].size())
        {
            ans.push_back(a[v][i]);
        }
    }
    return ans;
}

void dfs(int v)
{
    vector<int> cur;
    for (int i=0; i<d[v].size(); i++)
    {
        dfs(d[v][i]);
    }
    if (d[v].size()==0)
    {
        cur.push_back(v);
        a[v]=cur;
        return;
    }
    vector<int> w=a[d[v][0]];
    for (int i=1; i<d[v].size(); i++)
    {
        w=get_union(d[v][i],w);
    }
    cur.push_back(v);
    cur=w;
    cur.insert(cur.begin(), v);
    a[v]=cur;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin>>n;
    for (int i=1; i<n; i++)
    {
        int l;
        cin>>l;
        l--;
        d[l].push_back(i);
    }
    dfs(0);
    a[0].erase(a[0].begin());
    cout<<a[0].size()<<'\n';
    for (auto i:a[0])
    {
        cout<<i+1<<" ";
    }
}
