#include<iostream>
#include<fstream>
#include<vector>
#include<map>
#include<algorithm>
#include<ctime>
#include<random>

using namespace std;

mt19937 rnd(time(NULL));

int n,m;

int a[1000000+5];

vector<int> d[1000000+5];

int l[1000000+5];

int r[1000000+5];

void dfs(int v)
{
    l[v]=a[v];
    r[v]=a[v];
    for (auto i:d[v])
    {
        dfs(i);
        l[v]=min(l[v],l[i]);
        r[v]=max(r[v],r[i]);
    }
}

int L[1000000+5];

int R[1000000+5];

map<int, int> mp, mpc;

int K=0;

vector<int> t[4000000+5];

vector<int> w[1000000+5];

void build(int v, int tl, int tr)
{
    if (tl==tr)
    {
        t[v]=w[tl];
        return;
    }
    int tm=(tl+tr)/2;
    build(v*2,tl,tm);
    build(v*2+1,tm+1,tr);
    t[v].resize(t[v*2].size()+t[v*2+1].size());
    merge(t[v*2].begin(), t[v*2].end(), t[v*2+1].begin(), t[v*2+1].end(), t[v].begin());
}

int get(int v, int tl, int tr, int l, int r, int q)
{
    if (l>r) return 0;
    if (tl==l&&tr==r)
    {
        return t[v].end()-lower_bound(t[v].begin(), t[v].end(), q);
    }
    int tm=(tl+tr)/2;
    return get(v*2,tl,tm,l,min(r,tm),q)+get(v*2+1,tm+1,tr,max(l,tm+1),r,q);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for (int i=0; i<n; i++)
    {
        int l,r;
        cin>>l>>r>>a[i];
        l--;
        r--;
        if (l!=-1) d[i].push_back(l);
        if (r!=-1) d[i].push_back(r);
        mp[a[i]]++;
    }
    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>L[i]>>R[i];
        mp[L[i]]++;
        mp[R[i]]++;
    }
    for (auto i:mp)
    {
        K++;
        mpc[i.first]=K;
    }
    for (int i=0; i<n; i++)
    {
        a[i]=mpc[a[i]];
    }
    for (int i=0; i<m; i++)
    {
        L[i]=mpc[L[i]];
        R[i]=mpc[R[i]];
    }
    dfs(0);
    for (int i=0; i<n; i++)
    {
        w[l[i]].push_back(r[i]);
    }
    for (int i=1; i<=K; i++)
    {
        sort(w[i].begin(), w[i].end());
    }
    build(1,1,K);
    for (int i=0; i<m; i++)
    {
        int ans1=get(1,1,K,1,L[i],L[i]);
        int ans2=get(1,1,K,L[i]+1,R[i],R[i]);
        int ans=ans1+ans2;
        cout<<ans*2+1<<'\n';
    }
}
