#include <bits/stdc++.h>

using namespace std;

#define int long long

struct node {
    int id;
    int w;
    int c1;
    int c2;
};

bool cmp(const node& x, const node& y) {
    return x.id < y.id;
}

std::vector<node> res;

int ind = 1;
int rec(int cnt1, int cnt2) {
    if (cnt1 == 0 && cnt2 == 0) {
        return 0;
    }
    int id = ind++;
    if (cnt2 > 0) {
        cnt2--;
        if (cnt2 % 2 == 0) {
            int res1 = rec(cnt1 / 2, cnt2 / 2);
            int res2 = rec(cnt1 - cnt1 / 2, cnt2 / 2);
            if (res1 == -1 || res2 == -1) {
                return -1;
            }
            res.push_back({id, 2, res1, res2});
        } else {
            if (cnt1 == 0) {
                return -1;
            }
            if (cnt1 % 2 == 1) {
                int res1 = rec(cnt1 / 2 + 1, cnt2 / 2);
                int res2 = rec(cnt1 / 2, cnt2 / 2 + 1);
                if (res1 == -1 || res2 == -1) {
                    return -1;
                }
                res.push_back({id, 2, res1, res2});
            } else {
                int res1 = rec(cnt1 / 2 + 1, cnt2 / 2);
                int res2 = rec(cnt1 / 2 - 1, cnt2 / 2 + 1);
                if (res1 == -1 || res2 == -1) {
                    return -1;
                }
                res.push_back({id, 2, res1, res2});
            }
        }
        cnt2++;
    } else if (cnt1 > 0) {
        cnt1--;
        if (cnt2 % 2 == 0) {
            int res1 = rec(cnt1 / 2, cnt2 / 2);
            int res2 = rec(cnt1 - cnt1 / 2, cnt2 / 2);
            if (res1 == -1 || res2 == -1) {
                return -1;
            }
            res.push_back({id, 1, res1, res2});
        }
        cnt1++;
    }
    return id;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    int a, b;
    cin >> a >> b;
    int rs = rec(a, b);
    if (rs == -1) {
        cout << -1 << "\n";
        return 0;
    }
    sort(res.begin(), res.end(), cmp);
    for (const node& x : res) {
        cout << x.w << " " << x.c1 << " " << x.c2 << "\n";
    }
    return 0;
}