#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <assert.h>
#include <fstream>
#include <tuple>
#include <queue>
#include <unordered_set>
#include <cstdlib>
#include <random>
#include <iomanip>

using namespace std;

#define sqr(a) ((a)*(a))
#define all(a) (a).begin(), (a).end()

const long long MOD = (int) 1e9 + 7;

long long binPow(long long a, long long b) {
    if (b == 0)
        return 1;

    long long ans = binPow(a, b / 2);
    ans = ans * ans % MOD;

    if (b % 2)
        ans = ans * a % MOD;

    return ans;
}

void solve() {
    int n;
    cin >> n;

    long long ans = (long long) 1e18;
    int id = 0;
    for (int i = 0; i < n; ++i) {
        long long cost;
        string a;
        cin >> cost >> a;

        int num[10] = {0};
        for (int j : a) 
            ++num[j - '0'];
    
        if (num[2] >= 2 && num[0] >= 1 && num[1] >= 1) {
            if (ans >cost) {
                ans = min(ans, cost);
                id = i + 1;
            }
        }
    }

    cout << id << "\n";
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("iq.in", "r", stdin);
    // freopen("iq.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(228);

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}