#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second
#define ll long long
//#define int ll
#define ld long double
#define endl '\n'
#define TIME 1.0*clock()/CLOCKS_PER_SEC
#define pii pair<int,int>
#define vi vector<int>
#define _ <<' '<<

#define MP                      make_pair
#define FOR(i, a, b)            for(int i = (a); i < (b); ++i)
#define RFOR(i, a, b)           for(int i = (a) - 1; i >= (b); --i)
#define CLEAR(a, b)             memset(a, b, sizeof(a))
#define SZ(a)                   (a).size()
#define ALL(a)                  (a).begin(), (a).end()
#define RALL(a)                 (a).rbegin(), (a).rend()

using namespace std;

const int M = 1e9 + 7;
const ll INF = 1e18;
const int N = 1e6 + 7;

struct fenwik {
  static const int N = ::N + 10;

  int t[N];

  fenwik(int n){
    for (int i = 0; i < n; ++i) t[i] = 0;
  }

  void upd(int p, int x) {p += 2;
    for (; p < N; p += p & -p) t[p] += x;
  }

  int q(int p) {p += 2;
    int res = 0;
    for (; p; p -= p & -p) res += t[p];
    return res;
  }
}t(N);

int n, l[N], r[N], mn[N], mx[N], k[N], cnt[N];
int V = 0;
vector<pii> add[N];
vector<pii> del[N];
vector<pii> Q[N];

void dfs(int v) {
  cnt[v] = 1;
  mn[v] = mx[v] = k[v];
  int to = l[v];
  if (to) {
    dfs(to);
    cnt[v] += cnt[to];
    mn[v] = min(mn[v], mn[to]);
    mx[v] = max(mx[v], mx[to]);
  }
  to = r[v];
  if (to) {
    dfs(to);
    cnt[v] += cnt[to];
    mn[v] = min(mn[v], mn[to]);
    mx[v] = max(mx[v], mx[to]);
  }

  add[0].pb( {mn[v], mx[v] - 1} );
  del[mn[v]].pb( {mn[v], mx[v] - 1} );
  add[mn[v] + 1].pb( {mn[v], N - 1} );
  del[mx[v]].pb( {mn[v], N - 1} );
}

vector<int> all;

int nm(int x) {
  return lower_bound(all.begin(), all.end(), x) - all.begin();
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif // LOCAL
  cin >> n;
  for (int i = 1; i <= n; ++i) {
    cin >> l[i] >> r[i] >> k[i];
    all.pb(k[i] - 1);
    all.pb(k[i] + 1);
    all.pb(k[i]);
  }
  sort(ALL(all));
  all.resize(unique(all.begin(), all.end()) - all.begin());
  for (int i = 1; i <= n; ++i) {
    k[i] = nm(k[i]);
  }
  dfs(1);
  int q;
  cin >> q;
  for (int i = 0; i < q; ++i) {
    int L, R;
    cin >> L >> R;
    Q[nm(L)].pb( {nm(R), i} );
  }
  vector<int> ans(q);
  for (int i = 0; i < N; ++i) {
    for (auto it : add[i]) {
      t.upd(it.F, 1);
      t.upd(it.S + 1, -1);
    }
    if (i)
      for (auto it : del[i - 1]) {
        t.upd(it.F, -1);
        t.upd(it.S + 1, 1);
      }
    for (auto it : Q[i]) {
      ans[it.S] = t.q(it.F);
    }
  }

  for (auto it : ans) cout << 2 * it + 1 << endl;
  return 0;
}
