#include <iostream>
#include <bitset>

int n;
std::bitset<8> steps[300000];
bool wins[300000];

char desc[9];

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	std::cin >> std::ws;

	for (int i = 0; i < n; i++) {
		std::cin.getline(desc, 9);

		for (int j = 0; j < 8; j++) {
			steps[n - 1 - i][j] = desc[j] == 'W';
		}
	}

	for (int i = 0; i < n; i++) {
		wins[i] = false;
		bool canMove = false;
		for (int j = 1; j <= 8; j++) {
			if (i - j < 0) {
				break;
			}

			if (j <= (8 - (steps[i] ^ steps[i - j]).count())) {
				canMove = true;
				if (!wins[i - j]) {
					wins[i] = true;
					break;
				}
			}
		}

		if (!canMove) {
			wins[i] = true;
		}
	}

	for (int i = n - 1; i >= 0; i--) {
		if (wins[i]) {
			std::cout << '1';
		} else {
			std::cout << '2';
		}
	}
	std::cout << std::endl;

	return 0;
}
