#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/priority_queue.hpp>

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

using namespace std;

template <class T, class M>
using trtr = __gnu_pbds::tree <T, M, less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#define sp ' '
#define en '\n'
#define En '\n'
#define eN '\n'
#define EN '\n'

#define _str(x) #x
#define ww(x) _str(x) << " = " << (x) << sp
#define wn(x) _2d << _str(x) << " = " << en << (x) << en

struct _flag_t { string val; } _1d{", "}, _2d{"\n  "};
_flag_t _flag = _1d;
ostream & operator << (ostream &os, _flag_t flag) { _flag = flag; return os; }

template <class Ch, class Tr, class It>
basic_ostream <Ch, Tr> &
_out (basic_ostream <Ch, Tr> & os, It f, It l) {
    if (f == l) return os << "{}";
    auto cur_flag = _flag;
    os << _1d << "{ " << *f;
    for (; ++f != l; os << cur_flag.val << *f);
    return os << " }";
}

template <class Ch, class Tr, class C>
basic_ostream <Ch, Tr> & operator << (basic_ostream < Ch, Tr > &os, C const &cont)
{ return _out(os, begin(cont), end(cont)); }

template <class X, class Y>
ostream & operator << (ostream &os, pair <X, Y> const &p) { return os << "[" << p.first << ", " << p.second << "]"; }
template <class X, class Y, class Z>
ostream & operator << (ostream &os, tuple <X, Y, Z> const &p)
{ return os << "[" << get<0>(p) << ", " << get<1>(p) << ", " << get<2>(p) << "]"; }

template <class X> X &maxi(X &x, X const &y) { return x < y ? x = y : x; }
template <class X> X &mini(X &x, X const &y) { return x > y ? x = y : x; }
template <class X> bool bmaxi(X &x, X const &y) { return x < y ? (x = y, true) : false; }
template <class X> bool bmini(X &x, X const &y) { return x > y ? (x = y, true) : false; }

#define int ll
#define qq auto
#define qr auto &
#define qrr auto &&
#define qc auto const&
#define sz(x) int( x.size() )
#define mp(x, y) make_pair( x, y )
#define ff first
#define ss second

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pdd = pair <double, double>;
using bit32 = bitset <32>;
using bit64 = bitset <64>;

template <class K, class T, class ...A>
using hash_table = __gnu_pbds::cc_hash_table <K, T, A...>;
//using hash_table = unordered_map<K, T, A...>;
//using hash_table = map<K, T>;

const double PI = acos(-1);
const double PIH = PI * 0.5;
const double PID = PI * 2.0;

template <class T = ll>
vector <vector <T>> mm(size_t n, size_t m = 0, T val = T())
{ return vector <vector <T>>(n, vector <T>(m, val)); }

#define forr(i, n) for(int i = 0; i < (n); i ++)
#define form(i, b, e) for(int i = (b); i >= e ; i --)
#define forn(i, b, n) for(int i = (b); i < (n); i ++)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

#define def(f, ...) qq f = [&] (qc f, __VA_ARGS__)
#define call(f, ...) f(f, __VA_ARGS__)
#define pb push_back


int32_t main()
{
    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    vector <int> k(n+1);
    qq g = mm(n+1);
    vector <pii> ki;
    forn(i, 1, n+1) {
        int x, y; cin >> x >> y >> k[i];
        if(x != 0) g[i].push_back(x);
        if(y != 0) g[i].push_back(y);
        ki.emplace_back(k[i], i);
    }
//    cout << ww(g) << En;
    ki.emplace_back(-2e17, -1);
    ki.emplace_back(+2e17, -2);

    sort(all(ki));

    qq rki = ki;
    reverse(all(rki));

    int l = 1;
    while( (1<<l) <= n ) ++l;

    vector <int> tin(n+1), tout(n+1), le(n+1, 1e9), re(n+1, -1e9), h(n+1);
    int timer{};
    qq up = mm(n+1, l+1);

    def(dfs, int v, int p) -> void {
        if( v == 0 ) return;
        le[v] = re[v] = k[v];
//        cout << ww(v) << ww(k[v]) << en;
        tin[v] = ++timer;
        up[v][0] = p;
        for (int i=1; i<=l; ++i) {
            up[v][i] = up[up[v][i-1]][i-1];
        }
        for(int to : g[v]) {
            if( to == p ) continue;
            h[to] = h[v]+1;
            call(dfs, to, v);
            mini(le[v], le[to]);
            maxi(re[v], re[to]);
        }
        tout[v] = ++timer;
    };

    auto upper = [&](int a, int b) {
        return tin[a] <= tin[b] && tout[a] >= tout[b];
    };

    auto lca = [&](int a, int b) {
        if( upper(a, b) ) return a;
        if( upper(b, a) ) return b;
        form(i, l, 0) {
            if ( !upper( up[a][i], b ) ) {
                a = up[a][i];
            }
        }
        return up[a][0];
    };

    call(dfs, 1, 1);

    auto kek = [&](int x, int L, int R) {
        return le[x] < L || R < re[x];
    };

    auto kekcm = [&](int x, int L, int R) {
        if( kek(x, L, R) ) return x;
        form(i, l, 0) {
            if( !kek( up[x][i], L, R ) ) {
                x = up[x][i];
            }
        }
        return up[x][0];
    };

    auto slv = [&](int L, int R) {
//        cout << ww(L) << ww(R) << en;
        auto fndl = [&](int x) {
            return upper_bound(all(ki), pii{x-1, 1e9})->ss;
        };
        auto fndr = [&](int x) {
            return prev(upper_bound(all(ki), pii{x, 1e9}))->ss;
        };

        if( L <= le[1] && re[1] <= R ) {
            cout << 1;
            return;
        }


        int a = fndl(L);
        int b = fndr(R);

//        cout << ww(a) << ww(b) << en;
//        cout << ww(k[a]) << ww(k[b]) << en;

        if( k[a] > k[b] ) {
//            throw "govno";
//            cout << "kkkkk" << En;

            vector <int> hu{};
            if(a > 0) hu.push_back(a);
            if(b > 0) hu.push_back(b);

//            cout << ww(hu) << en;

            int ans = 1e9;
            for(int x : hu) {
                mini(ans, (h[x]+1)*2);
            }

            cout << ans+1; /// !
            return;
        }

        if( !(L <= k[a] && k[b] <= R) ) {
            vector <int> hu{};
            if(a > 0) hu.push_back(a);
            if(b > 0) hu.push_back(b);

//            cout << ww(hu) << En;

            int ans = 1e9;
            for(int x : hu) {
                mini(ans, (h[x]+1)*2);
            }

            cout << ans+1; /// !
            return;
        }
        qq p = lca(a, b);

//        cout << ww(p) << en;

        if( L <= le[p] && re[p] <= R ) {
//            cout << "pppp" << en;
            cout << (h[p]+1)*2+1;
            return;
        }


        int ka = kekcm(a, L, R);
        int kb = kekcm(b, L, R);

        int na = h[ka] - h[p];
        int nb = h[ka] - h[p];

//        cout << ww(ka) << ww(kb) << en;

        int ans = (h[p]+1)*2 + na*2 + nb*2;
        cout << ans+1;
    };

//    cout << ww(le) << en;
//    cout << ww(re) << en;
//    cout << ww(h) << en;

    int q; cin >> q;
    forr(_, q) {
        int L, R; cin >> L >> R;
        slv(L, R);
        cout << en;
    }

}
/*

7
2 3 4
4 5 2
6 7 6
0 0 1
0 0 3
0 0 5
0 0 7
10
-2 -1
-2 1
1 2

7
2 3 4
4 0 2
5 6 8
0 0 1
0 7 5
0 0 9
0 0 6
7
2 7
0 10
2 8
4 4
3 3
1 2
1 3

*/
