#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int long long
#define endl '\n'
#define ld long double
#define vi vector < int >
#define pii pair < int, int >
#define ff first
#define ss second


const int inf = 1e18;
const ld PI = acos(-1);
const int MAXN = 1e6;

template < typename T1, typename T2 >
ostream &operator<<(ostream &out, pair < T1, T2 > a) {
    out << "{" << a.ff << ", " << a.ss << "}";
}

template < typename T1, typename T2 >
istream &operator>>(istream &in, pair < T1, T2 > a) {
    in >> a.ff >> a.ss;
}

template < typename T >
ostream &operator<<(ostream &out, vector < T > a) {
    for (auto it = a.begin(); it != a.end(); it++) {
        out << (*it);
        out << ", \n";
    }
}

struct event {
    int id;
    char type;

    event(int id, char t) : id(id), type(t) {}

};

vector < vector < int > > g;
vector < char > usd;
vector < vector < event > > res;

int dfs(int cur) {
    usd[cur] = 1;
    int r = 1;
    vector < event > ans{{cur, 'v'}};
    vector < event > tmp;
    for (int q:g[cur]) {
        if (usd[q])continue;
        int add = dfs(q);
        r *= (add + 1);
        int f = 0;
        for (int w = 0; w < ans.size(); w++) {
            tmp.push_back(ans[w]);
            tmp.push_back(event(q, f));
//            ans.insert(ans.begin() + w + 1, event(q, f));
            f = 1 - f;
//            w++;
        }
        ans = tmp;
        tmp.clear();
    }
    res[cur] = ans;
    return r;
}

void print(int cur, char r = 0) {
    if (r == 0) {
        for (int q = 0; q < res[cur].size(); q++) {
            if (res[cur][q].type == 'v') {
                if (res[cur][q].id != 0)cout << res[cur][q].id + 1 << " ";
            } else {
                print(res[cur][q].id, res[cur][q].type);
            }
        }
    } else {
        for (int q = res[cur].size() - 1; q >= 0; q--) {
            if (res[cur][q].type == 'v')cout << res[cur][q].id + 1 << " ";
            else {
                print(res[cur][q].id, 1 - res[cur][q].type);
            }
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    ifstream cin("snails.in");
//    ofstream cout("snails.out");
    int n;
    cin >> n;
    g.resize(n);
    res.resize(n + 1);
    usd.resize(n, 0);
    for (int q = 0; q < n - 1; q++) {
        int x;
        cin >> x;
        g[q + 1].push_back(x - 1);
        g[x - 1].push_back(q + 1);
    }
    cout << dfs(0) - 1 << endl;
    print(0);
}