#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int long long
#define endl '\n'
#define ld long double
#define vi vector < int >
#define pii pair < int, int >
#define ff first
#define ss second


const int inf = 1e18;
const ld PI = acos(-1);
const int MAXN = 1e6;

template < typename T1, typename T2 >
ostream &operator<<(ostream &out, pair < T1, T2 > a) {
    out << "{" << a.ff << ", " << a.ss << "}";
}

template < typename T1, typename T2 >
istream &operator>>(istream &in, pair < T1, T2 > a) {
    in >> a.ff >> a.ss;
}

template < typename T >
ostream &operator<<(ostream &out, vector < T > a) {
    for (auto it = a.begin(); it != a.end(); it++) {
        out << (*it);
        out << ", \n";
    }
}

void dfs(int cur, vector < char > &usd, vector < vector < int > > &g) {
    usd[cur] = 1;
    for (int q:g[cur]) {
        if (!usd[q])dfs(q, usd, g);
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    ifstream cin("snails.in");
//    ofstream cout("snails.out");
    int n;
    cin >> n;
    vector < string > s(n);
    vector < vector < int > > g(n), invg(n);
    for (int q = 0; q < n; q++) {
        cin >> s[q];
    }
    for (int q = 0; q < n; q++) {
        for (int w = q - 1; w >= max(0ll, q - 8); w--) {
            int cnt = 0;
            for (int e = 0; e < 8; e++) {
                if (s[q][e] == s[w][e])cnt++;
            }
            if (cnt >= q - w) {
                g[q].push_back(w);
                invg[w].push_back(q);
            }
        }
    }
    vector < int > ans(n, -1);
    ans[0] = 2;
    vector < char > usd(n, 0);
    dfs(0, usd, invg);
    for (int q = 1; q < n; q++) {
        if (!usd[q]) {
            ans[q] = 0;
            continue;
        }
        int predL = q - 1;
        set < int > pr;
        for (int w = q - 1; w >= q - 10; w--) {
            if (w < 0 || usd[w])pr.insert(-w);
        }
        for (int w:g[q]) {
            pr.erase(-w);
        }
        predL = -*pr.begin();
        if (predL == -1) {
            ans[q] = 1;
            continue;
        }
        ans[q] = ans[predL];
    }
    int last = 2;
    for (int q = 0; q < n; q++) {
        if (ans[q] != 0) {
            cout << ans[q];
            last = ans[q];
        } else cout << last;
    }
}