#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <random>
#include <algorithm>
#include <functional>

typedef long long int int64;
typedef unsigned long long int uint64;

using namespace std;

vector<int> days;
unordered_map<int, int> last_day;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    days.reserve(n);
    vector<int> ids;
    int max_used = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        ids.clear();
        ids.reserve(k);
        int min = 0;
        for (int j = 0; j < k; ++j) {
            int id;
            cin >> id;
            auto it = last_day.find(id);
            if (it != last_day.end()) {
                int val = days[it->second];
                if (val > min)
                    min = val;
                it->second = i;
            } else {
                last_day.emplace(id, i);
            }
        }
        days.push_back(min + 1);
        if (max_used < min + 1)
            max_used = min + 1;
    }

    cout << max_used << endl;

    return 0;
}