﻿#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

struct Ver
{
	int w;
	int onePar;
	int twoPar;
	Ver(int w, int onePar, int twoPar) {
		this->w = w;
		this->onePar = onePar;
		this->twoPar = twoPar;
	}
};

bool Ideal(vector <Ver>& v, int a , int b, int id) {
	int left = 0, right = 0;
	if (b > 0) {
		v.push_back(Ver(2, 0, 0));
		b--;
		if (left - right > 1) {
			right += 2;
			v[id - 1].onePar = v.size();
		}
		else {
			left += 2;
			v[id - 1].twoPar = v.size();
		}
	}
	else if (a > 0) {
		v.push_back(Ver(1, 0, 0));
		a--;
		if (left - right > 0) {
			right += 1;
			v[id - 1].onePar = v.size();
		}
		else {
			left += 1;
			v[id - 1].twoPar = v.size();
		}
	}
	if (b > 0) {
		v.push_back(Ver(2, 0, 0));
		b--;
		if (left - right > 1) {
			right += 2;
			v[id - 1].onePar = v.size();
		}
		else {
			left += 2;
			v[id - 1].twoPar = v.size();
		}
	}
	else if (a > 0) {
		v.push_back(Ver(1, 0, 0));
		a--;
		if (left - right > 0) {
			right += 1;
			v[id - 1].onePar = v.size();
		}
		else {
			left += 1;
			v[id - 1].twoPar = v.size();
		}
	}
	if (a + b <= 1 && a == 0) { return false; }
	if (abs(floor(a / 2.) + floor(b / 2.) - ceil(a / 2.) - ceil(b / 2.)) > 1) {
		Ideal(v, ceil(a / 2.), floor(b / 2.), id+1);
		Ideal(v, floor(a / 2.), ceil(b / 2.), id+2);
	}
	else {
		Ideal(v, floor(a / 2.), floor(b / 2.), id+1);
		Ideal(v, ceil(a / 2.), ceil(b / 2.), id+2);
	}
	return abs(left - right) <= 1;
}

int main() {
	int a,b;
	cin >> a >> b;
	int left = 0, right = 0;
	int idL = 1, idR = 1;
	vector <Ver> v; v.reserve(a + b);
	if (b > 0) {
		b--;
		v.push_back(Ver(2, 0, 0));
	}
	else {
		a--;
		v.push_back(Ver(1, 0, 0));
	}
	
	
	if (Ideal(v, a, b, 1)) {
		for (int i = 0; i < v.size(); i++) {
			cout << v[i].w << " " << v[i].onePar << " " << v[i].twoPar << endl;
		}
	}
	else cout << -1;
}