#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<ll> vll;

#define printvi(arr) for (int x : arr) cout << x << ' '; cout << '\n';
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)

const int maxn = 1e5 + 1;

ll gcd(ll x, ll y) {
    if (x == 0 || y == 0) return x + y;
    if (x < y) swap(x, y);
    return gcd(x % y, y);
}

int main() {
    int n;
    cin >> n;
    forn(i0, n) {
        ll b, d;
        cin >> b >> d;
        ll x = b * b;
        ll g = gcd(b, d);
        if (x % g > 0) {
            cout << "0\n";
            continue;
        }
        b /= g, d /= g, x /= g;
        if (b < d) swap(b, d);
        ll a = 1;
        while (a * d < x && (x - a * d) % b > 0) a++;
        ll c = (x - a * d) / b;
        cout << 1 + (c - 1) / d << '\n';
    }
}
