#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <sstream>
#include <random>
#include <climits>
#include <iomanip>
#include <queue>
#include <bitset>
#include <cctype>
#include <functional>
#include <complex>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <deque>
#include <numeric>
#include <assert.h>
using namespace std;

typedef long long li;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define correct(x,n) (((x) >= 0) && ((x) < n))
#define all(a) (a).begin(),(a).end()
#define rnd() (rand() + (RAND_MAX+1)*rand())

//#define x first
//#define y second

using vi = vector<li>;
using vptvi = vector<vi*>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;
//using Point = pair<li, li>;
//using Point = complex<li>;
using Point = complex<ld>;

li gcd(li a, li b)
{
	return b ? gcd(b, a % b) : a;
}

struct Graph
{
	vvi a;
	li n;
	
	void addEdge(int r)
	{
		int l;
		cin >> l;
		l--;
		a[l].push_back(r);
	}

	Graph()
	{
		cin >> n;
		a.assign(n, vi());
		forn(i, n - 1LL)
			addEdge(i + 1);
	}

	vi dfs(int v)
	{
		vi res;
		forv(to, a[v])
		{
			vi res1 = res;
			vi p = dfs(to);
			forv(val, p)
			{
				reverse(all(res1));
				res.push_back(val);
				forv(el, res1)
					res.push_back(el);
			}
		}
		reverse(all(res));
		res.push_back(v + 1);
		reverse(all(res));

		return res;
	}

	void solve()
	{
		vi res = dfs(0);
		cout << res.size() - 1 << endl;
		forn(i, res.size()-1)
			cout << res[i + 1] << " ";
		cout << endl;
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	Graph g;
	g.solve();
}