#include <bits/stdc++.h>
using namespace std;

vector< vector<int> > g;
vector< vector<int> > ans;

void dfs(int v)
{
	ans[v].push_back(v);
	for (int i = 0; i != g[v].size(); ++i) {
		dfs(g[v][i]);
	}
	vector<int> q(g[v].size());
	vector<bool> incr(g[v].size(), true);
	if (g[v].empty())
		return;
	while (true) {
		int i = 0;
		while (incr[i] && q[i] == ans[g[v][i]].size()
		   || !incr[i] && q[i] == 0) {
			incr[i] = !incr[i];
			++i;
			if (i == g[v].size())
				break;
		}
		if (i == g[v].size())
			break;
		if (incr[i]) {
			ans[v].push_back(ans[g[v][i]][q[i]]);
			++q[i];
		}
		else {
			--q[i];
			ans[v].push_back(ans[g[v][i]][q[i]]);
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	g.resize(n+1);
	for (int i = 2; i <= n; ++i) {
		int p;
		cin >> p;
		g[p].push_back(i);
	}
	ans.resize(n+1);
	dfs(1);
	cout << ans[1].size() - 1 << endl;
	for (int i = 1; i < ans[1].size(); ++i)
		cout << ans[1][i] << " ";
	return 0;
}