#include <bits/stdc++.h>
using namespace std;

vector< vector<int> > g;
vector<int> minn, maxx, cnt, key, lc, rc;

void dfs1(int v)
{
	if (v == 0)
		return;
	cnt[v] = 1;
	minn[v] = key[v];
	maxx[v] = key[v];
	if (lc[v]) {
		dfs1(lc[v]);
		minn[v] = min(minn[lc[v]], key[v]);
		cnt[v] += cnt[lc[v]];
	}
	if (rc[v]) {
		dfs1(rc[v]);
		maxx[v] = max(maxx[rc[v]], key[v]);
		cnt[v] += cnt[rc[v]];
	}
}

int lookup(int v, int l, int r)
{
	int res = 1;
	if (v == 0)
		return res;
	if (l <= minn[v] && maxx[v] <= r)
		return res;
	if (maxx[v] < l || r < minn[v])
		return res;
	res += lookup(lc[v], l, r);
	res += lookup(rc[v], l, r);
	return res;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	g.resize(n+1);
	minn.resize(n+1);
	maxx.resize(n+1);
	cnt.resize(n+1);
	key.resize(n+1);
	lc.resize(n+1);
	rc.resize(n+1);
	for (int i = 1; i <= n; ++i)
		cin >> lc[i] >> rc[i] >> key[i];
	dfs1(1);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << lookup(1, l, r) << endl;
	}
	return 0;
}