import java.util.Scanner;
import java.math.BigInteger;

class Main {

    static BigInteger x, y, d;

    static void extendedEuclid(BigInteger a, BigInteger b) {
        if (b.equals(BigInteger.ZERO)) {
            x = BigInteger.valueOf(1);
            y = BigInteger.valueOf(0);
            d = a;
            return;
        }
        extendedEuclid(b, a.mod(b));
        BigInteger x1 = y;
        BigInteger y1 = x.subtract(a.divide(b).multiply(y));
        x = x1;
        y = y1;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        while (t > 0) {
            --t;
            BigInteger a = BigInteger.valueOf(sc.nextInt());
            BigInteger b = BigInteger.valueOf(sc.nextInt());
            extendedEuclid(b, a);
            x = x.multiply(a.multiply(a).divide(d));
            y = y.multiply(a.multiply(a).divide(d));
            BigInteger left = x.multiply(BigInteger.valueOf(-1)).divide(a.divide(d));
            BigInteger right = y.divide(b.divide(d));
            while (right.compareTo(left) >= 0 && (x.add(a.divide(d).multiply(right)).compareTo(BigInteger.ZERO) <= 0 || y.subtract(b.divide(d).multiply(right)).compareTo(BigInteger.ZERO) <= 0)) right = right.subtract(BigInteger.ONE);
            while (right.compareTo(left) >= 0 && (x.add(a.divide(d).multiply(left)).compareTo(BigInteger.ZERO) <= 0 || y.subtract(b.divide(d).multiply(left)).compareTo(BigInteger.ZERO) <= 0)) left = left.add(BigInteger.ONE);
            System.out.println(right.subtract(left).add(BigInteger.ONE));
        }
        sc.close();
    }
}
