#include <iostream>
#include <iomanip>

#include <vector>
#include <string>

#include <algorithm>
#include <numeric>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n;
    cin >> n;

    int res = 1;
    vector<int> prev;

    for(auto it = 0; it < n; ++it) {
        int n;
        cin >> n;
        vector<int> curr(n);
        bool add = false;
        auto iter = prev.begin();
        for(auto i = 0; i < n; ++i) {
            cin >> curr[i];
            if(!add) {
                iter = lower_bound(iter, prev.end(), curr[i]);
                if(iter != prev.end() && *iter == curr[i]) {
                    add = true;
                }
            }
        }
        if(add) res++;
        prev = move(curr);
    }

    cout << res;

}