#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define mp make_pair
#define pb push_back
#define ins insert
#define Pq priority_queue
#define u_set unordered_set
#define MOD 1000000007
#define MAXN 100001
#define set_val(arr,v) memset(arr, v, sizeof(arr))
#define scan(n) scanf("%d", &n)
#define scanP(x,y) scanf("%d %d", &x, &y)
#define scanPL(x,y) scanf("%lld %lld", &x, &y)
#define FOR(i,from,to) for (int i=from; i<to; i++)
#define B() begin()
#define E() end()
#define F first
#define S second

struct node {
	int left;
	int right;
	int key;
	int count = 0;
	int min = INT_MAX;
	int max = INT_MIN;
};

map<int, node> gr;

int lookup(int u, int L, int R, int &calls) {
	calls++;
	if(u == 0) return 0;
	auto v = gr[u];
	if(L <= v.min && v.max <= R)
		return v.count;
	if(v.max < L || R < v.min)
		return 0;
	
	int res = 0;
	if(L <= v.key && v.key <= R) res++;
	res += lookup(v.left, L, R, calls);
	res += lookup(v.right, L, R, calls);
	return res;
}

void dfs(int v) {
	if(!v) return;
	int left = gr[v].left, right = gr[v].right;
	dfs(left); dfs(right);
	
	gr[v].count = gr[left].count + gr[right].count + 1;
	gr[v].min = min(min(gr[left].min, gr[right].min), gr[v].key);
	gr[v].max = max(max(gr[left].max, gr[right].max), gr[v].key);
}

int main() {
	ios::sync_with_stdio(0);  cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	FOR(i,0,n) {
		cin >> gr[i+1].left >> gr[i+1].right >> gr[i+1].key;
	}
	int q;
	cin >> q;
	vector<pair<int,int>> queries(q);
	for(auto& x : queries) cin >> x.F >> x.S;
	
	dfs(1);
	for(auto p : queries) {
		int calls = 0;
		lookup(1, p.F, p.S, calls);
		cout << calls << endl;
	}
	return 0; 
}