#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define mp make_pair
#define pb push_back
#define ins insert
#define Pq priority_queue
#define u_set unordered_set
#define MOD 1000000007
#define MAXN 100001
#define set_val(arr,v) memset(arr, v, sizeof(arr))
#define scan(n) scanf("%d", &n)
#define scanP(x,y) scanf("%d %d", &x, &y)
#define scanPL(x,y) scanf("%lld %lld", &x, &y)
#define FOR(i,from,to) for (int i=from; i<to; i++)
#define B() begin()
#define E() end()
#define F first
#define S second

struct node {
	int left;
	int right;
	int key;
	int count = 0;
	int min = INT_MAX;
	int max = INT_MIN;
};

unordered_map<int, node> gr;

// (1,1), (1,2), (1,4), (5,9), (5,6), (6,6), (9,9)

// 2 7
// 0 10
// 2 8
void lookup(int u, int L, int R, int &calls) {
	calls++;
	if(u == 0) return;
	auto v = gr[u];
	if(L <= v.min && v.max <= R)
		return;
	if(v.max < L || R < v.min)
		return;
	
	lookup(v.left, L, R, calls);
	lookup(v.right, L, R, calls);
}

void dfs(int v) {
	if(!v) return;
	int left = gr[v].left, right = gr[v].right;
	dfs(left); dfs(right);
	
	gr[v].count = gr[left].count + gr[right].count + 1;
	gr[v].min = min(min(gr[left].min, gr[right].min), gr[v].key);
	gr[v].max = max(max(gr[left].max, gr[right].max), gr[v].key);
}

int main() {
	// ios::sync_with_stdio(0);  cin.tie(0); cout.tie(0);
	int n;
	scanf("%d", &n);
	FOR(i,0,n) {
		scanf("%d %d %d", &gr[i+1].left, &gr[i+1].right, &gr[i+1].key);
		// cin >> gr[i+1].left >> gr[i+1].right >> gr[i+1].key;
	}
	int q;
	scanf("%d", &q);
	vector<pair<int,int>> queries(q);
	for(auto& x : queries) scanf("%d %d", &x.F, &x.S);
	
	dfs(1);
	vector<int> keys;
	// vector<pair<int,int>> all;
	FOR(i,0,n) {
		keys.pb(gr[i+1].key);
		// all.pb(mp(gr[i+1].min, gr[i+1].max));
	}
	// sort(all.B(), all.E());
	sort(keys.B(), keys.E());
	keys.pb(INT_MAX);

	// FOR(i,0,n) {
	// 	cout << all[i].F << " # " << all[i].S << endl;
	// }

	for(auto& p : queries) {
		int calls = 0;
		int L = *lower_bound(keys.B(), keys.E(), p.F), R = *(--upper_bound(keys.B(), keys.E(), p.S));
		// cout << L << " " << R << endl;
		lookup(1, L, R, calls);
		// cout << calls << endl;
		printf("%d\n", calls);
		// int tot = upper_bound(keys.B(), keys.E(), p.S) - lower_bound(keys.B(), keys.E(), p.F);
		// cout << "tot: " << tot << endl;

		// auto left = upper_bound(all.B(), all.E(), mp(p.F-1, INT_MAX));
		// auto right = lower_bound(all.B(), all.E(), mp(INT_MIN, p.S));
		// cout << "left: " <<  (*left).F << " - " << (*left).S << endl;
		// cout << "right: " <<  (*right).F << " - " << (*right).S << endl;
		// cout << calls << " " << right-left << endl;
	}
	return 0; 
}