#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>
//#include <assert.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-12;

vector<vector<int>> g;

vector<int> dfs(int v) {
	vector<vector<int>> res(g[v].size());
	for (int i = 0; i < g[v].size(); ++i) {
		res[i] = dfs(g[v][i]);
	}
	sort(res.begin(), res.end(), [](vector<int>& a, vector<int>& b) {return a.size() > b.size();});
	
	vector<int> ans;
	for (int i = 0; i < g[v].size(); ++i) {
		vector<int> next;
		bool rev = false;
		if (!rev)
			for (int i = 0; i < ans.size(); ++i)
				next.push_back(ans[i]);
		else
			for (int i = ans.size() - 1; i >= 0; --i)
				next.push_back(ans[i]);
		rev ^= 1;
		for (int num : res[i]) {
			next.push_back(num);
			if (!rev)
				for (int i = 0; i < ans.size(); ++i)
					next.push_back(ans[i]);
			else
				for (int i = ans.size() - 1; i >= 0; --i)
					next.push_back(ans[i]);
			rev ^= 1;
		}
		ans = next;
	}
	
	if (v != 0)
		ans.insert(ans.begin(), v);
	return ans;
}

void solve() {
	int n;
	cin >> n;
	
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		g[p - 1].push_back(i);
	}
	
	vector<int> ans = dfs(0);
	
	cout << ans.size() << "\n";
	for (int num : ans)
		cout << num + 1 << " ";
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}