#include<bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
const char *yes = "YES", *no = "NO";

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    T el;
    if(v.size() == 0) {
        while(in >> el) {
            v.push_back(el);
        }
    } else {
        for(auto& x : v) {
            in >> x;
        }
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> v) {
    for(const auto& x : v) out << x << ' ';
    return out;
}

int mod(const int& num, const int& module) {
    return ((num % module) + module) % module;
}

inline void solve() {
    int n; cin >> n; assert(n > 0);
    /*map<int, int> mp;
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        int k; cin >> k;
        vector<int> a(k);
        bool increase = true;
        for(int j = 0; j < k; ++j) {
            cin >> a[j];
            if(!mp[ a[j] ]) {
                increase = false;
            }
        }
        if(increase) {
            for(auto& x : mp) {
                x.second++;
            }
        } else {
            for(const auto& x : a) {
                mp[x]++;
            }
        }
        cout << "Debug: "; for(auto& [k, v] : mp) cout << v << ' '; cout << '\n';
    }
    for(const auto& [k, v] : mp) ans = max(ans, v);
    cout << ans;*/
    
    int digit = n;
    map<int, int> mp;
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        int k; cin >> k;
        vector<int> a(k); cin >> a;
        for(auto& x : a) {
            if(mp.find(x) != mp.end() and mp[x] == digit) {
                digit--;
                ans++;
                break;
            }
        }
        for(auto& x : a) {
            mp[x] = digit;
        }
    }
    cout << ans + 1;
}   

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;// cin >> t;
    while(t--) {
        solve();
        cout << '\n';
    }
}