#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <bitset>

#define ln '\n'
#define ll long long
#define ioio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define X first
#define Y second

const double pi = acos(-1.0);
const double eps = 1e-9;
const int INF  = 1e9;

using namespace std;

void solution (int & x, int & y, int a, int b, int cnt) {
	x += cnt * b;
	y -= cnt * a;   
}
 int func (int a, int b, int & x, int & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	int x1, y1;
	int d = func (b%a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
} 
bool ifexists (int a, int b, int c, int & x1, int & y1, int & g) {
	g = func (abs(a), abs(b), x1, y1);
	if (c % g != 0)
		return false;
	x1 *= c / g;
	y1 *= c / g;
	if (a < 0)   x1 *= -1;
	if (b < 0)   y1 *= -1;
	return true;
}
int solve (int a, int b, int c, int xmin, int xmax, int ymin, int ymax) {
	int x, y, g;
	if (! ifexists (a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;
 
	int sign_a = a>0 ? +1 : -1;
	int sign_b = b>0 ? +1 : -1;
 
	solution (x, y, a, b, (xmin - x) / b);
	if (x < xmin)
		solution (x, y, a, b, sign_b);
	if (x > xmax)
		return 0;
	int lx1 = x;
 
	solution (x, y, a, b, (xmax - x) / b);
	if (x > xmax)
		solution (x, y, a, b, -sign_b);
	int rx1 = x;
 
	solution (x, y, a, b, - (ymin - y) / a);
	if (y < ymin)
		solution (x, y, a, b, -sign_a);
	if (y > ymax)
		return 0;
	int lx2 = x;
 
	solution (x, y, a, b, - (ymax - y) / a);
	if (y > ymax)
		solution (x, y, a, b, sign_a);
	int rx2 = x;
 
	if (lx2 > rx2)
		swap (lx2, rx2);
	int lx = max (lx1, lx2);
	int rx = min (rx1, rx2);
 
	return (rx - lx) / abs(b) + 1;
}

int main()
{
	ioio;
    int n, b, d;
    cin>>n;
    while(cin>>b>>d){
    cout<<solve(b,d,b*b,1,b+d,1,b+d)<<endl;
    }
	
    return 0;
    
}