import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class D {
    static StringTokenizer st;
    static BufferedReader br;
    static PrintWriter pw;

    static String nextToken() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    static double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    static long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        run();
        pw.close();
    }

    private static void run() {
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            String s = nextToken();
            for (int j = 0; j < s.length(); j++) {
                if (s.charAt(j) == 'W') {
                    a[i] += (1 << j);
                }
            }
        }
        boolean[] tr = new boolean[n];
        for (int i = n - 1; i >= 0; i--) {
            boolean ttr = false;
            for (int j = i + 1; j <= Math.min(i + 8, n - 1); j++) {
                int k = 8;
                int aa = a[i] ^ a[j];
                while (aa > 0) {
                    if ((aa & 1) == 1) {
                        k--;
                    }
                    aa = aa >> 1;
                }
                if (k >= j - i && !tr[j]) {
                    ttr = true;
                    break;
                }
            }
            tr[i] = ttr;
            pw.print(tr[i] ? 1 : 2);
        }
    }

}
