#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define  int long long
int a, b;
int cnt;

vector<vector<int>> tree;

int build(int weight){
    if(weight == 0) return 0;
    if(b > 0 && weight >= 2){
        cnt++;
        tree[cnt].push_back(2);
        weight -= 2;
        b--;
    } else if(a > 0){
        cnt++;
        tree[cnt].push_back(1);
        weight -= 1;
        a--;
    } else {
        return -1;
    }
    int cur = cnt;
    int v1;
    if(weight % 2 == 0){
        v1 = build(weight/2);
    } else {
        v1 = build(weight/2 + 1);
    }
    int v2 = build(weight/2);
    if(v1 == -1 || v2 == -1) return -1;
    tree[cur].push_back(v1);
    tree[cur].push_back(v2);
    return cur;
}


signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> a >> b;
    int n = a + b;
    tree.resize(a + b + 1);
    cnt = 0;
    int res = build(a + b*2);
    if(res == -1) {
        cout << -1;
        return 0;
    }
    else {
        for(int i = 1; i <= n; i++){
            cout << tree[i][0] << " " << tree[i][1] << " " << tree[i][2] << '\n';
        }
    }

}