//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,tune=native")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((long long)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll mod) {
    return (ull)rng() % mod;
}

const int maxn = 3e5 + 555;

int n;
string s, t, st, w[maxn];
int c[256];
char used_c[11];
int id[11];
map<string, vector<int>> cnt;
vector<pair<string, int>> w_res[maxn];
int ans[maxn];

void check() {
    ll x = 0;
    for (int i = 0; i < sz(s); ++i) {
        x *= 10;
        x += c[(int)s[i]];
    }
    // assert(c[(int)s[0]] > 0);
    ll y = 0;
    for (int i = 0; i < sz(t); ++i) {
        y *= 10;
        y += c[(int)t[i]];
    }
    ll z = x + y;
    string u = "";
    while (z) {
        int j = z % 10;
        if (used_c[j]) {
            u += used_c[j];
        } else {
            u += char('0' + j);
        }
        z /= 10;
    }
    reverse(all(u));
    memset(id, -1, sizeof id);
    int id_ptr = 0;
    for (int i = 0; i < sz(u); ++i) {
        if ('A' <= u[i] && u[i] <= 'Z') {
            continue;
        }
        int j = (u[i] - '0');
        if (id[j] == -1) {
            id[j] = id_ptr++;
        }
        u[i] = char('0' + id[j]);
    }

    // if (u == "MONE0") {
    //     cout << u << endl;
    // }
    if (!cnt.count(u)) {
        return;
    }

    vector<int> cvec = cnt[u];
    vector<int> tvec;
    for (int i : cvec) {
        // if (i == 2) {
        //     cout << x << " " << y << " " << x + y << " " << u << endl;
        // }
        // if (w[j] == "HONEY") {
        //     cout << x << " " << y << " " << x + y << " " << u << endl;
        // }
        ++ans[i];
        if (ans[i] < 2) {
            tvec.push_back(i);
        }
    }
    cnt[u] = tvec;
}

void go(int i) {
    int from = 0;
    if (i == 0 || i == sz(s)) {
        from = 1;
    }
    if (i == sz(st)) {
        check();
        return;
    }
    if (c[(int)st[i]] != -1) {
        if (c[(int)st[i]] >= from) {
            go(i + 1);
        }
        return;
    }
    for (int j = from; j <= 9; ++j) {
        if (used_c[j])
            continue;
        c[(int)st[i]] = j;
        used_c[j] = st[i];
        go(i + 1);
        c[(int)st[i]] = -1;
        used_c[j] = 0;
    }

}

void solve() {
    cin >> s;
    cin >> t;
    st = s + t;
    vector<char> in_st(256, 0);
    for (char c : st) {
        in_st[c] = 1;
    }
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        vector<int> char_id(256, -1);
        vector<int> ids;
        int char_id_ptr = 0;
        for (int j = 0; j < sz(w[i]); ++j) {
            if (char_id[(int)w[i][j]] == -1) {
                char_id[(int)w[i][j]] = char_id_ptr++;
            }
            ids.push_back(char_id[w[i][j]]);
        }
        if (char_id_ptr > 10) {
            continue;
        }
        int id1_ptr = 0;

        string res = w[i];
        vector<int> id1(char_id_ptr, -1);
        id1_ptr = 0;
        for (int j = 0; j < sz(ids); ++j) {
            if (!in_st[w[i][j]]) {
                if (id1[ids[j]] == -1) {
                    id1[ids[j]] = id1_ptr++;
                }
                res[j] = char('0' + id1[ids[j]]);
            }
        }
        // cout << i << " " << res << endl;
        auto& vec = cnt[res];
        w_res[i].push_back({res, sz(vec)});
        vec.push_back(i);
    }
    memset(c, -1, sizeof c);
    memset(used_c, 0, sizeof used_c);
    memset(ans, 0, sizeof ans);
    go(0);

    vector<string> rans;
    for (int i = 0; i < n; ++i) {
        // cout << i << " " << ans[i] << endl;
        if (ans[i] == 1) {
            rans.push_back(w[i]);
        }
    }
    cout << sz(rans) << '\n';
    for (string w : rans) {
        cout << w << "\n";
    }
}

signed main() {
#ifdef LOCAL
    // assert(freopen("input.txt", "r", stdin));
    assert(freopen("ex/brainteaser2.in", "r", stdin));
    // assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

    int T = 1;
    // cin >> T;
    for (int numt = 0; numt < T; ++numt) {
        solve();
    }

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


