//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,tune=native")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((long long)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll mod) {
    return (ull)rng() % mod;
}

const int maxn = 22;

vector<int> d[maxn];
vector<int> dp[maxn][maxn];
vector<int> g[maxn];
int n;

void go(int v, int i) {
    dp[v][i] = {};
    if (i == 0) {
        dp[v][i] = {v};
    }
    if (i == sz(g[v])) {
        return;
    }
    go(v, i + 1);
    int to = g[v][i];
    auto tovec = d[to];
    tovec.push_back(-1);
    bool rev = false;
    for (int x : tovec) {
        if (!rev) {
            for (int j = 0; j < sz(dp[v][i + 1]); ++j) {
                dp[v][i].push_back(dp[v][i + 1][j]);
            }
        } else {
            for (int j = sz(dp[v][i + 1]) - 1; j >= 0; --j) {
                dp[v][i].push_back(dp[v][i + 1][j]);
            }
        }
        rev = !rev;
        dp[v][i].push_back(x);
    }
    dp[v][i].pop_back();
}

void dfs(int v) {
    for (int to : g[v]) {
        dfs(to);
    }
    go(v, 0);
    d[v] = dp[v][0];
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int pr;
        cin >> pr;
        --pr;
        g[pr].push_back(i);
    }
    dfs(0);
    d[0].erase(d[0].begin());
    cout << sz(d[0]) << "\n";
    for (int x : d[0]) {
        cout << x + 1 << " ";
    }
    cout << "\n";

}

signed main() {
#ifdef LOCAL
    assert(freopen("input.txt", "r", stdin));
    // assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

    int T = 1;
    // cin >> T;
    for (int numt = 0; numt < T; ++numt) {
        solve();
    }

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


