/*
* C++11 code template for contests.
* @author: Andrei Kalendarov
* @e-mail: andreykalendarov@gmail.com
*/

//#define ANDREIKKAA_ALLOCATOR
const int _ML = 450;

const char _inpf[] =
#if defined(ANDREIKKAA)
        "input.txt"
#else
""
#endif
;
const char _outf[] =
#if defined(ANDREIKKAA)
        ""
#else
""
#endif
;

#if defined(ANDREIKKAA)
#undef NDEBUG
#else
#pragma GCC optimize("O3,no-stack-protector")
#endif
#include "bits/stdc++.h"
#if !defined(ANDREIKKAA)
#define endl '\n'
#endif
#define x first
#define y second
using namespace std;
#define rand abcdefghijklmnopqrstuvwxyz
#define random_shuffle abcdefghijklmnopqrstuvwxyz
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
using ll = long long;
using ld = long double;
const ld PI = 3.14159265358979323846;
mt19937 rd(228);
#if defined(ANDREIKKAA_ALLOCATOR)
char _mem[_ML * 1024 * 1024];
size_t _ptr = 0;
inline void* operator new (size_t _x) { _ptr += _x; if(_ptr >= _ML * 1024 * 1024) {_ptr = 12345;} return _mem + _ptr - _x; }
inline void operator delete (void*) { }
#endif
template<class T, class U> inline ostream &operator<< (ostream &, const pair<T, U> &);
template<class T, class U> inline istream &operator>> (istream &, pair<T, U> &);
template<class T> inline ostream &operator<< (ostream &, const vector<T> &);
template<class T> inline istream &operator>> (istream &, vector<T> &);
template<class T> inline ostream &operator<< (ostream &, const set<T> &);
template<class T> inline ostream &operator<< (ostream &, const multiset<T> &);
template<class T> inline ostream &operator<< (ostream &, const unordered_set<T> &);
template<class T> inline ostream &operator<< (ostream &, const unordered_multiset<T> &);
template<class T, class U> inline ostream &operator<< (ostream &, const map<T, U> &);
template<class T, class U> inline ostream &operator<< (ostream &, const unordered_map<T, U> &);

/* ________ CODE ________ */

int udig[10];
int uchr[26];

vector<int> vars(const string &a, int pos) {
    if(pos >= sz(a)) {
        return{0};
    }

    if(uchr[a[pos] - 'A'] != -1) {
        assert(udig[uchr[a[pos] - 'A']]);
        if(pos + 1 == sz(a) && uchr[a[pos] - 'A'] == 0) {
            return{};
        }
        return{uchr[a[pos] - 'A']};
    }

    vector<int> vars;

    for(int i = (pos + 1 == sz(a)); i < 10; ++i) {
        if(udig[i] == 0) {
            vars.push_back(i);
        }
    }

    return vars;
}

bool tryset(char ch, int dig) {
    if(uchr[ch - 'A'] == -1 || uchr[ch - 'A'] == dig) {
        uchr[ch - 'A'] = dig;
        ++udig[dig];
        return true;
    } else {
        return false;
    }
}

void deset(char ch) {
    assert(uchr[ch - 'A'] != -1);
    --udig[uchr[ch - 'A']];
    uchr[ch - 'A'] = -1;
}


int rec(const string &a, const string &b, const string &c, int pos, int to, int car) {
    if(pos == to) {
        /*if(car == 0) {
            for(char ch : a) {
                cout << uchr[ch];
            }
            cout << endl;
            for(char ch : b) {
                cout << uchr[ch];
            }
            cout << endl;
            for(char ch : c) {
                cout << uchr[ch];
            }
            cout << endl;
            cout << endl;

            //cout << a << " " << b << " " << c << endl;
        }*/
        return car == 0;
    }

    int ans = 0;

    for(int i : vars(a, pos)) {
        if(pos < sz(a)) {
            ++udig[i];
            uchr[a[pos] - 'A'] = i;
        }

        for(int j : vars(b, pos)) {
            if(pos < sz(b)) {
                ++udig[j];
                uchr[b[pos] - 'A'] = j;
            }

            int kk = (i + j + car) % 10;
            assert(pos < sz(c));

            if(uchr[c[pos] - 'A'] == kk || (uchr[c[pos] - 'A'] == -1 && udig[kk] == 0)) {
                ++udig[kk];
                uchr[c[pos] - 'A'] = kk;

                const int now = i + j + car;
                assert(now % 10 == kk);
                ans += rec(a, b, c, pos + 1, to, now / 10);
                if(ans > 1) {
                    return ans;
                }

                --udig[kk];
                if(udig[kk] == 0) {
                    uchr[c[pos] - 'A'] = -1;
                }
            }

            if(pos < sz(b)) {
                --udig[j];
                if(udig[j] == 0) {
                    uchr[b[pos] - 'A'] = -1;
                }
            }
        }

        if(pos < sz(a)) {
            --udig[i];
            if(udig[i] == 0) {
                uchr[a[pos] - 'A'] = -1;
            }
        }
    }

    return ans;
}

map<string, int> zalupki;

int f(const string &a, const string &b, const string &c) {
    if(sz(c) < max(sz(a), sz(b)) || max(sz(a), sz(b)) + 1 < sz(c)) {
        return 0;
    }

    int fnd = -1;
    for(int i = sz(b); i + 1 < sz(a); ++i) {
        if(a[i] != a[i + 1]) {
            fnd = i + 2;
            break;
        }
    }

    if(fnd != -1) {
        if(sz(a) != sz(c)) {
            return 0;
        }

        if(!equal(a.begin() + fnd, a.end(), c.begin() + fnd)) {
            return 0;
        }
    }

    vector<bool> used(26);
    int cc = 0;
    for(char ch : a) {
        if(!used[ch - 'A']) {
            ++cc;
        }
        used[ch - 'A'] = true;
    }
    for(char ch : b) {
        if(!used[ch - 'A']) {
            ++cc;
        }
        used[ch - 'A'] = true;
    }
    for(char ch : c) {
        if(!used[ch - 'A']) {
            ++cc;
        }
        used[ch - 'A'] = true;
    }

    if(cc > 10) {
        return false;
    }

    memset(uchr, -1, sizeof uchr);
    memset(udig, 0, sizeof udig);
    //cout << rec(a, b, c, 0, max({sz(a), sz(b), sz(c)}), 0) << endl;
    //return false;

    if(sz(c) > max(sz(a), sz(b))) {
        if(!tryset(c.back(), 1)) {
            return 0;
        }
    }

    if(a[0] == c[0]) {
        if(!tryset(b[0], 0)) {
            return 0;
        }
    }

    if(b[0] == c[0]) {
        if(!tryset(a[0], 0)) {
            return 0;
        }
    }

    vector<char> cand;
    for(int i = 0; i < sz(b); ++i) {
        if(a[i] == c[i]) {
            cand.push_back(b[i]);
        } else if(b[i] == c[i]) {
            cand.push_back(a[i]);
        }
    }

    sort(all(cand));
    cand.erase(unique(all(cand)), cand.end());

    if(sz(cand) >= 3) {
        return 0;
    }

    if(sz(cand) == 2) {
        int ans = 0;

        if(tryset(cand[0], 0)) {
            if(tryset(cand[1], 9)) {
                ans += rec(a, b, c, 0, max({sz(a), sz(b), sz(c)}), 0);

                deset(cand[1]);
            }
            deset(cand[0]);
        }

        if(ans > 1) {
            return ans;
        }

        if(tryset(cand[0], 9)) {
            if(tryset(cand[1], 0)) {
                ans += rec(a, b, c, 0, max({sz(a), sz(b), sz(c)}), 0);

                deset(cand[1]);
            }
            deset(cand[0]);
        }

        return ans;
    }

    if(sz(cand) == 1) {
        int ans = 0;
        if(tryset(cand[0], 0)) {
            ans += rec(a, b, c, 0, max({sz(a), sz(b), sz(c)}), 0);
            deset(cand[0]);
        }
        if(ans > 1) {
            return ans;
        }
        if(tryset(cand[0], 9)) {
            ans += rec(a, b, c, 0, max({sz(a), sz(b), sz(c)}), 0);
            deset(cand[0]);
        }
        return ans;
    }

    return rec(a, b, c, 0, max({sz(a), sz(b), sz(c)}), 0);
}

string canon(const string &s, const string &a, const string &b) {
    string ans;

    array<char, 26> old_new, new_old;
    old_new.fill(-1);
    new_old.fill(-1);

    for(char c : a) {
        old_new[c - 'A'] = c;
        new_old[c - 'A'] = c;
    }
    for(char c : b) {
        old_new[c - 'A'] = c;
        new_old[c - 'A'] = c;
    }

    for(char c : s) {
        if(old_new[c - 'A'] == -1) {
            for(int i = 0; i < 26; ++i) {
                if(new_old[i] == -1) {
                    new_old[i] = c;
                    old_new[c - 'A'] = 'A' + i;
                    goto ok;
                }
            }
            return "";
            ok:;
        }
        ans += old_new[c - 'A'];
    }
    return ans;
}


inline void _main_function() {
    /*string a = "DUB";
    string b = "UPSPEAK";
    string c = "UPBUILD";
    reverse(all(a));
    reverse(all(b));
    reverse(all(c));
    cout << f(a, b, c) << endl;
    return;*/

    string s, t;
    cin >> s >> t;

    reverse(all(s));
    reverse(all(t));

    if(sz(s) < sz(t)) {
        swap(s, t);
    }

    /*string uni = s + t;
    sort(all(uni));
    uni.erase(unique(all(uni)), uni.end());

    if()*/

    int n;
    cin >> n;

    vector<string> ans;
    int cc = 0;
    for(int i = 0; i < n; ++i) {
        if(i % 1000 == 0) {
            //cout << i << endl;
        }
        string u;
        cin >> u;
        reverse(all(u));

        auto can = canon(u, s, t);

        auto it = zalupki.find(can);

        if(it != zalupki.end()) {
            ++cc;
            if(it->y) {
                reverse(all(u));
                ans.push_back(u);
            }
        } else {
            if(f(s, t, u) == 1) {
                reverse(all(u));
                ans.push_back(u);
                zalupki[can] = true;
            } else {
                zalupki[can] = false;
            }
        }
    }

    cout << sz(ans) << endl;
    for(const auto &i : ans) {
        cout << i << endl;
    }
    //cout << "! " << cc << endl;
}

///////

int main() {
#if defined(ANDREIKKAA)
    time_t _start = clock();
#endif
    if (_inpf[0] != '\0') assert(freopen(_inpf, "r", stdin) != nullptr);
    if (_outf[0] != '\0') assert(freopen(_outf, "w", stdout) != nullptr);
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    cout << setprecision(20);
    //cout << fixed;

    _main_function();
#if defined(ANDREIKKAA)
    cout << "Time: " << (clock() - _start) / (ld)CLOCKS_PER_SEC << endl;
#endif
}

template<class T, class U> inline ostream &operator<< (ostream &_out, const pair<T, U> &_p) {
    _out << _p.x << ' ' << _p.y;
    return _out;
}
template<class T, class U> inline istream &operator>> (istream &_in, pair<T, U> &_p) {
    _in >> _p.x >> _p.y;
    return _in;
}
template<class T> inline ostream &operator<< (ostream &_out, const vector<T> &_v) {
    if (_v.empty()) { return _out; }
    _out << *_v.begin();
    for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline istream &operator>> (istream &_in, vector<T> &_v) {
    for (auto &_i : _v) { _in >> _i; }
    return _in;
}
template<class T> inline ostream &operator<< (ostream &_out, const set<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline ostream &operator<< (ostream &_out, const multiset<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline ostream &operator<< (ostream &_out, const unordered_set<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline ostream &operator<< (ostream &_out, const unordered_multiset<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T, class U> inline ostream &operator<< (ostream &_out, const map<T, U> &_m) {
    if (_m.empty()) { return _out; }
    _out << '(' << _m.begin()->x << ": " << _m.begin()->y << ')';
    for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) { _out << ", (" << _it->x << ": " << _it->y << ')'; }
    return _out;
}
template<class T, class U> inline ostream &operator<< (ostream &_out, const unordered_map<T, U> &_m) {
    if (_m.empty()) { return _out; }
    _out << '(' << _m.begin()->x << ": " << _m.begin()->y << ')';
    for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) { _out << ", (" << _it->x << ": " << _it->y << ')'; }
    return _out;
}
