/*

Code for problem L by cookiedoth
Generated 13 Dec 2020 at 10.51 AM


   ,##.                   ,==.
 ,#    #.                 \ o ',
#        #     _     _     \    \
#        #    (_)   (_)    /    ; 
 `#    #'                 /   .'  
   `##'                   "=="

-_-
z_z
>_<

*/

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <complex>
#include <cassert>
#include <random>
#include <cstring>
#include <numeric>
#include <random>
#include <utility>
#include <tuple>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << #a << " = " << a << endl
#define forn(i, n) for (int i = 0; i < n; ++i)
#define length(a) (int)a.size()

using namespace std;

template<class T> int chkmax(T &a, T b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, T b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream& out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9 + 228;
const int mx = 2e5 + 228;
int n, key[mx], l_link[mx], r_link[mx], lo[mx], hi[mx], h[mx], maxH;
vector<vector<pair<int, int>>> segments;

void read() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> l_link[i] >> r_link[i] >> key[i];
		l_link[i]--;
		r_link[i]--;
	}
}

void dfs(int v, int hv) {
	h[v] = hv;
	lo[v] = hi[v] = key[v];
	if (l_link[v] != -1) {
		dfs(l_link[v], hv + 1);
		chkmin(lo[v], lo[l_link[v]]);
	}
	if (r_link[v] != -1) {
		dfs(r_link[v], hv + 1);
		chkmax(hi[v], hi[r_link[v]]);
	}
	segments[hv].emplace_back(lo[v], hi[v]);
	chkmax(maxH, hv);
}

int check1(int L, int R, int h) {
	int pos = lower_bound(all(segments[h]), make_pair(L + 1, -INF)) - segments[h].begin() - 1;
	if (pos == -1) {
		return 0;
	}
	return segments[h][pos].first <= L && segments[h][pos].second >= R &&
		segments[h][pos].second - segments[h][pos].first > R - L;
}

int check2(int L, int R, int h) {
	int pos = lower_bound(all(segments[h]), make_pair(L, -INF)) - segments[h].begin() - 1;
	if (pos == -1) {
		return 0;
	}
	return segments[h][pos].second >= L;
}

int check3(int L, int R, int h) {
	int pos = lower_bound(all(segments[h]), make_pair(R + 1, -INF)) - segments[h].begin() - 1;
	if (pos == -1) {
		return 0;
	}
	return segments[h][pos].second > R;
}

int binsearch1(int L, int R, int type) {
	int l = -1, r = maxH;
	while (l < r) {
		int mid = (l + r) >> 1;
		int res;
		if (type == 1) {
			res = check1(L, R, mid + 1);
		} else if (type == 2) {
			res = check2(L, R, mid + 1);
		} else {
			res = check3(L, R, mid + 1);
		}
		if (res) {
			l = mid + 1;
		} else {
			r = mid;
		}
	}
	return l;
}

int query(int L0, int R0) {
	int L = L0;
	int R = R0;
	// cerr << "LR = " << L << " " << R << '\n';
	int h1 = binsearch1(L, R, 1);
	int h2 = binsearch1(L, R, 2);
	int h3 = binsearch1(L, R, 3);
	// cerr << "h1, h2, h3 " << h1 << " " << h2 << " " << h3 << '\n';
	chkmax(h2, h1);
	chkmax(h3, h1);
	int res = 2 * h2 + 2 * h3 + 1 - 2 * h1 + 2;
	return res;
}

void process_queries() {
	int T;
	cin >> T;
	while (T--) {
		int L, R;
		cin >> L >> R;
		int res = query(L, R);
		cout << res << '\n';
	}
}

signed main() {
	fast_io();
	read();
	segments.resize(n);
	dfs(0, 0);
	// cerr << segments[0][0].first << ' ' << segments[0][0].second << '\n';
	// cerr << segments[1][0].first << ' ' << segments[1][0].second << '\n';
	process_queries();
}
