#include <vector>
#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <iomanip>
#include <time.h>
#include <unordered_map>
#include <unordered_set>

#define fi first
#define se second
#define ll long long
#define ld long double
#define int long long
using namespace std;
const int N = 3e2 + 12;

int cnt[N];
int top = 0;
vector<int> e[N];
vector<int> col[N];
bool en[N];
bool use[N];
void dfs(int u, int pr) {
    if (e[u].size() == 0) {
        cnt[u] = 2;
        return;
    }
    cnt[u] = 1;
    for (auto v : e[u]) {
        dfs(v, u);
        cnt[u] *= cnt[v];
    }
    if (u != 1)
        ++cnt[u];
}

void recc(int root, int u, vector<int>& cnt, vector<int>& rev, vector<int> child) {
    if (u == cnt.size())
        return;
    if (!rev[u]) {
        recc(root, u + 1, cnt, rev, child);
        for (int i = 0; i < col[child[u]].size(); ++i) {
            col[root].push_back(col[child[u]][i]);
            recc(root, u + 1, cnt, rev, child);
        }
    } else {
        recc(root, u + 1, cnt, rev, child);
        for (int i = (int) col[child[u]].size() - 1; i >= 0; --i) {
            col[root].push_back(col[child[u]][i]);
            recc(root, u + 1, cnt, rev, child);
        }
    }
    rev[u] ^= 1;
}

void dfs_color(int u) {
    if (u != 1)
        col[u].push_back(u);
    vector<int> cnt(e[u].size(), 0);
    vector<int> rev(e[u].size(), 0);
    for (auto v : e[u]) {
        dfs_color(v);
    }
    recc(u, 0, cnt, rev, e[u]);
}


void solve() {
    int k, n, A, B, x;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        cin >> x;
        e[x].push_back(i);
    }
    dfs(1, 0);
    dfs_color(1);
    cout << col[1].size() << endl;
    for (auto x : col[1])
        cout << x << ' ';

}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false); cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
