#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    map<int, vector<int>> kek;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            kek[x].push_back(i);
        }
    }

    vector<vector<int>> gr(n);
    for (const auto& p : kek) {
        for (int i = 0; i + 1 < p.second.size(); ++i) {
            gr[p.second[i]].push_back(p.second[i + 1]);
        }
    }

    vector<int> dp(n);
    for (int i = n - 1; i >= 0; --i) {
        for (int j : gr[i]) {
            dp[i] = max(dp[i], dp[j] + 1);
        }
    }

    cout << *max_element(dp.begin(), dp.end()) + 1 << endl;

    return 0;
}
