
def gcd(a, b):
    if b == 0:
        return a
    else:
        return gcd(b, a % b)

def gcdex(a, b):
    if a == 1 and b == 0:
        return 1, 0
    x2, y2 = gcdex(b, a % b)
    return y2, x2 - (a // b) * y2


def cntdiof(a, b, c):
    d = gcd(a, b)
    if c % d != 0:
        return 0
    a //= d
    b //= d
    c //= d
    x0, y0 = gcdex(a, b)
    x = x0 * c
    y = y0 * c
    # x, y are sol for ax + by = c
    left_t = -x // b + 1
    right_t = y // a
    if y % a == 0:
        right_t -= 1

    if left_t <= right_t:
        return right_t - left_t + 1
    else:
        return 0


n = int(input())

for i in range(n):
    b, d = map(int, input().split())
    print(cntdiof(b, d, b ** 2))
