#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("popcnt")
//#pragma GCC target("-mpopcnt")

using namespace std;
//using namespace __gnu_pbds;

#define pb push_back
#define F first
#define S second
#define ll long long
#define ld double long
#define ull unsigned long long
#define endl '\n'


const ll N = 2e6 + 36;
const ll M = 1e1 + 64;
const ll INF = 1e9 + 7;
const ll MOD = 1e9 + 7;
const ll X[4] = {1, -1, 0, 0};
const ll Y[4] = {0, 0, 1, -1};
const ld PI = 3.14159265358979323846;
const ld EPS = 1e-12;

mt19937 gen(19937);

vector < pair < int, int > > g[N];
vector < int > gr[M];
int d[M];
bool good[N], us[N];
unordered_set < int > st;

void dfs(int v, int need) {
    d[v] = need;
    for (auto to:gr[v]) {
        dfs(to, need | (1 << to));
    }
}

vector < int > otv;
vector < int > path;
int ans = 0, mx = 0;


vector< pair <int, int > > generateGray(int n) {
    // Base case
    if (n <= 0){
        vector < pair <int, int> > s;
        if (st.count(100 + 1)){
            s.pb({1, 1});
        }
        return s;
    }

    if (n == 1) {
        vector<pair <int, int> > s;
        if (st.count(1)){
            s.pb({0, 1});
        }
        if (st.count(100 + 1)){
            s.pb({1, 1});
        }
        return s;
    }

    //Recursive case
    vector<pair <int, int> > recAns=
        generateGray(n-1);
    vector<pair <int, int> > mainAns;

    // Append 0 to the first half
    for(int i=0; i<int(recAns.size()); ++i) {
        int s= 1 + recAns[i].S;
        int ss = recAns[i].F;
        if (st.count(ss * 100 + s)){
            mainAns.push_back({ss, s});
        }
    }

    // Append 1 to the second half
    for(int i=int(recAns.size())-1; i>=0; --i) {
        int s= 1 + recAns[i].S;
        int ss = (1 << (n - 1)) + recAns[i].F;
        if (st.count(ss * 100 + s)){
            mainAns.push_back({ss, s});
        }
    }
    //cout << n << ' ' << mainAns.size() << endl;
    return mainAns;
}

// Function to generate the
// Gray code of N bits
void generateGrayarr(int n) {
    vector<pair <int, int> > arr;
    arr=generateGray(n);
    // print contents of arr
    cout << arr.size() - 1 << endl;
    for (int i = int(arr.size()) - 2; i >= 0; i--){
        for (int j(0); j < n; ++j){
            if ((arr[i].F ^ (1 << j)) == arr[i + 1].F){
                cout << n - j << ' ';
                break;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    mx = (1 << n) - 1;
    for (int i(1); i < n; ++i) {
        int x;
        cin >> x;
        --x;
        gr[x].pb(i);
    }
    dfs(0, 1);
    for (int i(1); i < (1 << n); i += 2) {
        bool f = 1;
        for (int j(1); j < n; ++j) {
            if (i & (1 << j)) {
                if ((i & d[j]) != d[j]) {
                    f = 0;
                    break;
                }
            }
        }
        if (f) {
            int s = 0;
            int now = 0;
            for (int j(n - 1); j >= 0; --j) {
                if (i & (1 << j)) {
                    ++s;
                    now += (1 << (n - j - 1));
                } else {
                    ++s;
                }
                //cout << now << ' ' << s << endl;
                st.insert(now * 100 + s);
            }
        }
        good[i] = f;
    }
    generateGrayarr(n);
    return 0;
}
