#include <iostream>
#include <vector>

using namespace std;

int n;
int p[100];
int c[100];
int used[100];

enum {
    GREEN = 0,
    RED = 1,
};

int cnt_used = 0;

vector<int> childs[100];
vector<int> answer;
int order[100][100];

void rec(int v, int parent)
{
    bool update_cnt_used = !used[v];
    if (update_cnt_used) {
        used[v] = true;
        ++cnt_used;
    }

    if (v == 0) {
        if (cnt_used == n) {
            return;
        }

        // Ищем вершину с used = false и color = green?? (причем у потомков color = red)
        if (parent >= 0) {
            for (auto i : childs[parent]) {
                int u = i;
                if (!used[u]) {
                    while (p[u] != 0) {
                        if (c[p[u]] != RED) {
                            break;
                        }
                        u = p[u];
                    }
                    if (p[u] == 0) {
                        rec(i, parent);
                        return;
                    }
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            int u = i;
            if (!used[u]) {
                while (p[u] != 0) {
                    if (!used[p[u]] or c[p[u]] != RED) {
                        break;
                    }
                    u = p[u];
                }
                if (p[u] == 0) {
                    rec(i, parent);
                    return;
                }
            }
        }
        return;
    }

//    c[v] = 1 - c[v];
//    answer.push_back(v + 1);
    rec(0, v);

//    if (c[p[v]] == RED) {
//        bool check = true;
//        for (auto u : childs[v]) {
//            if (c[u] == RED) {
//                check = false;
//                break;
//            }
//        }
//        if (check) {
//            c[v] = 1 - c[v];
//            answer.push_back(v + 1);
//            rec(0, v);
//        }
//    }
    c[v] = 1 - c[v];
    answer.push_back(v + 1);
    rec(0, v);

    if (update_cnt_used) {
        used[v] = false;
        --cnt_used;
    }
}



int main()
{
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        childs[p[i]].push_back(i);
    }
    p[0] = -1;
    c[0] = RED;


    for (int i = n - 1; i >= 0; --i) {
        vector<int> v;
        for (auto child : childs[i]) {
            v.push_back(child);
            for (auto x : childs[child]) {
                v.push_back(x);
            }
        }
        childs[i] = v;
    }


    rec(0, -1);

    cout << answer.size() << endl;
    for (auto x : answer) {
        cout << x << ' ';
    }
    cout << endl;
}
