def gcd(a, b):
    while b > 0:
        a %= b
        a, b = b, a
    return a


def ex_gcd(a, b):
    if a == 0:
        return 0, 1, b
    x1, y1, g = ex_gcd(b % a, a)
    x = y1 - (b // a) * x1
    y = x1
    return x, y, g


def solve(b, d):
    g = gcd(b, d)
    w = b * b
    b //= g
    d //= g
    x, y, _ = ex_gcd(d, b)
    w //= g
    x *= w
    y *= w
    if x < 0:
        k = (-x + b - 1) // b
        x += b * k
        y -= d * k
    if x == 0:
        x += b
        y -= d
    if y < 0:
        k = (-y + d - 1) // d
        y += d * k
        x -= b * k
    if y == 0:
        y += d
        x -= b
    if x <= 0 or y <= 0:
        return 0
    return x // b - int(x % b == 0) + y // d - int(y % d == 0) + 1


def main():
    t = int(input())
    for _ in range(t):
        b, d = map(int, input().split())
        print(solve(b, d))


main()