//
// Created by sakost on 10.12.2019.
//

#include <bits/stdc++.h>

#pragma GCC optimize("O2")


using namespace std;

// definitions
typedef unsigned long long ull;
typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;
typedef pair<ld, ld> pld;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;


//const ll p = 31;
const ll P = 1000000007;
const ld INFLD = numeric_limits<ld>::max();
const ll INFL = numeric_limits<ll>::max();
const int INF = numeric_limits<int>::max();
const ld eps = numeric_limits<ld>::epsilon();
const ld pi = 3.14159265358979323846264338327950288419716939937510;
const ld d2r = pi / 180;
const ld r2d = 180 / pi;

#define timeit clock_t _begin = clock();
#define endtimeit clock_t _end = clock(); cerr << "Elapsed seconds: " << double(_end - _begin) / CLOCKS_PER_SEC << endl;
#define fastIO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define fori(i, k, n) for(ull i(k); i < n; ++i)
#define forj(k, n) for(ull j(k); j < n; ++j)
#define formi(n, k) for(ll i(n); i > k; --i)
#define sz size()
#define forel(a) for(auto &el: a)
#define srt(a) sort(a.begin(), a.end())
#define all(a) (a).begin(), (a).end()
#define bg begin()
#define fs first
#define sc second
#ifdef _ONPC_
#define what(x) cerr << #x << " = " << x << endl
#else
#define what(x)
#endif

struct Node{
//    int id;
    Node *left = nullptr, *right = nullptr;
    ll value = 0;
};

ll count_l = 0;
void count_lookup(){
    count_l++;
}

ll left_min(Node *v){
    if(v == nullptr) return 0;
    if(v->left == nullptr) return v->value;
    return left_min(v->left);
}
ll right_max(Node *v){
    if(v == nullptr) return 0;
    if(v->right == nullptr) return v->value;
    return right_max(v->right);
}


void lookup(Node* v, ll l, ll r){
    count_lookup();
    if(v == nullptr) return;
    ll lm = left_min(v);
    ll rm = right_max(v);
    if(l <= lm && rm <= r){
        return;
    }
    if(rm < l || r < lm){
        return;
    }
    lookup(v->left, l, r);
    lookup(v->right, l, r);
}

void solve() {
    vector<Node*> nodes;
    int n;
    cin >> n;
    nodes.resize(n);
    for (int i = 0; i < n; ++i) {
        nodes[i] = new Node;
    }

    for (int i = 0; i < n; ++i) {
        ll l,r,k;
        cin >> l >> r >> k;
//        l--;r--;
        if(l > 0)
            nodes[i]->left = nodes[l-1];
        if(r > 0)
            nodes[i]->right = nodes[r-1];
        nodes[i]->value = k;
    }

    int q;
    cin >> q;
    while(q--){
        count_l = 0;
        ll l,r;
        cin >> l >> r;
        lookup(nodes[0], l, r);
        cout << count_l << '\n';
    }
}

signed main() {
#ifdef _ONPC_
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#define TIMEIT
    timeit
#endif // _ONPC_

    fastIO;
    int t(1);
//    cin >> t; //////////////////////////////// UNCOMMENT IF WITH TESTS ///////////////////////////////////////
    fori(i, 0, t)solve();

#ifdef TIMEIT
    endtimeit
#endif // TIMEIT
    return 0;
}