#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()

typedef long long ll;

const int N = 3e6;

vector<int> ans[21];
vector<int> edges[21];
//int rev[20];

void dfs(int v, int p = -1) {
  // if (!edges[v].empty()) {
  //   if (v != 1) ans[v] = {v};
  //   return;
  // }
  vector<pair<int, int> > vt;
  for (int u : edges[v]) {
    dfs(u, v);
    vt.push_back({ans[u].size(), u});
  }
  sort(all(vt)); reverse(all(vt));
  // for (int u : edges[v]) {
  //   rev[u] = 0;
  // }
  vector<int> prefix;
  for (auto [shit, u] : vt) {
    vector<int> res = ans[u];
    vector<int> nprefix = prefix;
    int rev = 1;
    for (int i = 0; i < res.size(); i++) {
      nprefix.push_back(res[i]);
      if (rev == 0) {
        for (auto x : prefix) nprefix.push_back(x);
        rev ^= 1;
      }
      else {
        for (int j = prefix.size() - 1; j >= 0; j--) nprefix.push_back(prefix[j]);
        rev ^= 1;
      }
    }
    prefix = nprefix;
  }
  if (v == 1) {
    ans[v] = prefix;
  }
  else {
    ans[v] = {v}; for (auto x : prefix) ans[v].push_back(x);
  }
}

void solve() {
  int n; cin >> n;
  for (int v = 2; v <= n; v++) {
    int p; cin >> p;
    edges[p].push_back(v);
  }
  dfs(1, -1);
  cout << ans[1].size() << "\n";
  for (auto x : ans[1]) cout << x << " ";
}

int main() {
  ios::sync_with_stdio(NULL), cin.tie(0), cout.tie(0);
  cout.setf(ios::fixed), cout.precision(20);
  //cout << 1.0 * clock() / CLOCKS_PER_SEC << endl;
  solve();
}
