#include<bits/stdc++.h>
#define fr first
#define sc second
#define pb push_back
#define ll long long
#define double long double
#define maxheap priority_queue<int>
#define minheap priority_queue<int,vector<int>,greater<int>>
const  double pi = acos(-1.0);
const double eps = 1e-9;
using namespace std;

const int N = 2e6 + 10;
const int LOG = 20;
int n, tim;
int pred[N], l[N], r[N], vmin[N], vmax[N], key[N];
int up[N][LOG];
int tin[N], tout[N], cnt[N], h[N];

void dfs(int v, int p, int d){
    h[v] = d;
    tin[v] = ++tim;
    up[v][0] = p;
    for (int i = 1; i < LOG; i++) {
      up[v][i] = up[up[v][i - 1]][i - 1];
    }
    cnt[v] = 1;
    if (l[v] != 0){
        dfs(l[v], v, d + 1);
        vmin[v] = min(vmin[l[v]], vmin[v]);
        vmax[v] = max(vmax[l[v]], vmax[v]);
        cnt[v] += cnt[l[v]];
    }
    if (r[v] != 0){
        dfs(r[v], v, d + 1);
        vmin[v] = min(vmin[r[v]], vmin[v]);
        vmax[v] = max(vmax[r[v]], vmax[v]);
        cnt[v] += cnt[r[v]];
    }
    tout[v] = ++tim;
}

bool is_lca(int u, int v) {
  return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int lca(int u, int v) {
  if (is_lca(u, v)) return u;
  if (is_lca(v, u)) return v;
  for (int i = LOG - 1; i >= 0; i--) {
    if (!is_lca(up[u][i], v)) {
      u = up[u][i];
    }
  }
  return up[u][0];
}
void solve(){
    cin >> n;

    vector <pair <int, int> > ver;
    for (int i = 1; i <= n; i++){

        int left, right;
        cin >> left >> right;

        l[i] = left;
        r[i] = right;

        cin >> key[i];

        pred[left] = i;
        pred[right] = i;

        vmin[i] = key[i];
        vmax[i] = key[i];
        ver.pb({key[i], i});
    }
    dfs(1, 1, 1);

    sort(ver.begin(), ver.end());

    int q;
    cin >> q;
    while (q--){
        int L, R;
        cin >> L >> R;
        auto pos = lower_bound(ver.begin(), ver.end(), make_pair(L, - 1));

        if (pos == ver.end()){
            cout << 1 << endl;
            continue;
        }
        int v = pos -> sc;
        int pref = -1;
        int ans = 0;
        int id = pos - ver.begin();

        while (1) {
            int nv = v;

            for (int i = LOG - 1; i >= 0; i--){
              int u = up[nv][i];
              if (L <= vmin[u] && vmax[u] <= R) nv = u;
            }
            int razmer = cnt[nv];
            if (pref == -1){
              ans += (h[nv] - 1) * 2;
              if (L <= vmin[nv] && vmax[nv] <= R) {
                ans++; 
              }
              else {
                ans += 2;
                ans++;  
              }
              pref = nv;
            }
            else{
              int lc = lca(pref, nv);
              int raz = max(h[nv] - h[lc], 0);
              ans += raz * 2;
              if (L <= vmin[nv] && vmax[nv] <= R) {
                ans += 0;
              }
              else {
                ans += 2;
              }
              pref = nv;
              //cout << "lca " << lc << " " << raz << " " << nv << " " << vmin[nv] << " " << vmax[nv] << endl;
            }
            //cout << v << " " << ans << endl;
            id = id + 1 + cnt[r[nv]];
            if (id >= n) break;
            v = ver[id].sc;
        }
        cout << ans << " ";
    }
}
int main(){
    ios::sync_with_stdio(NULL), cin.tie(0), cout.tie(0);
    cout.setf(ios::fixed), cout.precision(6);
    //freopen("input.txt", "r", stdin); //freopen("somebody.txt", "w", stdout);
    //freopen("caravan.in","r",stdin); freopen("caravan.out", "w", stdout);
    int step;
    step = 1;
    //cin >> step;
    for (int i = 1; i <= step; i++){
         solve();
    }
}
