#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker,"/STACK:1000000000,1000000000")
#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <bitset>
#include <iomanip>

#define sp << " "
#define sps << " " <<
#define ln << "\n"
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define optimise cin.sync_with_stdio(false); cout.sync_with_stdio(false); cin.tie(NULL);

using namespace std;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;

template<class T>
istream& operator>> (istream& is, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)is >> vec[i]; return is; }
template<class T>
ostream& operator<< (ostream& os, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)os << vec[i] << " "; return os; }
template<class T>
istream& operator>> (istream& is, pair<T, T>& a) { is >> a.first >> a.second; return is; }

const double pi = acos(-1.0);
const ll mod = (int)1e9 + 9; /*1e9;*/ /*(1ll << 30);*/ /*998244353*/;
const ll INF = 2e18;
const int inf = (int)1e9 + 7;
const int maxlen = (int)1e5 + 100;
const double eps = 1e-7;

//------------------------
string s[300005];
bool isWin[300005];

int common(string a, string b) {
	int ans = 0;
	for (int i = 0; i < 8; i++)
		if (a[i] == b[i])
			ans++;
	return ans;
}

void solve() {
	int n;
	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}

	for (int i = 1; i < n; i++) {
		for (int j = i - 1; j >= max(i - 8, 0); j--) {
			int dif = common(s[i], s[j]);
			if (!isWin[j] && i - j <= dif)
				isWin[i] = true;
		}
	}

	for (int i = 0; i < n; i++)
		if (isWin[i])
			cout << '1';
		else
			cout << '2';

}

int main() {
	optimise
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T = 1;
	//cin >> T;
	
	while (T--) {
		solve();
	}
	return 0;
}