#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace std;

#define for0(i, n) for(int i = 0; i < n; ++i)

#define pb push_back

typedef long long ll;

void problem();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tst = 1;
	while (tst--) {
#endif
		cin.tie();
		problem();
#ifdef _DEBUG
		cout << '\n';
	}
#endif
	return 0;
}

void dfs(int v, int a, int b) {
	if (b % 2 || !a) {
		cout << 2;
		--b;
	}
	else {
		cout << 1;
		--a;
	}
	if (!a && !b) {
		cout << " 0 0\n";
		return;
	}
	int am = a / 2;
	int u = v + am + b / 2 + 1;
	if (a + b == 1) {
		cout << " 0 " << v + 1 << "\n";
	}else{
		cout << ' ' << v + 1 << ' ' << u << '\n';
	}
	if(am || b)
		dfs(v + 1, am, b / 2);
	dfs(u, a - am, b / 2);
}

void problem() {
	int a, b;
	cin >> a >> b;
	if (!a && b % 2 == 0) {
		cout << -1;
		return;
	}
	dfs(1, a, b);
}