#include <bits/stdc++.h>

using namespace std;

struct Node {
    int data;
    int left;
    int right;
    int mi;
    int ma;
    Node( int l , int r, int val)
    {
        data = val;
        left = l;
        right = r;
        mi = val;
        ma = val;
    }

};
Node def = Node(0,0,0);
vector<Node> mas(200010, def);

//long long getAns(long long x ,long long l, long long r)
//{
//    if  ((mas[x].ma < l) || (mas[x].mi > r)) return 0;
//    if  ((mas[x].ma <= r) && (mas[x].mi >= l)) return 0;
//
//    if (x == 0) {
//        return 0;
//    }
//
//    return 2 + getAns(mas[x].left, l , r) + getAns(mas[x].right, l , r);
//}

long long getAns(int x ,int l, int r)
{
    stack<int> s;
    s.push(x);
    int ans = 0;
    while (!s.empty()) {
        int a = s.top();
        s.pop();
        if  ((mas[a].ma < l) || (mas[a].mi > r)) continue;
        if  ((mas[a].ma <= r) && (mas[a].mi >= l)) continue;
        if (a == 0) continue;
        ans += 2;
        s.push(mas[a].left);
        s.push(mas[a].right);
    }

    return ans;
}

void findAll(int x )
{
    int mi = mas[x].mi;
    int ma = mas[x].ma;

    if(mas[x].left != 0)
    {
        findAll(mas[x].left);
        mi = min(mi,mas[ mas[x].left ].mi);
        //ma = max(ma,mas[mas[x].left].ma);
    }

    if(mas[x].right != 0)
    {
        findAll(mas[x].right);
        //mi = min(mi,mas[ mas[x].right ].mi);
        ma = max(ma,mas[ mas[x].right ].ma);
    }

    mas[x].mi = mi;
    mas[x].ma = ma;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mas[0] = (Node(0,0,0));
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        int l , r, k;
        cin >> l >> r >> k;
        Node tmp = Node(l,r,k);
        mas[i + 1] = tmp;
    }

    findAll(1);
    int q;
    cin >> q;
    vector<int> ans(q);
    for(int i = 0; i < q; ++i)
    {
        int l,r;
        cin >> l >> r;
        ans[i] = getAns(1,l,r) + 1;
    }

    for (auto i : ans) {
        cout << i << "\n";
    }

    return 0;
}