/*
 _    _    _______   _    _
| |  / /  |  _____| | |  / /
| | / /   | |       | | / /
| |/ /    | |_____  | |/ /
| |\ \    |  _____| | |\ \
| | \ \   | |       | | \ \
| |  \ \  | |_____  | |  \ \
|_|   \_\ |_______| |_|   \_\

*/
#include <bits/stdc++.h>

using namespace std;

typedef unsigned long long ull;
typedef double ld;
typedef pair <int, int> PII;


#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define right(x) x << 1 | 1
#define left(x) x << 1
#define forn(x, a, b) for (int x = a; x <= b; ++x)
#define for1(x, a, b) for (int x = a; x >= b; --x)
#define mkp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define y1 kekekek

#define fname ""

const int oo = 1e9 + 9, base = 1e9 + 7;
const ld eps = 1e-7;
const int N = 1e6 + 228;

int n, Q;
int res[N], a[N];
int ll[N], rr[N];
int gl[N], gr[N];
int ql[N], qr[N];
vector < int > vec, g[N], q[N];
int t[N];

void upd(int i, int val) {
    for (; i <= sz(vec); i |= i + 1) t[i] += val;
}

int get(int i) {
    int sum = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) sum += t[i];
    return sum;
}

void calc(int v) {
    if (!v) return;

    calc(gl[v]);
    calc(gr[v]);

    ll[v] = min(ll[gl[v]], a[v]);
    rr[v] = max(rr[gr[v]], a[v]);
    g[rr[v]].eb(v);
//    cerr << v << " -> " << ll[v] << " " << rr[v] << "\n";
}

void solve() {
    cin >> n;
    forn(i, 1, n) {
        cin >> gl[i] >> gr[i] >> a[i];
        vec.eb(a[i]);
    }

    cin >> Q;
    forn(i, 1, Q) {
        cin >> ql[i] >> qr[i];
        vec.eb(ql[i]);
        vec.eb(qr[i]);
    }

    sort(all(vec));
    vec.erase(unique(all(vec)), vec.end());

    forn(i, 1, n) {
        a[i] = lower_bound(all(vec), a[i]) - vec.begin() + 1;
    }

    forn(i, 1, Q) {
        ql[i] = lower_bound(all(vec), ql[i]) - vec.begin() + 1;
        qr[i] = lower_bound(all(vec), qr[i]) - vec.begin() + 1;

        ql[i + Q] = qr[i] + 1;
        qr[i + Q] = sz(vec);

        ql[i + Q + Q] = 1;
        qr[i + Q + Q] = ql[i] - 1;
    }

    ll[0] = sz(vec);
    rr[0] = 0;
    calc(1);

    forn(i, 1, Q + Q + Q) {
        q[qr[i]].eb(i);
    }

    forn(i, 1, sz(vec)) {
        for (int it : g[i]) {
            upd(ll[it], 1);
        }
        for (int it : q[i]) {
            res[it] = get(i) - get(ql[it] - 1);
        }
    }

    forn(i, 1, Q) {
//        cout << res[i] << " ";
        cout << (n - res[i] - res[i + Q] - res[i + Q + Q]) * 2 + 1 << "\n";
    }
}

void clear() {}

int main() {
    ios_base :: sync_with_stdio(0), cin.tie(0), cout.tie(0);

    #ifdef krauch
        freopen("input.txt", "r", stdin);
    #else
        //freopen(fname".in", "r", stdin);
        //freopen(fname".out", "w", stdout);
    #endif

    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
        clear();
    }

    return 0;
}
