	#define _CRT_SECURE_NO_WARNINGS
	#include<iostream>
	#include <vector>
	#include <map>
	#include <string>
	#include<unordered_map>
	#include <unordered_set>
	#include<set>
	#include<queue>
	#include<iomanip>
	#include <bitset>
	typedef long long ll;
	using namespace std;
	const int MAXN = 2e5 + 10;
	const int LOGN = 20;
	int numbers[MAXN];
	int values[MAXN];
	int min_values[MAXN];
	int max_values[MAXN];
	int l[MAXN], r[MAXN];
	int p[MAXN][LOGN];
	int h[MAXN];
	int l_item[MAXN], r_item[MAXN];
	vector<int> kekw;
	

	void dfs(int v, int parent)
	{
		if (l[v] == -1 && r[v] == -1)
			kekw.push_back(v);

		
		h[v] = h[parent] + 1;
		p[v][0] = parent;
		for (int i = 1; i < LOGN; ++i)
		{
			p[v][i] = p[p[v][i - 1]][i - 1];
		}
		min_values[v] = values[v];
		max_values[v] = values[v];
		if (l[v] != -1)
		{
			dfs(l[v], v);
			min_values[v] = min_values[l[v]];
		}
		
		if (r[v] != -1)
		{
			dfs(r[v], v);
			max_values[v] = max_values[r[v]];
		}
	}

	/*struct SegmentTree
	{
		pair<int, int> values[MAXN * 4];
		void Build(int l, int r, vector<pair<int, int>> &to_save, int i)
		{
			if (l == r)
			{
				values[i] = to_save[i];
				return;
			}
			int med = (l + r) >> 1;
			Build(l, med, to_save, i * 2 + 1);
			Build(med + 1, r, to_save, i * 2 + 2);
			if (values[i * 2 + 1].second < values[i * 2 + 2].second)
				values[i] = values[i * 2 + 2];
			else
				values[i] = values[i * 2 + 1];
		}

		SegmentTree(vector<pair<int, int>> &order)
		{
			Build(0, order.size() - 1, order, 0);
		}

		pair<int, int> BestValue(int l, int r, int l1, int r1, int i)
		{
			if (l <= l1 && r >= r1)
			{
				return values[i];
			}
			int med = (l + r) >> 1;
			vector<pair<int, int>> result;
			if (l1 <= med)
			{
				result.push_back(BestValue(l, med, l1, min(med, r1), i * 2 + 1));
			}
			if (r1 > med)
			{
				result.push_back(BestValue(med + 1, r, max(l1, med + 1), r1, i * 2 + 2));
			}
			if (result.size() == 1)
				return result[0];
			return result[0].second > result[1].second ? result[0] : result[1];
		}

	};*/

	int get_parent(int v, int to)
	{
		if (h[v] > h[to])
			swap(v, to);
		for (int i = 0; i < LOGN; ++i)
		{
			if ((h[to] - h[v]) & (1 << i))
			{
				v = p[v][i];
			}
		}
		if (v == to)
			return v;
		for (int i = LOGN - 1; i >= 0; --i)
		{
			if (p[v][i] != p[to][i])
			{
				v = p[v][i];
				to = p[to][i];
			}
		}
		return p[v][0];
	}

	struct query
	{
		int l, r;
		int ind;
	};
	queue<query> que;

	bool Greater1(query q1, query q2)
	{
		return q1.l < q2.l;
	}
	bool Greater2(query q1, query q2)
	{
		return q1.r > q2.r;
	}

	bool contain(int l, int r, int l1, int r1)
	{
		return l >= l1 && r <= r1;
	}

	/*void DFS1(int v, vector<int>& indexes)
	{
		indexes.push_back(v);
		if (l[v] != -1)
		{
			vector<int> index;
			DFS1(l[v], index);
		}
		if (r[v] != -1)
			DFS1(r[v], indexes);
		else
		{
			
			while (!que.empty() && que.front().l <= max_values[v])
			{
				int l_index = 0, r_index = indexes.size() - 1;
				auto top_item = que.front();
				que.pop();
				while (l_index < r_index)
				{
					int med = (l_index + r_index + 1) >> 1;
					if (min_values[indexes[med]] <= top_item.r)
					{
						l_index = med;
					}
					else
						r_index = med - 1;
				}
				if (min_values[indexes[l_index]] <= top_item.r)
				{
					int ind = indexes[l_index];
					if (!contain(min_values[ind], max_values[ind], top_item.l, top_item.r))
					{
						l_item[top_item.ind] = ind;
						continue;
					}
					for (int i = LOGN - 1; i >= 0; --i)
					{
						int p_kekw = p[ind][i];
						if (contain(min_values[p_kekw], max_values[p_kekw], top_item.l, top_item.r))
						{
							ind = p_kekw;
						}
					}
					if (ind == 0)
					{
						l_item[top_item.ind] = -1;
					}
					else
					{
						l_item[top_item.ind] = p[ind][0];
					}
				}
			}
			
		}
		indexes.pop_back();
	}

	void DFS2(int v, vector<int> indexes)
	{
		indexes.push_back(v);
		if (r[v] != -1)
		{
			vector<int> index;
			DFS2(r[v], index);
		}
		if (l[v] != -1)
			DFS2(l[v], indexes);
		else
		{

			while (!que.empty() && que.front().r >= min_values[v])
			{
				int l_index = 0, r_index = indexes.size() - 1;
				auto top_item = que.front();
				que.pop();
				while (l_index < r_index)
				{
					int med = (l_index + r_index + 1) >> 1;
					if (max_values[indexes[med]] >= top_item.l)
					{
						l_index = med;
					}
					else
						r_index = med - 1;
				}
				if (max_values[indexes[l_index]] >= top_item.l)
				{
					int ind = indexes[l_index];
					if (!contain(min_values[ind], max_values[ind], top_item.l, top_item.r))
					{
						r_item[top_item.ind] = ind;
						continue;
					}
					for (int i = LOGN - 1; i >= 0; --i)
					{
						int p_kekw = p[ind][i];
						if (!contain(min_values[p_kekw], max_values[p_kekw], top_item.l, top_item.r))
						{
							ind = p_kekw;
						}
					}
					if (ind == 0)
					{
						r_item[top_item.ind] = -1;
					}
					else
					{
						r_item[top_item.ind] = p[ind][0];
					}
				}
			}

		}
		indexes.pop_back();

	}*/

bool intersect(int l1, int r1, int l, int r)
{
	return max(l1, l) <= min(r1, r);
}

int GetFirstValue(int v, int l, int r)
{
	if (!intersect(min_values[v], max_values[v], l, r))
	{
		for (int i = LOGN - 1; i >= 0; --i)
		{
			
			int p_val = p[v][i];
			if (!intersect(min_values[p_val], max_values[p_val], l, r))
			{
				v = p_val;
			}
		}
		if (v == 0)
			return -1;
		v = p[v][0];
	}
	if (!contain(min_values[v], max_values[v], l, r))
		return v;
	for (int i = LOGN - 1; i >= 0; --i)
	{

		int p_val = p[v][i];
		if (contain(min_values[p_val], max_values[p_val], l, r))
		{
			v = p_val;
		}
	}
	if (v == 0)
		return -1;
	return p[v][0];
}
	

	void solve()
	{
		int n;
		cin >> n;
		for (int i = 0; i < n; ++i)
		{
			cin >>l[i] >> r[i] >> values[i];
			l[i]--;
			r[i]--;
		}
		//h[0] = -1;
		dfs(0, 0);
		//vector<pair<int, int>> to_build;
		//map<ll, int> indexes;
		//indexes[-1e18] = -1;
		//indexes[1e18] = n;
		//for (int i = 0; i < n; ++i)
		//{
		//	to_build.push_back({ kekw[i], h[kekw[i]] });
		//	indexes[values[i]] = i;
		//}
	//	auto tree = new SegmentTree(to_build);
		int q;
		cin >> q;
		/*vector<query> queries;

		for (int i = 0; i < q; ++i)
		{
			int l, r;
			cin >> l >> r;
			queries.push_back({ l, r, i });
		}
		sort(queries.begin(), queries.end(), Greater1);
		for (auto u : queries)
		{
			que.push(u);
		}
		vector<int> values;*/
		
		for (int i = 0; i < q; ++i)
		{
			int l, r;
			cin >> l >> r;
			int l_index = 0, r_index = kekw.size() - 1;
			while (l_index < r_index)
			{
				int med = (l_index + r_index) >> 1;
				if (values[kekw[med]] >= l)
					r_index = med;
				else
					l_index = med + 1;
			}
			int m = GetFirstValue(kekw[l_index], l, r);
			if (m == -1)
			{
				cout << 1 << '\n';
				continue;
			}
			if (l_index > 0)
			{
				int v = GetFirstValue(kekw[l_index - 1], l, r);
				if (get_parent(v, m) != m)
				{
					m = v;
				}
			}
			l_index = 0, r_index = kekw.size() - 1;
			while (l_index < r_index)
			{
				int med = (l_index + r_index + 1) >> 1;
				if (values[kekw[med]] <= r)
					l_index = med;
				else
					r_index = med - 1;
			}
			int c = GetFirstValue(kekw[l_index], l, r);
			if (l_index < kekw.size() - 1)
			{
				int v = GetFirstValue(kekw[l_index + 1], l, r);
				if (get_parent(v, c) != c)
				{
					c = v;
				}
			}
			if (c == m)
				cout << h[c] + h[m] + 2 - h[get_parent(c, m)]<<'\n';
			else
				cout << h[c] + h[m] + 4 - h[get_parent(c, m)] << '\n';
		}

	}


	int main()
	{
//		freopen("input.in", "r", stdin);
//		freopen("output.out", "w", stdout);

		solve();
		return 0;
	}