#include <algorithm>
#include <queue>
#include <deque>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>
#include <cstring>
#include <cmath>
#include <stack>
#include <random>


using namespace std;
using ll = long long;
#define forn(i, n) for(ll i = 0; i < n; ++i)

const ll INF = 1e9;
const ll MOD = 1e17;
const ll MAXN = 2 * 1e5 + 100;
const ll MAXL = 20;

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);
    cout << fixed << setprecision(16);
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        ll b, d;
        cin >> b >> d;
        ll g = gcd(b, d);
        --b;
        cout << (b * g / d) << '\n';
    }
    return 0;
}