/*
     :   (zv.proger@yandex.ru)
      A   codeforces.com
*/

#include<bits/stdc++.h>
using namespace std;

#define ALL(x) x.begin(), x.end()

using ll = long long;
using pii = pair<int, int>;

const int inf = 1e9;
bool __mt = true;

void init() {}

ll gcd (ll a, ll b, ll & x, ll & y) {
    if (!a) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}


bool as (ll a, ll b, ll c, ll & x0, ll & y0, ll &g) {
    g = gcd(a, b, x0, y0);
    if (c % g) return false;
    x0 *= c / g;
    y0 *= c / g;
    return true;
}

void sh (ll a, ll b, ll &x, ll &y, ll cnt) {
    x += cnt * b;
    y -= cnt * a;
}

ll all(ll a, ll b, ll c) {
    ll x, y, g;
    if (!as(a, b, c, x, y, g)) return 0;
    a /= g; b /= g;
    sh(a, b, x, y, (1-x) / b - 2);
    while (x <= 0)
        sh(a, b, x, y, 1);
    if (y <= 0) return 0;
    ll l = 0, r = 1e17 / max(a, b);
    while (l < r - 1) {
        ll cx = x, cy = y;
        ll m = (l + r) / 2;
        sh(a, b, cx, cy, m);
        if (cy <= 0) r = m; else l = m;
    }
    return r;
}

void solve() {
    ll b, d; cin >> b >> d;
    cout << all(d, b, b*b) << endl;
}

int main() {
    int t = 1;
    if (__mt) cin >> t;
    init();
    for (; t--;) {
        solve();
    }
}