#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <utility>
#include <map>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <cstring>
#include <sstream>
#include <cmath>


using namespace std;

//using pii = pair<long long>;
#define f first
#define s second
template <class X, class Y> pair<X,Y> operator + (pair<X,Y> a, pair<X,Y> b) {return {a.f + b.f, a.s + b.s};}
template <class X, class Y> pair<X,Y> operator - (pair<X,Y> a, pair<X,Y> b) {return {a.f - b.f, a.s - b.s};}
template <class X, class Y, class Z> pair<X,Y> operator * (pair<X,Y> a, Z b) {return {a.f * b, a.s * b};}
template <class X, class Y, class Z> pair<X,Y> operator / (pair<X,Y> a, Z b) {return {a.f / b, a.s / b};}

vector<int> _snm;
void init_snm(int n) { _snm.resize(n); for (int i =0; i < n; i++) { _snm[i] = i; } }
int par_snm(int a) { return _snm[a] == a ? a : _snm[a] = par_snm(_snm[a]); }
int uni_snm(int a, int b) { a = par_snm(a); b = par_snm(b); if (rand() & 1) swap(a, b); return _snm[a] = b; }

struct mdt {
    static const long long md = 1e9 + 7.5;
    long long x;
    mdt (long long a = 0) { x = a % md; }
    mdt pow(long long n) const { return n ? mdt(x*x).pow(n/2)*(n & 1 ? x : 1): 1; }
    mdt rev() const { return pow(md - 2); }
    friend mdt operator + (mdt a, mdt b) { return a.x + b.x; }
    friend mdt operator - (mdt a, mdt b) { return a.x - b.x + md; }
    friend mdt operator * (mdt a, mdt b) { return a.x * b.x; }
    friend mdt operator / (mdt a, mdt b) { return a * b.rev(); }
    mdt &operator += (mdt b) { return *this = *this + b; }
    mdt &operator -= (mdt b) { return *this = *this - b; }
    mdt &operator *= (mdt b) { return *this = *this * b; }
    mdt &operator /= (mdt b) { return *this = *this / b; }
    friend istream &operator >> (istream &a, mdt &b) { long long x; a >> x; b = x; return a; }
    friend ostream &operator << (ostream &a, mdt b) { return a << b.x; }
};


int main(){

    int N;
    cin >> N;
    int ans = 0;

    vector<long> yestrday;


    int k;
    for(int i = 0; i < N; ++i){
        cin >> k;
        int cl;
        vector<long> yestrdayCopy;

        for(int j = 0; j < k; ++j){
            cin >> cl;
            yestrdayCopy.push_back(cl);
        }

        if(yestrday.empty()) {
            ++ans;

        }else{
            sort(yestrdayCopy.begin(), yestrdayCopy.end());
            sort(yestrday.begin(), yestrday.end());
            bool isPlusAns = false;
            for(int j = 0; j < yestrday.size(); ++j){
                if(yestrdayCopy[j] == yestrday[j]) {
                    isPlusAns = true;
                    break;
                }
            }

            if(isPlusAns)
                ++ans;
        }

        yestrday = yestrdayCopy;
    }

    cout<<ans<<endl;
}