fun main() {
    val t = readInt()
    for (tc in 1..t) {
        val (b, d) = readLongs()
        val gcd = gcd(b, d)
        val lca = b / gcd * d
        val numberOfAs = b * b / lca
        val mod = b * b % lca
        println(if (mod == 0L) numberOfAs - 1 else numberOfAs)
    }
}

fun gcd(a: Long, b: Long): Long {
    return if (b > 0) {
        gcd(b, a % b)
    } else {
        a
    }
}

/**
 * IO functions
 */
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLong() = readLn().toLong()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun readLongs() = readStrings().map { it.toLong() }
private fun readDoubles() = readStrings().map { it.toDouble() }