#include <iostream>

using namespace std;

struct node {
    int key;
    node *left, *right;
    int min, max;
    int count;
};

struct info {
    int li;
    int ri;
    int ki;
};

int num;

int lookup(node *v, int L, int R) {
    num++;
    if(v == nullptr) {
        return 0;
    }
    if(L <= v->min && v->max <= R){
        return v->count;
    }
    if(v->max < L || R < v->min){
        return 0;
    }
    int res = 0;
    if(L <= v->key && v->key <= R) {
        res += 1;
    }
    res += lookup(v->left, L, R);
    res += lookup(v->right, L, R);
    return res;
}

info *mas;
node *tree;

node* maketree(int ind) {
    if(ind == 0) {
        return nullptr;
    }
    node *x = new node;
    x->key = mas[ind-1].ki;
    //cout << x->key << endl;
    x->left = maketree(mas[ind-1].li);
    x->right = maketree(mas[ind-1].ri);
    x->count = 0;
    x->max = -1;
    x->min = INT32_MAX;
    return x;
}

void watchtree(node *rut) {
    if(rut == nullptr) {
        //cout << "NULL";
        return;
    }
    //cout << rut->key;
    //cout << rut->count << endl;
    watchtree(rut->left);
    //cout << "rig";
    watchtree(rut->right);
}

int most_left(node *ptr){
    while(ptr->left != nullptr) {
        ptr = ptr->left;
    }
    return ptr->key;
}

int most_right(node *ptr){
    while(ptr->right != nullptr) {
        ptr = ptr->right;
    }
    return ptr->key;
}

int count_nodes(node *ptr) {
    if(ptr == nullptr)
        return 0;
    ptr->max = most_right(ptr);
    ptr->min = most_left(ptr);
    ptr->count = count_nodes(ptr->left) + count_nodes(ptr->right) + 1;
    return count_nodes(ptr->left) + count_nodes(ptr->right) + 1;
}

int main() {
    node *bintr;
    int countnodes;
    cin >> countnodes;
    mas = new info[countnodes];

    int li, ri, ki;
    for(int i = 0; i < countnodes; i++) {
        cin >> li >> ri >> ki;
        mas[i].li = li;
        mas[i].ri = ri;
        mas[i].ki = ki;
    }

    tree = maketree(1);
    tree->count = count_nodes(tree);
    watchtree(tree);

    int nq;
    cin >> nq;
    for(int i = 0; i < nq; i++) {
        int L, R;
        cin >> L >> R;
        num = 0;
        lookup(tree, L, R);
        cout << num << endl;
    }
}
