#include <bits/stdc++.h>
using namespace std;
typedef int64_t i64;

string brute(int n, vector<int> a) {
    string ans;
    vector<int> f(n);
    for (int i = 0; i < n; i++) {
        f[i] = 0;
        for (int j = i - 1; j >= 0; j--) {
            f[j] = 0;
            for (int k = 1; k <= 8; k++) {
                if (j + k > i) {
                    break;
                }
                if (k <= 8 - __builtin_popcount(a[j] ^ a[j + k]) && !f[j + k]) {
                    f[j] = 1;
                    break;
                }
            }
        }
        ans.push_back(f[0] ? '1' : '2');
    }
    return ans;
}

string solve(int n, vector<int> a) {
    vector<vector<int>> f(n, vector<int>(1 << 8));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < (1 << 8); j++) {
            for (int k = 1; k <= 8; k++) {
                if (i + k >= n) {
                    break;
                }
                if (k <= 8 - __builtin_popcount(a[i] ^ a[i + k]) && !(j & (1 << (k - 1)))) {
                    f[i][j] = 1;
                    break;
                }
            }
        }
    }
    vector<vector<int>> g(n, vector<int>(1 << 8));
    g[0] = f[0];
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < (1 << 8); j++) {
            int mj = f[i][j] + (j & 0b1111111) * 2;
            g[i][j] = g[i - 1][mj];
        }
    }
    string ans;
    for (int i = 0; i < n; i++) {
        ans.push_back(g[i][0b11111111] ? '1' : '2');
    }
    return ans;
}

int main() {
#ifdef LOCAL_TESTING
    freopen("input.txt", "rt", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < 8; j++) {
            a[i] |= int(s[j] == 'R') << j;
        }
    }
    string ans = solve(n, a);
    cout << ans << endl;
#ifdef LOCAL_TESTING
    string bans = brute(n, a);
    cout << bans << endl;
    assert(ans == bans);
#endif
    return 0;
}
