#include <bits/stdc++.h>

using namespace std;

const int maxn = 300500;

using ll = long long;

vector<int> by[17][17][26];
string d[maxn];
int m[maxn];

int main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    string a, b;
    cin >> a >> b;
    int q;
    cin >> q;
    vector<int> ans(q);
    for (int j = 0; j < q; ++j) {
        string s;
        cin >> s;
        reverse(s.begin(), s.end());
        int mask = 0;
        for (int i = 0; i < s.length(); ++i) {
            by[s.length()][i][s[i] - 'A'].push_back(j);
            mask |= 1 << (s[i] - 'A');
        }
        d[j] = s;

//        mask ^= (1 << 26) - 1;
        m[j] = mask;
    }

    set<char> ch;
    for (char c : a) ch.insert(c);
    for (char c : b) ch.insert(c);
    vector<char> v(ch.begin(), ch.end());
    vector<int> cnt(10);
    for (int i = 0; i < 10; ++i) {
        cnt[i] = i;
    }
    vector<int> pos(256, -1);
    for (int i = 0; i < v.size(); ++i) {
        pos[v[i]] = i;
    }
    vector<int> last;
    map<int, int> masks;
    map<int, int> masks3;
    do {
        vector<int> va(a.size());
        vector<int> vb(b.size());
        for (int i = 0; i < a.size(); ++i) {
            va[i] = cnt[pos[a[i]]];
        }
        for (int i = 0; i < b.size(); ++i) {
            vb[i] = cnt[pos[b[i]]];
        }
        if (va[0] == 0 || vb[0] == 0) {
            continue;
        }
        if (last.size() > 0) {
            bool ok = false;
            for (int j = 0; j < v.size(); ++j) {
                if (last[j] != cnt[j]) {
                    ok = true;
                }
            }
            if (!ok) {
                continue;
            }
        }
        last = cnt;

        vector<int> has(10, false);
        vector<char> symb(10);
        for (int j = 0; j < v.size(); ++j) {
            has[cnt[j]] = true;
            symb[cnt[j]] = v[j];
        }

        reverse(va.begin(), va.end());
        reverse(vb.begin(), vb.end());
        vector<int> vc(max(va.size(), vb.size()) + 1);
        for (int i = 0; i < va.size() || i < vb.size(); ++i) {
            if (i < va.size()) vc[i] += va[i];
            if (i < vb.size()) vc[i] += vb[i];
            if (vc[i] >= 10) {
                vc[i + 1]++;
                vc[i] %= 10;
            }
        }
        while (vc.size()> 0 && vc.back() == 0) {
            vc.pop_back();
        }
        int len = vc.size();
        pair<int, int> best{-1, -1};
        for (int i = 0; i < vc.size(); ++i) {
            int d = vc[i];
            if (!has[d]) {
                continue;
            }
            char c = symb[d];
            if (c == 0) {
//                cerr << d << ' ' << has[d] << endl;
                return 0;
            }
            if (best.first == -1 || by[len][i][c - 'A'].size() < by[len][best.first][best.second].size()) {
                best = {i, c - 'A'};
            }
        }
//        cout << best.first << ' ' << best.second << endl;
        if (best.first != -1) {
            for (int index : by[len][best.first][best.second]) {
                if (ans[index] >= 2) {
                    continue;
                }
                bool ok = true;
                map<char, set<int>> q;
                for (int j = 0; j < d[index].size(); ++j) {
                    int p = pos[d[index][j]];
                    if (p == -1) {
                        q[d[index][j]].insert(vc[j]);
                        continue;
                    }
                    int need = cnt[p];
                    if (vc[j] != need) {
                        ok = false;
                        break;
                    }
                }
                for (const auto& z : q) if (z.second.size() > 1) ok = false;
                if (ok) {
                    ans[index]++;
                }
            }
        } else {
            masks[len]++;
            for (char c : v) {
                masks3[len] |= 1 << (c - 'A');
            }
        }
    } while (next_permutation(cnt.begin(), cnt.end()));

    for (auto z: masks) {
        int len = z.first;
        for (int i = 0; i < q; ++i) {
            if (masks3[len] & m[i]) {
                continue;
            }
            ans[i] += masks[len];
        }
    }

    for (int i = 0; i < q; ++i) {
        if (ans[i] == 1) {
            string s = d[i];
            reverse(s.begin(), s.end());
            cout << s << '\n';
        }
    }
    return 0;
}
