def gcd(a, b):
    if b == 0:
        return a
    else:
        return gcd(b, a % b)

class solution:
    def __init__(self, a=0, b=0):
        self.x = a
        self.y = b

def eu (a, b, sol):
    if a == 0:
        sol.x = 0
        sol.y = 1
        return b
    sol2 = solution()
    d = eu (b%a, a, sol2)
    sol.x = sol2.y - (b // a) * sol2.x
    sol.y = sol2.x
    return d


def find_any_solution (a, b, c, sol):
    g = eu(abs(a), abs(b), sol)
    if c % g != 0:
        return -1
    sol.x *= c // g
    sol.y *= c // g
    if (a < 0):
        sol.x *= -1
    if (b < 0):
        sol.y *= -1
    return g


def shift_solution (sol, a, b, cnt):
    sol.x += cnt * b
    sol.y -= cnt * a


def find_all_solution(a, b, c, minx, maxx, miny, maxy):
    sol = solution()
    g = find_any_solution(a, b, c, sol)
    if g == -1:
        return (-1, -1)

    a //= g
    b //= g

    sign_a = 1
    if a < 0:
        sign_a = -1
    sign_b = 1
    if b < 0:
        sign_b = -1

    shift_solution(sol, a, b, (minx - sol.x) // b)
    if sol.x < minx:
        shift_solution (sol, a, b, sign_b)
    if sol.x > maxx:
        return (-1, -1, 0)
    lx1 = sol.x

    shift_solution (sol, a, b, (maxx - sol.x) // b)
    if sol.x > maxx:
        shift_solution (sol, a, b, -sign_b)
    rx1 = sol.x

    shift_solution (sol, a, b, - (miny - sol.y) // a)
    if sol.y < miny:
        shift_solution (sol, a, b, -sign_a)
    if sol.y > maxy:
        return (-1, -1, 0)
    lx2 = sol.x

    shift_solution (sol, a, b, - (maxy - sol.y) // a)
    if sol.y > maxy:
        shift_solution (sol, a, b, sign_a)
    rx2 = sol.x

    if lx2 > rx2:
        lx2, rx2 = rx2, lx2
    lx = max (lx1, lx2)
    rx = min (rx1, rx2)

    if lx > rx:
        return (-1, -1, 0)
    cc = (rx - lx) // b + 1
    return (lx, rx, cc)

def solve():
    b, d = map(int, input().split())
    (l, r, cc) = find_all_solution(d, b, b ** 2, 1, 2 * 10**18, 1, 2 * 10**18)
    print(cc)

n = int(input())

for i in range(n):
    solve()