#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")

// hloya template v26

// ░░░░░░░▄▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▄░░░░░░
// ░░░░░░█░░▄▀▀▀▀▀▀▀▀▀▀▀▀▀▄░░█░░░░░
// ░░░░░░█░█░▀░░░░░▀░░▀░░░░█░█░░░░░
// ░░░░░░█░█░░░░░░░░▄▀▀▄░▀░█░█▄▀▀▄░
// █▀▀█▄░█░█░░▀░░░░░█░░░▀▄▄█▄▀░░░█░
// ▀▄▄░▀██░█▄░▀░░░▄▄▀░░░░░░░░░░░░▀▄
// ░░▀█▄▄█░█░░░░▄░░█░░░▄█░░░▄░▄█░░█
// ░░░░░▀█░▀▄▀░░░░░█░██░▄░░▄░░▄░███
// ░░░░░▄█▄░░▀▀▀▀▀▀▀▀▄░░▀▀▀▀▀▀▀░▄▀░
// ░░░░█░░▄█▀█▀▀█▀▀▀▀▀▀█▀▀█▀█▀▀█░░░
// ░░░░▀▀▀▀░░▀▀▀░░░░░░░░▀▀▀░░▀▀░░░░

#include <bits/stdc++.h>
using namespace std;

bool dbg = 0;

clock_t start_time = clock();
#define current_time fixed<<setprecision(6)<<(ld)(clock()-start_time)/CLOCKS_PER_SEC

#define f first
#define s second
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(), (v).end()
#define sz(v) ((int)(v).size())
#define sqr(x) ((x) * (x))

#define ull unsigned long long
#define ll long long
#define ld long double
#define pii pair<int,int>
#define umap unordered_map<int, int>

#define files1 freopen("decomposable.in","r",stdin)
#define files2 freopen("decomposable.out","w",stdout)
#define files files1;files2
#define fast_io ios_base::sync_with_stdio(0);cin.tie(0)

// #define endl '\n'
#define ln(i,n) " \n"[(i) == (n) - 1]

void bad(string mes = "NO"){cout << mes;exit(0);}
void bad(int mes){cout << mes;exit(0);}

template<typename T>
string bin(T x, int st = 2){
    string ans = "";
    while (x > 0){
        ans += char('0' + x % st);
        x /= st;
    }
    reverse(ans.begin(), ans.end());
    return ans.empty() ? "0" : ans;
}

mt19937_64 mt_rand(
        chrono::system_clock::now().time_since_epoch().count()
);

template<typename T1, typename T2> inline bool upmax(T1& a, T2 b) { return (a < b ? (a = b, true) : false); }
template<typename T1, typename T2> inline bool upmin(T1& a, T2 b) { return (b < a ? (a = b, true) : false); }

// inline int popcount(int x){
//     int count = 0;
//     __asm__ volatile("POPCNT %1, %0;":"=r"(count):"r"(x):);
//     return count;
// }

template<typename T>
T input(){
    T ans = 0, m = 1;
    char c = ' ';

    while (!((c >= '0' && c <= '9') || c == '-')) {
        c = getchar();
    }

    if (c == '-')
        m = -1, c = getchar();
    while (c >= '0' && c <= '9'){
        ans = ans * 10 + (c - '0'), c = getchar();
    }
    return ans * m;
}

template<typename T>
T gcd (T a, T b) { while (b) { a %= b; swap (a, b); } return a; }

template<typename T> void read(T& a) { a = input<T>(); }
template<typename T> void read(T& a, T& b) { read(a), read(b); }
template<typename T> void read(T& a, T& b, T& c) { read(a, b), read(c); }
template<typename T> void read(T& a, T& b, T& c, T& d) { read(a, b), read(c, d); }

const int inf = 1e9 + 20;
const long double eps = 1e-15;
const ll llinf = 2e18 + 5;
const int maxn = 2e5 + 500;
const int mod = 258280327;

int l[maxn], r[maxn], k[maxn];

vector<pair<int, int>> rng;

int mn[maxn], mx[maxn];

void dfs(int v) {
    if (v == 0) {
        return;   
    }
    mn[v] = mx[v] = k[v];
    if (l[v] != 0) {
        dfs(l[v]);
        mn[v] = mn[l[v]];
    }
    if (r[v] != 0) {
        dfs(r[v]);
        mx[v] = mx[r[v]];
    }
}

void dfs2(int v, int p) {
    if (p != 0) {
        rng.push_back({mn[p], mx[p]});
    }
    if (v == 0) {
        return;
    }
    dfs2(l[v], v);
    dfs2(r[v], v);
}

vector<int> tree[(int)2e6];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v].push_back(rng[tl].s);
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v<<1, tl, tm);
    build(v<<1|1, tm + 1, tr);
    merge(all(tree[v<<1]), all(tree[v<<1|1]), back_inserter(tree[v]));
}

int get(int v, int tl, int tr, int l, int r, int x) {
    if (l > r) {
        return 0;
    }
    if (tl == l && tr == r) {
        int pp = upper_bound(all(tree[v]), x) - tree[v].begin();
        return pp;
    }
    int tm = (tl + tr) >> 1;
    return get(v<<1, tl, tm, l, min(r, tm), x) + get(v<<1|1, tm + 1, tr, max(l, tm + 1), r, x);
}

int main() {
    srand(time(0));
    // freopen("input.txt", "r", stdin);
    fast_io;

    int n;
    cin >> n;
    // n = 200000;

    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i] >> k[i];
        // if (i == n) {
        //     l[i] = 0;
        // } else {
        //     l[i] = i + 1;
        // }
        // r[i] = 0;
    }

    dfs(1);
    dfs2(1, 0);

    vector<pair<int, int>> rng2;
    for (auto [a, b] : rng) {
        rng2.emplace_back(b, a);
    }
    
    sort(all(rng));
    sort(all(rng2));

    build(1, 0, (int)rng.size() - 1);

    // return 0;
    
    int q;
    cin >> q;

    while (q--) {
        int l, r;
        cin >> l >> r;
        int ans = rng.size() + 1;

        {
            int ps = lower_bound(all(rng), mp(l, -inf)) - rng.begin();
            int cc = get(1, 0, rng.size() - 1, ps, rng.size() - 1, r);
            ans -= cc;
        }
        {
            // max < l
            int ps = lower_bound(all(rng2), mp(l, -inf)) - rng2.begin();
            int cc = ps;
            ans -= cc;
        }
        {
            // r < min
            int ps = upper_bound(all(rng), mp(r, inf)) - rng.begin();
            int cc = rng.size() - ps;
            ans -= cc;
        }

        cout << ans << "\n";
    }
    return 0;
} 