#include <bits/stdc++.h>

using namespace std;

struct Node
{
    bool fill=true;
    bool filled = false;
    int color;
    int ready_child = 0;
    bool push_fill = false;
};

Node nodes[40];
vector<int> answers;
vector<int> childs[40];

void add_answer(int v)
{
    answers.push_back(v);
    //cout << v << " ";
}

void move_one_step(int v)
{
    if (nodes[v].push_fill)
    {
        for (int u: childs[v])
        {
            nodes[u].filled = false;
            nodes[u].push_fill = true;
            if (nodes[u].color == 1)
                nodes[u].fill ^= 1;
        }
        nodes[v].push_fill = false;
    }

    if (nodes[v].fill)
    {
        if (nodes[v].color == 0)
        {
            nodes[v].color = 1;
            add_answer(v);
            if (childs[v].size() == 0)
                nodes[v].filled = true;
            return;
        }
        int iChild = 0;
        int u;
        while (iChild < childs[v].size())
        {
            u = childs[v][iChild];
            if (nodes[u].filled)
                iChild++;
            else
                break;
        }

        if (iChild != childs[v].size())
        {
            move_one_step(u);
            for (int i = 0; i < iChild; i++)
            {
                u = childs[v][i];
                nodes[u].filled = false;
                if (nodes[u].color == 1)
                {
                    nodes[u].fill ^= 1;
                }
                nodes[u].push_fill = true;
            }
        }

        nodes[v].filled = true;
        for (int u : childs[v])
            if (!nodes[u].filled)
                nodes[v].filled = false;
    }
    else
    {
        int u;
        int iChild = 0;
        while (iChild < childs[v].size())
        {
            u = childs[v][iChild];
            if (nodes[u].filled)
                iChild++;
            else
                break;
        }

        if (iChild != childs[v].size())
        {
            move_one_step(u);
            for (int i = 0; i < iChild; i++)
            {
                u = childs[v][i];
                nodes[u].filled = false;
                if (nodes[u].color == 1)
                {
                    nodes[u].fill ^= 1;
                }
                nodes[u].push_fill = true;
            }
        }
        else
        {
            nodes[v].color = 0;
            nodes[v].filled = true;
            add_answer(v);
            nodes[v].fill ^= 1;
        }
    }
}

int main()
{
    //ios_base::sync_with_stdio(false); cin.tie(0);

    int n;
    cin >> n;
    for (int i = 2; i <= n; i++)
    {
        int v;
        cin >> v;
        childs[v].push_back(i);
    }

    nodes[1].color = 1;
    while (!nodes[1].filled)
    {
        move_one_step(1);
    }

    //cout << "\n";
    cout << answers.size() << "\n";
    for (int val : answers)
        cout << val << " ";

    return 0;
}
