#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <random>
#include <algorithm>
#include <functional>
#include <deque>

typedef long long int int64;
typedef unsigned long long int uint64;

using namespace std;

vector<vector<int>> tree;

vector<int> func(int root) {
    vector<int> res1, res2;
    for (int ch : tree[root]) {
        res2.insert(res2.end(), res1.begin(), res1.end());
        res2.push_back(ch);
        res2.insert(res2.end(), res1.begin(), res1.end());
        int dir = 1;
        for (int ch2 : func(ch)) {
            res2.push_back(ch2);
            if (++dir & 1)
                res2.insert(res2.end(), res1.begin(), res1.end());
            else
                res2.insert(res2.end(), res1.rbegin(), res1.rend());
        }
        res1.clear();
        swap(res1, res2);
    }
    return res1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    tree.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        tree[p - 1].push_back(i);
    }

    vector<int> res = func(0);
    cout << res.size() << endl;
    for (int i : res) {
        cout << i + 1 << ' ';
    }
    return 0;
}