﻿#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <vector>
#include <cmath>
using namespace std;

int price;
string s;
int i, t, tt, n;
int res = 0;
int res_price = INT32_MAX;
int two, one, zero;
int v;
bool f = 1;

struct node {
    char key = 1;
    int n = 0;
    node* l = NULL;
    node* r = NULL;
    int wl = 0;
    int wr = 0;

    node(char c, int nn) {
        key = c;
        n = nn;
    }

    int delta() {
        int d = abs(wl - wr);
        if(l)
            d = max(d, l->delta());
        if(r)
            d = max(d, r->delta());
        return d;
    }

    void  push(const char x, const int m) {
        if (l == NULL) {
            l = new node(x, m);
            wl += x;
        }
        else if (r == NULL)
        {
            r = new node(x, m);
            wr += x;
        }
        else        
        if (wl < wr) {
            l->push(x, m);
            wl += x;
        }
        else {
            r->push(x, m);
            wr += x;
        }
        //return abs(wl - wr);
    }

    void print() {

        cout << (int)key << ' ';
        if (l) {
            cout << l->n << ' ';
        }
        else
            cout << 0 << ' ';

        if (r)
            cout << r->n << ' ';
        else
            cout << 0 << ' ';


        cout << endl;
        if (l) {
            l->print();
        }

        if (r)
            r->print();
    }
        
};

int a, b;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    cin >> a >> b;
    int n = 1;
    node *root;
    if (b)
    {
        root = new node(2, n++);
        b--;
    }
    else
    {
        root = new node(1, n++);
        a--;
    }
        
    while (b--) {
        root->push(2, n);
        n++;
    }
    while (a--) {
        root->push(1, n);
        n++;
    }

    if (root->delta() > 1)
        cout << -1 << endl;
    else
    {
        root->print();
    }

    return 0;
}
