﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

long binpow(int temp, int pow)
{
    if (pow == 0) return 1;
    else
    {
        if (pow % 2 == 1) return temp * binpow(temp, pow - 1);
        else
        {
            long b = binpow(temp, pow / 2);
            return b * b;
        }
    }
}

int main()
{
    vector<int> simple;
    int a, b, c, n;
    cin >> a >> b >> c >> n;
    long r = binpow(10, 9) +(long) 7;
    simple.resize(a * (n - 1) * (n - 1) + (n - 1) * b + c);
    for (int i = n - 1; i >= 0; --i)
    {
        int me = (a * i * i + b * i + c);
        int div = 2;
        while (me > 1)
        {
            while (me % div == 0)
            {
                simple[div - 1]++;
                me = me / div;
            }
            div++;
        }
    }
    long long answer = 1;
    for (int i = 0; i < simple.size(); ++i)
    {
        if (simple[i] >= 2)
            answer *= binpow(i + 1, simple[i] - (simple[i]% 2));
    }
    answer = answer % r;
    cout << answer;
}
