#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

const int dd = (int)2e5 + 7;
int L[dd], R[dd], V[dd];
int S[dd], cnt[dd];
int can[dd];

int nv = 0;
int newv() {
    int cur = nv++;
    L[cur] = -1, R[cur] = -1;
    V[cur] = 1, S[cur] = 1;
    cnt[cur] = 1;
    can[cur] = 1;
    return cur;
}

int build(int sz) {
    int v = newv();

    int a = (sz - 1) / 2;
    int b = (sz - 1) - a;

    if (a > 0) {
        L[v] = build(a);
        S[v] += S[L[v]];
        cnt[v] += cnt[L[v]];
    }
    if (b > 0) {
        R[v] = build(b);
        S[v] += S[R[v]];
        cnt[v] += cnt[R[v]];
    }
    return v;
}

bool put(int v) {
    if (cnt[v] * 2 == S[v]) return false;

    if (L[v] != -1 && R[v] != -1) {
        int to = -1;
        if (can[L[v]] && S[L[v]] <= S[R[v]]) {
            to = L[v];
        } else if (can[R[v]]) {
            to = R[v];
        }
        if (to != -1 && put(to)) {
            S[v]++;
            return true;
        }
    }
    if (V[v] == 1) {
        V[v]++;
        S[v]++;
        return true;
    }
    can[v] = 0;
    return false;
}

void solve(int a, int b) {

    int n = a + b;

    int root = build(n);

    for (int it = 0; it < b; it++) {
        if (!put(root)) {
            cout << "-1\n";
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << V[i] << " " << L[i] + 1 << " " << R[i] + 1 << "\n";
    }
}

void solve() {
    int a, b;
    while (cin >> a >> b) {
        solve(a, b);
    }
}