#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

bool global[26];
int local[26];

string transform(const string& s) {
    string ret;
    int lid = 0;
    for (char c : s) {
        if (global[c - 'A'])
            ret.push_back(c);
        else {
            if (local[c - 'A'] == -1)
                local[c - 'A'] = lid++;
            ret.push_back('a' + local[c - 'A']);
        }
    }
    for (char c : s)
        local[c - 'A'] = -1;
    return ret;
}

unordered_map<string, vector<string>> transformations(1e6);
unordered_map<string, int> solutions(1e6);

string a, b, gls;
int anss[26];
char rev_anss[10];
bool used[10];

ll value(const string& s) {
    ll ret = 0;
    for (char c : s) {
        ret *= 10;
        ret += anss[c - 'A'];
    }
    return ret;
}

int local_id[10];
string inverse_value(ll x) {
    memset(local_id, 0xff, sizeof(local_id));
    string ret;
    int lid = 0;
    while (x != 0) {
        ll d = x % 10;
        x /= 10;
        if (rev_anss[d] != (char)0xff)
            ret.push_back(rev_anss[d]);
        else {
            if (local_id[d] == -1)
                local_id[d] = lid++;
            ret.push_back('a' + local_id[d]);
        }
    }
    reverse(all(ret));
    for (char& c : ret) {
        if ('a' <= c && c <= 'z') {
            c = 'a' + (lid - 1 - (c - 'a'));
        }
    }
    return ret;
}

void gen(int i) {
    if (i == (int)gls.size()) {
        if (anss[a[0] - 'A'] == 0 || anss[b[0] - 'A'] == 0)
            return;
        ll av = value(a), bv = value(b);
        ll cv = av + bv;
        string c = inverse_value(cv);
        solutions[c]++;
        return;
    }
    forn(x, 10) {
        if (used[x])
            continue;
        used[x] = true;
        anss[gls[i] - 'A'] = x;
        rev_anss[x] = gls[i];
        gen(i + 1);
        rev_anss[x] = -1;
        anss[gls[i] - 'A'] = -1;
        used[x] = false;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // Code here:

    memset(local, 0xff, sizeof(local));
    memset(rev_anss, 0xff, sizeof(rev_anss));

    cin >> a >> b;
    for (char c : a) {
        if (!global[c - 'A'])
            gls.push_back(c);
        global[c - 'A'] = true;
    }
    for (char c : b) {
        if (!global[c - 'A'])
            gls.push_back(c);
        global[c - 'A'] = true;
    }

    if (gls.size() > 10) {
        cout << 0 << endl;
        return 0;
    }

    int n;
    cin >> n;
    forn(i, n) {
        string s;
        cin >> s;
        transformations[transform(s)].push_back(s);
    }

    gen(0);

    vector<string> ans;
    for (const auto& [k, v] : solutions) {
        if (v == 1) {
            for (string s : transformations[k])
                ans.emplace_back(move(s));
        }
    }

    cout << ans.size() << endl;
    for (const string& s : ans)
        cout << s << endl;

    return 0;
}
