#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXN = 2e5 + 10;

vector <int> kek[MAXN];
vector <int> gr[MAXN];

int dp[MAXN], key[MAXN];
int l[MAXN], r[MAXN], d[MAXN];

vector <int> all_vals;

int shit_between[MAXN];
int shit_depth[MAXN];

int sz = 0, n;

int tm = 0;
int tin[MAXN], tout[MAXN];

int find_all_vals(int v, int depth = 1) {
	if (v == -1)
		return 0;
	d[v] = depth;
	tin[v] = tm++;
	find_all_vals(l[v], depth + 1);
	if (shit_depth[sz] > depth) {
		shit_between[sz] = v;
		shit_depth[sz] = depth;
	}
	sz++;
	if (shit_depth[sz] > depth) {
		shit_between[sz] = v;
		shit_depth[sz] = depth;
	}
	all_vals.push_back(key[v]);
	find_all_vals(r[v], depth + 1);
	tout[v] = tm++;
	return sz;
}

int find_shit_between(int l, int l_1) {
	if (l + 1 < 1 or l + 1 > n - 1) {
		return -1;
	}
	return shit_between[l + 1];
}

int up[20][MAXN];

int find_lca(int x, int y) {
	if (d[x] > d[y])
		swap(x, y);
	if (tin[x] <= tin[y] && tout[y] <= tout[x]) {
		return x;
	}
	
	for (int k = 19; k >= 0; k--) {
		int x1 = up[k][x];
		if (!(tin[x1] <= tin[y] && tout[y] <= tout[x1]))
			x = x1;
	}
	return up[0][x];
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	
	ios_base::sync_with_stdio(false);
	
	cin >> n;
	int root = 0;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> key[i];
		l[i]--;
		r[i]--;
		if (l[i] != -1)
			up[0][l[i]] = i;
		if (r[i] != -1)
			up[0][r[i]] = i;
	}
	up[0][0] = 0;
	
	for (int k = 1; k < 20; k++)
		for (int i = 0; i < n; i++)
			up[k][i] = up[k - 1][up[k - 1][i]];
	
	for (int i = 0; i < MAXN; i++)
		shit_depth[i] = 3 * MAXN;
	
	find_all_vals(root);
	
	int q; cin >> q;
	for (int i = 0; i < q; i++) {
		int x, y; cin >> x >> y;
		int lft = lower_bound(all_vals.begin(), all_vals.end(), x) - all_vals.begin();
		int rght = upper_bound(all_vals.begin(), all_vals.end(), y) - all_vals.begin();
		
		int root1 = find_shit_between(lft - 1, lft);
		int root2 = find_shit_between(rght - 1, rght);
		
		int kek = 0;
		
		if (root1 != -1 && root2 != -1) {
			int lca = find_lca(root1, root2);
			kek = d[root1] + d[root2] - d[lca];
		} else if (root1 != -1) {
			kek = d[root1];
		} else if (root2 != -1) {
			kek = d[root2];
		} else {
			kek = 0;
		}
		cout << 1 + 2 * kek << endl;
	}
	
	
	return 0;
}
