def gcdex(a, b):
    if a == 0:
        return b, 0, 1
    d, x1, y1 = gcdex(b % a, a)
    x = y1 - (b // a) * x1
    y = x1
    return d, x, y


def diophantineEquation(a, b, c):
    sw = False
    if a > b:
        sw = True
        tmp = a
        a = b
        b = tmp
    g, x, y = gcdex(a, b)
    if sw:
        tmp = x
        x = y
        y = tmp
    if c % g > 0:
        return [-1]
    x *= c // g
    y *= c // g
    if a < 0:
        x *= -1
    if b < 0:
        y *= -1
    return [x, y, g]

n = int(input())

for i in range(n):
    b, d = map(int, input().split())
    sq = b ** 2
    ac = diophantineEquation(d, b, sq)
    if len(ac) == -1:
        print(0)
        continue
    a, c, g = ac[0], ac[1], ac[2]
    b //= g
    d //= g
    if a <= 0:
        x = -a + 1
        x = (x + b - 1) // b
        a += x * b
        c -= x * d
    x = (a - 1) // b
    a -= x * b
    c += x * d
    if (c <= 0):
        print(0)
        continue
    print((1 + (c - 1) // d))

