
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int mod = 1e9 + 7;

ll binpow(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

const int N = 1e5 + 5;

void solve() {
    int n;
    cin >> n;
    vector<int> last(N);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        int mx = 0;
        vector<int> a(k);
        for (int j = 0; j < k; j++) {
            cin >> a[j];
            mx = max(mx, last[a[j]] + 1);
        }
        for (int j = 0; j < k; j++) {
            last[a[j]] = mx;
        }
    }
    cout << *max_element(last.begin(), last.end()) << endl;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case " << tc << ": ";
        solve();
    }
    return 0;
}