#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#define __USE_MINGW_ANSI_STDIO 0
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <stdio.h>
#include <iomanip>
#include <set>
#include <string>
#include <map>
#include <math.h>
#include <queue>
#include <complex>
#include <ctime>
#include <list>
#include <stack>
#include <chrono>
#include <random>
#define ll long long
#define lll __int128
#define fi first
#define ld long double
#define se second
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vi vector<int>
#define vll vector<ll>
#define vii vector<vector<int>>
#define vvld vector<vector<ld>>
#define vvll vector<vector<ll>>
const ll MAXN = 2e5+10;
const ll INF = 1e9+10;
const ll mod = 1e9+7;
const ld eps = 1e-5;
using namespace std;

int cnt;

struct node {
    int left, right, key, min, max;
    node() {}
    node(int l, int r, int k) {
        left = l;
        right = r;
        key = k;
    }
};

vector<node> g;

void lookup(int v, int L, int R) {
    ++cnt;
    if (v == 0)
        return;
    if (L <= g[v].min && g[v].max <= R)
        return;
    if (g[v].max < L || R < g[v].min)
        return;
    // int res = 0;
    // if (L <= g[v].key && g[v].key <= R)
    // res += 1;
    // res += lookup(g[v].left, L, R);
    // res += lookup(g[v].right, L, R);
    lookup(g[v].left, L, R);
    lookup(g[v].right, L, R);
    // return res;
}

pair<int, int> minmax(int v) {
    if (g[v].left == 0)
        g[v].min = g[v].key;
    else
        g[v].min = minmax(g[v].left).first;

    if (g[v].right == 0)
        g[v].max = g[v].key;
    else
        g[v].max = minmax(g[v].right).second;

    return {g[v].min, g[v].max};
}

void solve(int tt) {
    int n;
    cin >> n;
    g.resize(n + 1);
    int l, r, k;
    for (int i = 1; i <= n; ++i) {
        cin >> l >> r >> k;
        g[i] = node(l, r, k);
    }
    minmax(1);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> l >> r;
        cnt = 0;
        lookup(1, l, r);
        cout << cnt << endl;
    }
}

int main(){
    srand(time(NULL));
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // #ifdef LOCAL
    // freopen("in","r",stdin);
    // freopen("out","w",stdout);
    // #endif
    int t;
    t = 1;
    // cin >> t;
    for(int i =0;i < t;i++)
        solve(i+1);
    return 0;
}