#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <sstream>
#include <random>
#include <climits>
#include <iomanip>
#include <queue>
#include <bitset>
#include <cctype>
#include <functional>
#include <complex>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <deque>
#include <numeric>
#include <assert.h>
using namespace std;

typedef long long li;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define correct(x,n) (((x) >= 0) && ((x) < n))
#define all(a) (a).begin(),(a).end()
#define rnd() (rand() + (RAND_MAX+1)*rand())

//#define x first
//#define y second

using vi = vector<li>;
using vptvi = vector<vi*>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;
//using Point = pair<li, li>;
//using Point = complex<li>;
using Point = complex<ld>;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vpi a;

	auto check = [](string s)
	{
		map<char, int> mp;
		forv(c, s)
			mp[c]++;
		if (!mp.count('1') || mp['1'] < 1)
			return 0;
		if (!mp.count('0') || mp['0'] < 1)
			return 0;
		if (!mp.count('2') || mp['2'] < 2)
			return 0;
		return 1;
	};

	forn(i, n)
	{
		int cost;
		string s;
		cin >> cost >> s;
		if (!check(s))
			continue;
		a.emplace_back(cost,i + 1);
	}
	if (a.empty())
	{
		cout << 0 << endl;
		return 0;
	}
	int res = (*min_element(all(a))).second;
	cout << res << endl;
}