///////////////////////////////     _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 100005;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

int a, b;
int timer = 0;

int w[N], l[N], r[N];

int ind[4 * N];
vector <int> vertex;

void solve(int cnt) {
    int h = 0;
    while ((1 << h) != (int)vertex.size()) {
        ++h;
    }

    ++h;
    ind[0] = 0;
    for (int i = 0; i < h; i++) {
        int x = (1 << i);
        for (int j = x; j < 2 * x; j++) {
            ind[j] = ind[j - x] ^ (1 << (h - i - 1));
        }
    }

    vector < pair<int, int> > mas;
    for (int j = 0; j < 2 * (int)vertex.size(); j++) {
        mas.push_back(make_pair(ind[j], j));
    }
    sort(mas.begin(), mas.end());

    int it = 0;
    while (cnt--) {
        int gag = mas[it].second;
        ++timer;
        w[timer] = 1;
        l[timer] = r[timer] = 0;

        if (gag % 2 == 0) {
            l[ vertex[gag / 2] ] = timer;
        } else {
            r[ vertex[gag / 2] ] = timer;
        }

        ++it;
    }
}

int main() {
    cin >> a >> b;

    int id = -1;
    for (int i = 20; i >= 0; i--) {
        if ((b >> i) & 1) {
            id = i;
            break;
        }
    }

    if (id != -1) {
        if (a + b < (1 << (id + 1)) - 1) {
            cout << -1 << endl;
            return 0;
        }

        a -= (1 << (id + 1)) - 1 - b;
        for (int i = 0; i <= id; i++) {
            if ((b >> i) & 1) {
                for (int j = 0; j < (1 << i); j++) {
                    ++timer;
                    w[timer] = 2;
                    l[timer] = 0;
                    r[timer] = 0;

                    if (timer % 2 == 0) {
                        l[timer / 2] = timer;
                    } else {
                        r[timer / 2] = timer;
                    }

                    if (i == id) {
                        vertex.push_back(timer);
                    }
                }
            } else {
                for (int j = 0; j < (1 << i); j++) {
                    ++timer;
                    w[timer] = 1;
                    l[timer] = 0;
                    r[timer] = 0;

                    if (timer % 2 == 0) {
                        l[timer / 2] = timer;
                    } else {
                        r[timer / 2] = timer;
                    }

                    if (i == id) {
                        vertex.push_back(timer);
                    }
                }
            }
        }
    } else {
        ++timer;
        w[timer] = 1;
        l[timer] = r[timer] = 0;

        a--;
        vertex.push_back(1);
    }

    while (a >= 2 * (int)vertex.size()) {
        a -= 2 * (int)vertex.size();

        vector <int> v;
        for (int i = 0; i < (int)vertex.size(); i++) {
            int gag = vertex[i];

            ++timer;
            w[timer] = 1;
            l[timer] = 0;
            r[timer] = 0;
            l[gag] = timer;
            v.push_back(timer);

            ++timer;
            w[timer] = 1;
            l[timer] = r[timer] = 0;
            r[gag] = timer;
            v.push_back(timer);
        }

        vertex = v;
    }

    if (a != 0) {
        solve(a);
    }

    for (int i = 1; i <= timer; i++) {
        printf("%d %d %d\n", w[i], l[i], r[i]);
    }
    return 0;
}
