///////////////////////////////     _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 35;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

string s1, s2;

int go[N];
bool used[N];
int inv[N];
vector <int> letters;

bool mark[N];
map <string, int> mp;
char lava[N];

void update() {
    if (go[ s1[0] - 'A' ] == 0 || go[ s2[0] - 'A' ] == 0) return ;

    long long a = 0;
    for (int i = 0; i < (int)s1.size(); i++) {
        a = a * 10ll + go[ s1[i] - 'A' ];
    }
    long long b = 0;
    for (int i = 0; i < (int)s2.size(); i++) {
        b = b * 10ll + go[ s2[i] - 'A' ];
    }
    a += b;


    for (int i = 0; i < 10; i++) {
        lava[i] = '-';
    }

    char ch = 'Z';
    string S = "";
    while (a) {
        if (used[a % 10] || lava[a % 10] != '-') {
            S += lava[a % 10] == '-' ? char('A' + inv[a % 10]) : lava[a % 10];
        } else {
            while (mark[ ch - 'A' ]) {
                ch--;
            }
            S += ch;
            lava[a % 10] = ch;
            ch--;
        }
        a /= 10;
    }
    reverse(S.begin(), S.end());

    mp[S]++;
}

void rec(int v) {
    if (v == (int)letters.size()) {
        update();
        return ;
    }

    for (int i = 0; i < 10; i++) {
        if (used[i]) continue;
        used[i] = true;
        go[ letters[v] ] = i;
        inv[i] = letters[v];
        rec(v + 1);
        used[i] = false;
    }
}

int main() {
    cin >> s1 >> s2;

    for (int i = 0; i < (int)s1.size(); i++) {
        letters.push_back(s1[i] - 'A');
        mark[ s1[i] - 'A' ] = true;
    }
    for (int i = 0; i < (int)s2.size(); i++) {
        letters.push_back(s2[i] - 'A');
        mark[ s2[i] - 'A' ] = true;
    }

    sort(letters.begin(), letters.end());
    letters.resize( unique(letters.begin(), letters.end()) - letters.begin() );

    if ((int)letters.size() > 10) {
        cout << 0 << endl;
        return 0;
    }

    rec(0);

    vector <string> answ;

    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;

        for (int i = 0; i < 26; i++) {
            lava[i] = '-';
        }

        char ch = 'Z';
        string S = "";
        for (int i = (int)s.size() - 1; i >= 0; i--) {
            if (mark[ s[i] - 'A' ] || lava[ s[i] - 'A' ] != '-') {
                S += (lava[ s[i] - 'A' ] == '-') ? s[i] : lava[ s[i] - 'A' ];
            } else {
                while (mark[ch]) {
                    ch--;
                }
                S += ch;
                lava[ s[i] - 'A' ] = ch;
                ch--;
            }
        }
        reverse(S.begin(), S.end());

        if (mp.find(S) != mp.end() && mp[S] == 1) {
            answ.push_back(s);
        }
    }

    cout << (int)answ.size() << endl;
    for (int i = 0; i < (int)answ.size(); i++) {
        cout << answ[i] << endl;
    }
    return 0;
}
