
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <list>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <queue>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

int gcd(int a, int b)
{
	return b ? gcd(b, a % b) : a;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	int n;
	cin >> n;
	std::set<int> ans;
	std::unordered_map<int, int> p;
	std::vector<std::vector<int>> v(n);
	for (int i = 0; i < n; ++i)
	{
		int k;
		cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; ++j)
		{
			cin >> v[i][j];
			p[v[i][j]] = 0;
		}
	}

	for (int i = n - 1; i >= 0; --i)
	{
		int max_num = 0;
		for (int j = 0; j < v[i].size(); ++j)
		{
			int cur = p[v[i][j]];
			if (cur > max_num)
			{
				max_num = cur;
			}
		}
		++max_num;
		ans.insert(max_num);
		for (int j = 0; j < v[i].size(); ++j)
		{
			p[v[i][j]] = max_num;
		}
	}

	cout << ans.size() << endl;
}