#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <stack>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <queue>
#include <bitset>

//#include "rubo.h"
#define MP make_pair
#define PB push_back
#define in int
#define ll long long
#define ull unsigned long long
#define vc vector
#define SQ(j) (j)*(j)
#define ch first
#define range second
//
//#define ld long double
#define dbl  double
#define pll pair<long long,long long>
#define pii pair<int,int>
#define sz(xxx) ((int)(xxx.size()))
#define all(j) j.begin(), j.end()
#define loop(xxx, yyy) for(int xxx = 0; xxx < yyy; xxx++)
//#define printf(fmt, ...) (0)
//#define HOME
//#define y0 ngacaleiebinvoaeu
//#define y1 gnarpipipaigare
#define j1 adsfndnasfafoasp

//#define printf(...) (0)
#define db(x) if(DEBUG) {cout << #x << " = " << x << endl;}
#define dbCont(x) if(DEBUG) {cout << #x << ": "; for(auto shun: x) cout << shun << ' '; cout<<endl;}


using namespace std;

template<class K, class V>
ostream &operator<<(ostream &out, pair<K, V> &elem) {
    out << "{" << elem.first << "," << elem.second << "}";
    return out;
}


const int N = 1000 * 1000 + 5;

int DEBUG = 0;

using namespace std;

ll gcd(ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_any_solution(ll a, ll b, ll c, ll &x0, ll &y0, ll &g) {
    g = gcd(abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0) x0 *= -1;
    if (b < 0) y0 *= -1;
    return true;
}

void shift_solution(ll &x, ll &y, ll a, ll b, ll cnt) {

    x += cnt * b;
    y -= cnt * a;
}

ll find_all_solutions(ll a, ll b, ll c, ll minx, ll maxx, ll miny, ll maxy) {
    db(a);
    db(b);
    db(c);

    ll x, y, g;
    if (!find_any_solution(a, b, c, x, y, g))
        return 0;
    a /= g;
    b /= g;

    ll sign_a = a > 0 ? +1 : -1;
    ll sign_b = b > 0 ? +1 : -1;

    shift_solution(x, y, a, b, (minx - x) / b);
    if (x < minx)
        shift_solution(x, y, a, b, sign_b);
    if (x > maxx)
        return 0;
    ll lx1 = x;

    shift_solution(x, y, a, b, (maxx - x) / b);
    if (x > maxx)
        shift_solution(x, y, a, b, -sign_b);
    ll rx1 = x;

    shift_solution(x, y, a, b, -(miny - y) / a);
    if (y < miny)
        shift_solution(x, y, a, b, -sign_a);
    if (y > maxy)
        return 0;
    ll lx2 = x;

    shift_solution(x, y, a, b, -(maxy - y) / a);
    if (y > maxy)
        shift_solution(x, y, a, b, sign_a);
    ll rx2 = x;

    if (lx2 > rx2)
        swap(lx2, rx2);
    ll lx = max(lx1, lx2);
    ll rx = min(rx1, rx2);


//    for(ll x = lx1; x <= rx1; x+=b){
//        ll y = (c-a*x)/b;
//            printf("(%lld, %lld)\n",x,y);
//    }

    return (rx - lx) / abs(b) + 1;
}

ll brute(ll d, ll b) {
    ll ans = 0;
    for (ll a = 1; a <= 1e7; a++) {
//            if(a*b + d*c == b*b){

        if((b*b-a*b) % d == 0){
            ll c = (b*b-a*b)/d;
            if(c > 0) ans++;
        }
    }
    return ans;
}

ll solve(ll d, ll b){

    ll LIM = 1e17;
    ll ans = find_all_solutions(b, d, b * b, 1, LIM, 1, LIM );
    return ans;
}

ll stress(){
    while(1){
        cout << endl;
        ll b = rand()%5000+1;
        ll d = rand()%5000+1;
        cout << "b d " << b << ' ' << d << endl;

        ll slv = solve(b,d);
        ll brt = brute(b,d);
        db(slv);
        db(brt);

        if(slv != brt){
            cout << "HOOP" << endl;
            exit(0);
        }

    }
}

int main() {


//    cout << solve(74, 1659) << endl;
//    cout << brute(74, 1659) << endl;
//
//    stress();
//    exit(0);

    ll t;
    cin >> t;
    loop(i, t) {
        ll b, d;
        cin >> b >> d;
        cout << solve(d,b) << endl;

    }
    return 0;
}


/*


1
74 1659

 b d 74 1659

4
1000000 1
9 6
40 60
60 40



 */



