#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define _  << " " <<
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 200200;
pii g[N];
int mark[N];
int maxv = 0;

bool build(int v, int a, int b) {

    if (a == 0 && b == 0)
        return true;
    if (a == 0 && b == 1) {
        mark[v] = 2;
        maxv = max(maxv, v);
        return true;
    }
    if (b == 0 && a == 1) {
        mark[v] = 1;
        maxv = max(maxv, v);
        return true;
    }
    if (b && b % 2 || a == 0) {
        mark[v] = 2;
        b--;
    }
    else {
        mark[v] = 1;
        a--;
    }
    maxv = max(maxv, v);

    int l1 = 0, r1 = 0, l2 = 0, r2 = 0;
    l2 = b / 2; r2 = b - l2;
    if (l2 < r2 && a) {
        l1 = 1;
        a--;
    }
    int d = a / 2;
    l1 += a - d; r1 += d;

    bool ok = (abs(2 * l2 + l1 - 2 * r2 - r1) <= 1);
    if (l1 + l2) {
        g[v].ff = v + 1;
        ok &= (build(v + 1, l1, l2));
    }
    if (r1 + r2) {
        g[v].ss = maxv + 1;
        ok &= (build(maxv + 1, r1, r2));
    }

    return ok;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << sp(10);

#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    int a, b;
    cin >> a >> b;

    int n = a + b;
    if (!build(1, a, b)) {
        cout << -1 << endl;
    }
    else {
        for (int i = 1; i <= n; i++) {
            cout << mark[i] _ g[i].ff _ g[i].ss << endl;
        }
    }

#ifdef LOCAL_DEBUG
    cerr << "Execution time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s.\n";
#endif

    return 0;
}
