#include <iostream>
#include <iterator>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::size_t n;
  std::cin >> n;
  std::unordered_map<std::size_t, std::size_t> max_sign_seen;
  for (std::size_t i = 0; i < n; ++i) {
    std::size_t k;
    std::cin >> k;

    std::size_t max_seen = 0;
    std::vector<std::size_t> day(k);
    for (std::size_t j = 0; j < k; ++j) {
      std::size_t h;
      std::cin >> h;
      max_seen = std::max(max_seen, max_sign_seen[h]);
      day[j] = h;
    }

    for (const auto &it: day) {
      max_sign_seen[it] = max_seen + 1;
    }
  }
  std::size_t max_seen = 0;
  for (const auto &[key, value]: max_sign_seen) {
    max_seen = std::max(max_seen, value);
  }
  std::cout << max_seen;
  return 0;
}
