#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_set>

#define ll long long

using namespace std;

/*
5
1 1
2 1 2
1 2
1 2
1 1

 7
 1 1
 1 2
 1 1
 1 2
 1 1
 1 2
 1 1
 */

int main() {
    int days; cin >> days;
    vector<vector<int>> people(1e5 + 1);
    for (int i = 0; i < days; ++i) {
        int n; cin >> n;
        for (int j = 0; j < n; ++j) {
            int t; cin >> t;
            people[t].push_back(i);
        }
    }

    vector<int> ans(days);
    for (int i = 0; i < people.size(); ++i) {
        for (int j = 0; j < people[i].size(); j++) {
            if (j == 0) {
                ans[people[i][j]] = max(1, ans[people[i][j]]);
            } else {
                ans[people[i][j]] = max(ans[people[i][j]], ans[people[i][j - 1]] + 1);
            }

        }
    }

    unordered_set<int> m;
    for (int i = 0; i < ans.size(); ++i) {
        if (ans[i] == 0) ans[i] = 1;
        m.insert(ans[i]);
    }

    cout << m.size();
//    vector<int> ps(1e5 + 1, 0);
//    vector<int> day(days);
//    for (int i = 0; i < days; ++i) {
//        int n; cin >> n;
//        for (int j = 0; j < n; ++j) {
//            int people; cin >> people;
//            ps[people]++;
//            day[i] = max(day[i], ps[people]);
//        }
//    }
    return 0;
}