#include <bits/stdc++.h>
#define ll long long
using namespace std;

int tree[400001];
int treeIndxs[400001];

void preOrder(int& indx, int v, int& bound) {
    if (v >= bound)
        return;
    if (tree[v] != 0)
        treeIndxs[v] = indx++;
    preOrder(indx, v * 2, bound);
    preOrder(indx, v * 2 + 1, bound);
}

void print(int v, int& bound) {
    if (v >= bound)
        return;
    if (tree[v] != 0) {
        //cout << treeIndxs[v] << " ";
        cout << tree[v] << " ";
        if (tree[v * 2] != 0) {
            cout << treeIndxs[v * 2] << " ";
        }
        else {
            cout << 0 << " "; 
        }
        if (tree[v * 2 + 1] != 0) {
            cout << treeIndxs[v * 2 + 1] << " ";
        }
        else {
            cout << 0 << " "; 
        }
        cout << endl;
    }
    print(v * 2, bound);
    print(v * 2 + 1, bound);
}

int main() {
 
    ios_base::sync_with_stdio(false);
    
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int A, B;
    cin >> A >> B;

    int l = 0;
    while ((1 << l) - 1 <= B) {
        l++;
    }

    l--;
    l = (1 << l);

    int twos = l - 1;
    int leftTwos = B - twos;

    if (l - leftTwos > A) {
        cout << -1;
        return 0;
    }

    int onesWithTwos = l - leftTwos;
    A -= onesWithTwos;
    int l1 = (l << 1);
    while(A > l1) {
        A -= l1;
        l1 <<= 1;
    }

    int lastRowOnes = A;

    //fill first twos
    for (int i = 1; i <= l - 1; i++) {
        tree[i] = 2;
    }

    int up = l * 2;
    for (int i = l, j = l + l / 2; i < l + l / 2 && j < up; i += 2, j+= 2) {
        if (leftTwos > 0) {
            leftTwos--;
            tree[i] = 2;
        }
        else {
            break;
        }
        if (leftTwos > 0) {
            leftTwos--;
            tree[j] = 2;
        }
    }
    for (int i = l + 1, j = l + l / 2 + 1; i < l + l / 2 && j < up; i += 2, j+= 2) {
        if (leftTwos > 0) {
            leftTwos--;
            tree[i] = 2;
        }
        else {
            break;
        }
        if (leftTwos > 0) {
            leftTwos--;
            tree[j] = 2;
        }
        else {
            break;
        }
    }
    //fill twos and ones
    for (int i = l; i < up; i++) {
        if (tree[i] != 2) {
            tree[i] = 1;
        }
    }
    //fill full ones
    for (int i = up; i < l1; i++) {
        tree[i] = 1;
    }
    //fill left ones
    l = l1;
    up = l * 2;
    leftTwos = lastRowOnes;
    for (int i = l, j = l + l / 2; i < l + l / 2 && j < up; i += 2, j+= 2) {
        if (leftTwos > 0) {
            leftTwos--;
            tree[i] = 1;
        }
        else {
            break;
        }
        if (leftTwos > 0) {
            leftTwos--;
            tree[j] = 1;
        }
    }
    for (int i = l + 1, j = l + l / 2 + 1; i < l + l / 2 && j < up; i += 2, j+= 2) {
        if (leftTwos > 0) {
            leftTwos--;
            tree[i] = 1;
        }
        else {
            break;
        }
        if (leftTwos > 0) {
            leftTwos--;
            tree[j] = 1;
        }
        else {
            break;
        }
    }
    int indx = 1;
    int curIndx = 1;
    preOrder(indx, 1, up);
    print(1, up);

    return 0;
}