#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <bitset>

#define ln '\n'
#define ll long long
#define ioio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define X first
#define Y second

const double pi = acos(-1.0);
const double eps = 1e-9;
const int INF = 1e9;

using namespace std;

set<int> intersec(set<int>a, set<int>b)
{
    set<int>ans;
    for (auto i : a)
    {
        if (b.count(i) > 0)
            ans.insert(i);
    }
    return ans;
}

set<int>setunion(set<int>a, set<int>b)
{
    set<int>ans;
    for (auto i : a)
        ans.insert(i);
    for (auto i : b)
        ans.insert(i);
    return ans;
}



void solve()
{
    int n;
    cin >> n;
    if (n == 0)
    {
        cout << 0;
        return;
    }
    vector<set<int>>v(n);
    for (int i = 0; i < n; ++i)
    {
        int m;
        cin >> m;
        for (int j = 0; j < m; ++j)
        {
            int t;
            cin >> t;
            v[i].insert(t);
        }
    }
    int ans = 1;
    set<int>lastt = v[0];
    for (int i = 1; i < n; ++i)
    {
        set<int>inter = intersec(lastt, v[i]);
        if (inter.size() == 0)
            lastt = setunion(v[i], lastt);
        else
        {
            ans++;
            lastt = v[i];
        }
    }
    cout << ans;
}



int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ioio;
    cout << fixed << setprecision(15);
    int n = 1;
    //cin >> n;
    for (int i = 0; i < n; ++i) {
        //cout << ln << "TEST NUMBER" << i + 1 << ln << ln;
        solve();
    }
}