#include <iostream>
#include <string>
#include <vector>
#include <array>
#include <utility>
#include <algorithm>
#include <map>

using namespace std;

vector<int> ToVect(string s)
{
	vector<int> a(s.length());
	for ( int i = 0; i < s.length(); ++i)
	{
		char c = s[i];
		a[i] = atoi(&c);
	}
	return a;
}


int main(void)
{
	int n;
	cin >> n;
	array<int,4> year = {0, 1, 2, 2};
	vector<pair<int, int>> a;
	
	int v = 1;
	while ( n--)
	{
		int p;
		string ch;
		cin >> p >> ch;
		vector<int> n = ToVect(ch);
		sort(n.begin(), n.end());
		int i = 0;
		for ( int j = 0; j < n.size(); ++j)
		{
			if ( i == 4 )
			{
				a.push_back(make_pair(p, v));
				break;
			}
			if ( n[j] == year[i] )
				i++;
		}
			
		v++;
	}

	int m = INT_MAX;
	int sol = 0;
	for ( auto i : a )
	{
		if ( m > i.first )
		{
			sol = i.second;
			m = i.first;
		}
	}

	cout << sol;

	return 0;
}