//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;


void debug_out()
{ cerr << endl; }

template<typename Head , typename... Tail>
void debug_out(Head H , Tail... T)
{
    cerr << "[" << H << "]";
    debug_out(T...);
}

#ifdef QWERTY
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

clock_t startTime;

double getCurrentTime()
{
    return (double) ( clock() - startTime ) / CLOCKS_PER_SEC;
}

#define ALL(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;

ll powmod(ll a , ll b)
{
    ll res = 1;
    a %= MOD;
    assert(b >= 0);
    for ( ; b ; b >>= 1 ) {
        if ( b & 1 ) res = res * a % MOD;
        a = a * a % MOD;
    }
    return res;
}

template<typename t1 , typename t2>
inline bool upmax(t1 &a , t2 b)
{
    if ( a < (t1) b ) {
        a = (t1) b;
        return true;
    } else return false;
}

template<typename t1 , typename t2>
inline bool upmin(t1 &a , t2 b)
{
    if ( a > (t1) b ) {
        a = (t1) b;
        return true;
    } else return false;
}

#define pii pair<int,int>
typedef vector<int> vi;
typedef vector<pair<int , int> > vpi;
#define N 21

int ans[1 << N];
vector<int> g[N];
int p[N];
int now = 0;

void dfs(int v)
{
    if ( v != 1 ) {
        ans[now++] = v;
        int j = now - 2;

        while (j >= 0 && ans[j] != p[v]) {
            ans[now++] = ans[j--];
        }
    }
    for ( auto x:g[v] ) {
        dfs(x);
    }
}

void solve(int TC)
{
    int n;
    cin >> n;
    for ( int i = 2 ; i <= n ; i++ ) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    dfs(1);
    cout << now << endl;
    for ( int i = 0 ; i < now ; i++ ) printf("%d ",ans[i]);
}

int main()
{
    startTime = clock();
#ifdef QWERTY
    freopen("input.txt" , "r" , stdin);
    freopen("output.txt" , "w" , stdout);
#endif
//    ios_base::sync_with_stdio(false);
    int T = 1;
//    cin >> T;
    for ( int i = 1 ; i <= T ; i++ ) {
        cerr << "Case #" << i << ":" << endl;
#ifdef QWERTY
        cout << "Case #" << i << ":" << endl;
#endif
        solve(T);
    }
    cerr << "Time: " << getCurrentTime() << " ms" << endl;
    return 0;
}
