#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("tune=native")
using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX_N = 100005;

int n;
vector<int> humanByPos[MAX_N];
vector<int> posByHuman[MAX_N];
int dp[MAX_N];

int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int k; cin >> k;
		humanByPos[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			cin >> humanByPos[i][j];
			posByHuman[humanByPos[i][j]].push_back(i);
		}
	}

	int maxDP = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		dp[i] = 0;
		for (int j : humanByPos[i])
		{
			auto it = upper_bound(posByHuman[j].begin(), posByHuman[j].end(), i);
			if (it == posByHuman[j].end())
				continue;
			dp[i] = max(dp[i], dp[*it]);
		}
		dp[i]++;
		maxDP = max(maxDP, dp[i]);
	}

	cout << maxDP << '\n';

	return 0;
}