#define _CRT_SECURE_NO_WARNINGS

#include <vector>
#include <iostream>
#include <string>
#include <functional>
#include <set>
#include <map>
#include <unordered_map>
#include <fstream>
#include <iomanip>
#include <ctime>
#include <queue>
#include <deque>
#include <math.h>
#include <cmath>
#include <stack>
#include <algorithm>
#include <list>
#include <array>
#include <valarray>
#include <unordered_map>
#include <cassert>
#include <random>
#include <cstring>
#include <sstream>
#include <numeric>
#include <iterator>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int((a).size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)
#define vec vector

typedef long long li;
typedef long long ll;
typedef long double ld;
typedef pair<ld, ld> pt;
typedef pair<int, int> pii;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B>& a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A>& v) {
	out << "[";
	forn(i, sz(v)) {
		if (i) out << ", ";
		out << v[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));

const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = INF + 7;
const ld EPS = 1e-7;
const ld PI = acos(-1.0);
//const li MOD = 100055128505716009;
//const li P = 3e4 + 11;

li gcd(li a, li b, li& x, li& y) {
	if (a == 0) {
		x = 0;
		y = 1;
		return b;
	}

	li x1, y1;
	li d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(li a, li b, li c, li& x0, li& y0, li& g) {
	g = gcd(abs(a), abs(b), x0, y0);

	if (c % g != 0) {
		return false;
	}

	x0 *= c / g;
	y0 *= c / g;

	if (a < 0) { 
		x0 *= -1; 
	}
	if (b < 0) {
		y0 *= -1;
	}

	return true;
}

void shift_solution(li& x, li& y, li a, li b, li cnt) {
	x += cnt * b;
	y -= cnt * a;
}

li find_all_solutions(li a, li b, li c, li minx, li maxx, li miny, li maxy) {
	li x, y, g;
	if (!find_any_solution(a, b, c, x, y, g)) {
		return 0;
	}
	//cout << x << ' ' << y << ' ' << g << endl;
	a /= g;  b /= g;

	li sign_a = (a > 0 ? +1 : -1);
	li sign_b = (b > 0 ? +1 : -1);

	shift_solution(x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution(x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	li lx1 = x;

	shift_solution(x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution(x, y, a, b, -sign_b);
	li rx1 = x;

	shift_solution(x, y, a, b, -(miny - y) / a);
	if (y < miny)
		shift_solution(x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	li lx2 = x;

	shift_solution(x, y, a, b, -(maxy - y) / a);
	if (y > maxy)
		shift_solution(x, y, a, b, sign_a);
	li rx2 = x;

	if (lx2 > rx2)
		swap(lx2, rx2);
	li lx = max(lx1, lx2);
	li rx = min(rx1, rx2);
		
	//cout << rx << ' ' << lx << endl;
	return (rx - lx) / abs(b) + 1;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int tt = clock();
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;

	// SOLUTION GOES HERE

	int n;
	cin >> n;

	forn(i, n) {
		li b, d;
		cin >> b >> d;

		cout << find_all_solutions(d, b, b * b, 1, 10 * INF, 1, 10 * INF) << '\n';
	}

	// SOLUTION ENDS HERE


#ifdef _DEBUG 
	cout << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif
}