#define _CRT_SECURE_NO_WARNINGS

#include <vector>
#include <iostream>
#include <string>
#include <functional>
#include <set>
#include <map>
#include <unordered_map>
#include <fstream>
#include <iomanip>
#include <ctime>
#include <queue>
#include <deque>
#include <math.h>
#include <cmath>
#include <stack>
#include <algorithm>
#include <list>
#include <array>
#include <valarray>
#include <unordered_map>
#include <cassert>
#include <random>
#include <cstring>
#include <sstream>
#include <numeric>
#include <iterator>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int((a).size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)
#define vec vector

typedef long long li;
typedef long long ll;
typedef long double ld;
typedef pair<ld, ld> pt;
typedef pair<int, int> pii;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B>& a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A>& v) {
	out << "[";
	forn(i, sz(v)) {
		if (i) out << ", ";
		out << v[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));

const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = INF + 7;
const ld EPS = 1e-7;
const ld PI = acos(-1.0);
//const li MOD = 100055128505716009;
//const li P = 3e4 + 11;


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int tt = clock();
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;

	// SOLUTION GOES HERE

	int n;
	cin >> n;

	vector<vector<int>> ps(n);
	forn(i, n) {
		int k;
		cin >> k;

		ps[i] = vector<int>(k);
		forn(j, k) {
			cin >> ps[i][j];
		}
	}

	if (n == 0) {
		cout << 0 << endl;
		return 0;
	}

	int ans = 1;
	map<int, int> saw;
	for (int i = n - 1; i >= 0; --i) {
		int mx = -1;
		for (int x : ps[i]) {
			mx = max(mx, saw[x]);
		}
		if (mx == ans) {
			ans++;
		}
		mx++;
		for (int x : ps[i]) {
			saw[x] = mx;
		}
		//cout << mx << ' ' << ans << endl;
	}

	cout << ans << endl;

	// SOLUTION ENDS HERE


#ifdef _DEBUG 
	cout << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif
}