def bezout(a, b):
    x, xx, y, yy = 1, 0, 0, 1
    while b:
        q = a // b
        a, b = b, a % b
        x, xx = xx, x - xx*q
        y, yy = yy, y - yy*q
    return (x, y, a)

n = int(input())
for i in range(n):
    b, d = map(int, input().split())
    x, y, g = bezout(b, d)
    x *= b*b // g
    y *= b*b // g


    l = (x - 1) // (d // g)
    r = (y - 1) // (b // g)

    print(max(r + l + 1, -l - r + 1))