#include <bits/stdc++.h>
#pragma GCC optimize ("O3", "unroll-all-loops")
#pragma GCC target ("sse4.2")

using namespace std;

#define F first
#define S second
typedef long long       ll;
typedef long double     ld;
typedef pair<ll, ll>   pll; 
typedef pair<int, int> pii; 

ifstream in;
ofstream out;

const long long kk = 1000;
const long long ml = kk * kk;
const long long mod = ml * kk + 7;
const long long inf = ml * ml * ml + 7; 
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

ll n, C;
vector<string> v;
bool viv = false;
string s, t;
set<char> ss;
map<string, int> cnt;

bool inc(char c) {
	return (ss.find(c) != ss.end());
}

string pat(string s) {
	// cout << s << endl;
	string res = s;
	set<char> ls;
	for (auto i : s) {
		if (!inc(i)) 
			ls.insert(i);
	}
	map<char, char> to;
	char nxt = 'a';
	for (auto i : ls) {	
		to[i] = nxt;
		// cout << "\t\t" << i << ' ' << nxt << endl;
		nxt++;
	}
	for (auto &i : res)
		if (!inc(i))
			i = to[i];
	// cout << "See " << res << endl;
	return res;
}

void read() {
	cin >> n;
	v.resize(n);
	for (auto &s : v)
		cin >> s;
}

void work(string l) {
	unordered_map<char, char> num;
	vector<int> oo;
	for (int i = 0; i < 10; i++) {
		num[l[i]] = char('0' + i);
	}
	string vs = s, vt = t;
	for (auto &i : vs)
		i = num[i];
	for (auto &i : vt)
		i = num[i];
	if (viv) {
		C++;
		if (C > 10)
			exit(0);
	}
	if (vs[0] == '0' || vt[0] == '0')
		return;

	ll sv = stoi(vs);
	ll tv = stoi(vt);
	ll sum = sv + tv;

	string sums = to_string(sum);

	for (auto &i : sums)
		i = l[i - '0'];
	if (viv) {
		cout << s << ' ' << vs << endl;
		cout << t << ' ' << vt << endl;
		cout << sum << ": " << sums << '\n';
		cout << endl;
	}
	char mx = 'A';
	for (auto i : sums)
		mx = max(mx, i);
	string lft;
	for (auto i : l)
		if (i > mx)
			lft += i;
	bool need = true;
	for (int i = 1; i < lft.size(); i++)
		if (lft[i - 1] > lft[i])
			need = false;
	if (need)
		cnt[sums]++;
}

void solve() {
	cin >> s >> t;
	for (auto i : s)
		ss.insert(i);	
	for (auto i : t)
		ss.insert(i);	
	read();
	if (ss.size() > 10) {
		cout << "0\n";
		exit(0);
	}

	string l;
	for (auto i : ss)
		l += i;
	char nxt = 'a';
	while (l.size() < 10) {
		l += nxt;
		nxt++;
	}

	sort(l.begin(), l.end());
	work(l);
	while (next_permutation(l.begin(), l.end())) {
		work(l);
	}
	cout << "NICE" << endl;

	vector<string> ans;
	for (auto s : v) {
		cout << pat(s) << ' ' << cnt[pat(s)] << '\n';
		if (cnt[pat(s)] == 1)
			ans.push_back(s);
	}
	cout << ans.size() << '\n';
	for (auto i : ans)
		cout << i << '\n';
}

int main() {
	// viv = true;
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll t = 1; 
	// cin >> t;
	while (t--)
		solve();

	return 0;
}