#include <stdio.h>
#include <bits/stdc++.h>

typedef long long ll;

#define fi first
#define se second

using namespace std;

const int N = 1e5 + 10;

int w[N], l[N], r[N];
int id = 0;

int dfs(int A, int B) {
    if (A == 0 && B == 0) {
        return 0;
    }
    int v = ++id;

    if (A % 2 == 0 && B % 2 == 0) {
        if (A == 0) {
            if (B > 1) {
                return -1;
            } else {
                w[v] = 2;
                return id;
            }
        } else {
            w[v] = 1;
            l[v] = dfs(A / 2, B / 2);
            r[v] = dfs(A / 2 - 1, B / 2);
        }
    } else if (A % 2 == 1 && B % 2 == 0) {
        w[v] = 1;
        l[v] = dfs(A / 2, B / 2);
        r[v] = dfs(A / 2, B / 2);
    } else if (A % 2 == 0 && B % 2 == 1) {
        w[v] = 2;
        l[v] = dfs(A / 2, B / 2);
        r[v] = dfs(A / 2, B / 2);
    } else if (A % 2 == 1 && B % 2 == 1) {
        w[v] = 2;
        l[v] = dfs(A / 2 + 1, B / 2);
        r[v] = dfs(A / 2, B / 2);
    }

    if (l[v] == -1 || r[v] == -1) {
        return -1;
    }
    return v;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int A, B;
    cin >> A >> B;
    int root = dfs(A, B);
    if (root == -1) {
        cout << -1;
        return 0;
    }

    for (int i = 1; i <= id; ++i) {
        cout << w[i] << ' ' << l[i] << ' ' << r[i] << '\n';
    }

    return 0;
}
