#pragma GCC Optimaze("Ofast")
#pragma GCC taget("avx")

#include<bits/stdc++.h>
#define all(x) begin(x),end(x)
 
using namespace std;
 
using ll = long long;
using ld = long double;

const int N = 200200;

char mem_[450 * 1024 * 1024];
size_t _ptr = 0;
void* operator new(size_t cnt) {
    _ptr += cnt;
    return mem_ + _ptr - cnt;
}
void operator delete(void *) {}
 

vector<int> g[N];
int val[N];
int x[N];
int y[N];

void Dfs(int from) {
    x[from] = y[from] = val[from];
    for (int to : g[from]) {
        Dfs(to);
        x[from] = min(x[from], x[to]);
        y[from] = max(y[from], y[to]);
    }
}

using ui = int;
const int MVAL = 800800 + 100;

struct SegmentTree {
    struct Node {
        Node* left = nullptr;
        Node* right = nullptr;
        int cnt = 0;
        Node() {}
    };
    Node* root = new Node();
    SegmentTree() {}
    
    void Add(Node* v, ui tl, ui tr, ui index) {
        v->cnt++;
        if (tl + 1 < tr) {
            ui tm = (tl + tr) >> 1;
            if (index < tm) {
                if (v->left == nullptr) {
                    v->left = new Node();
                }
                Add(v->left, tl, tm, index);
            } else {
                if (v->right == nullptr) {
                    v->right = new Node();
                }
                Add(v->right, tm, tr, index);
            }
        }
    }
    
    int Get(Node* v, ui tl, ui tr, ui l, ui r) {
        if (!v || tl >= r || tr <= l) return 0;
        if (tl >= l && tr <= r) return v->cnt;
        int tm = (tl + tr) >> 1;
        return Get(v->left, tl, tm, l, r) + Get(v->right, tm, tr, l, r);
    }
};

struct SegmentTree2D {
    struct Node2D {
        Node2D* left = nullptr;
        Node2D* right = nullptr;
        SegmentTree* tree = nullptr; 
        Node2D() {
            tree = new SegmentTree();
        }
    };
    SegmentTree2D() {
    }
    Node2D* root = new Node2D();
    
    void Add(Node2D* v, ui tl, ui tr, ui x, ui y) {
        v->tree->Add(v->tree->root, 0, MVAL, y);
        if (tl + 1 < tr) {
            ui tm = (tl + tr) >> 1;
            if (x < tm) {
                if (v->left == nullptr) {
                    v->left = new Node2D();
                }
                Add(v->left, tl, tm, x, y);
            } else {
                if (v->right == nullptr) {
                    v->right = new Node2D();
                }
                Add(v->right, tm, tr, x, y);
            } 
        } 
    }
    int Get(Node2D* v, ui tl, ui tr, ui l, ui r, ui y1, ui y2) {
        if (!v || tl >= r || tr <= l) return 0;
        if (tl >= l && tr <= r) return v->tree->Get(v->tree->root, 0, MVAL, y1, y2);
        int tm = (tl + tr) >> 1;
        return Get(v->left, tl, tm, l, r, y1, y2) + Get(v->right, tm, tr, l, r, y1, y2);
    }
};


namespace FastIO {
    struct Reader {
    private:
        FILE* file; std::vector<char> buffer; int pos; bool was;
        void read() {
            if (!buffer.empty()) {
                buffer.resize(fread(&buffer[0], 1, (int)buffer.size(), file)); pos = 0; 
            }
        }
    public:
        Reader(FILE* file_ = stdin, const int size_ = 1 << 16)
            : file(file_), buffer(size_, '\0'), pos(size_), was(true) { }
        operator bool() const { return was; }
        char getChar() {
            if (pos == (int)buffer.size()) { read(); }
            if (pos == (int)buffer.size()) { was = false; return EOF; } 
            else { was = true; return buffer[pos++]; }
        }
        std::string getStr() {
            char c = ' ';
            while (std::isspace(c)) { c = getChar(); }
            std::string answ;
            while (c != EOF && !std::isspace(c)) { answ.push_back(c); c = getChar(); }
            was = !answ.empty();
            return answ;
        }
        std::string getLine() {
            char c = '\n';
            while (c == '\n') { c = getChar(); }
            std::string answ;
            while (c != '\n' && c != EOF) { answ.push_back(c); c = getChar(); }
            was = !answ.empty();
            return answ;
        }
        template<typename T> T getInt() {
            char c = '?';
            while (!(c == '-' || ('0' <= c && c <= '9') || c == EOF)) { c = getChar(); }
            bool positive = true;
            if (c == '-') { positive = false; c = getChar(); }
            T answ(0);
            bool flag = false;
            while ('0' <= c && c <= '9') { flag = true; (answ *= 10) += (c - '0'); c = getChar(); }
            was = flag;
            return positive ? answ : -answ;
        }
        template<typename T> T getReal() {
            bool flag = false;
            char c = '?';
            while (!(c == '-' || ('0' <= c && c <= '9') || c == EOF)) { c = getChar(); }
            bool positive = (c != '-');
            if (c == '-') { c = getChar(); }
            long long first = 0;
            while ('0' <= c && c <= '9') { flag = true; (first *= 10) += (c - '0'); c = getChar(); }
            was = flag;
            if (c != '.') { return T(positive ? first : -first); }
            c = getChar();
            long long second = 0, pow = 1;
            while ('0' <= c && c <= '9') { (second *= 10) += (c - '0'); c = getChar(); pow *= 10; }
            T answ = first + (T)second / (T)pow;
            return positive ? answ : -answ;
        }
    };
    
    Reader& operator>>(Reader& reader, char& c) { return c = reader.getChar(), reader; }
    
    Reader& operator>>(Reader& reader, std::string& s) { return s = reader.getStr(), reader; }
    
    template<class T> typename std::enable_if<std::is_floating_point<T>::value, Reader&>::type
    operator>>(Reader& reader, T& t) { return t = reader.getReal<T>(), reader; }
    
    template<class T> typename std::enable_if<std::is_integral<T>::value, Reader&>::type
    operator>>(Reader& reader, T& t) { return t = reader.getInt<T>(), reader; }
    
    template<class T> Reader& operator>>(Reader& reader, std::vector<T>& vec) {
        for (auto &it : vec) { reader >> it; }
        return reader;
    }
    
    struct Writer {
    private:
        FILE* file; std::vector<char> buffer; int pos;
        int defaultPrecision, defaultWidth; char defaultFill;
    public:
        Writer(FILE* file_ = stdout, const int size_ = 1 << 16) 
            : file(file_), buffer(size_, '\0'), pos(0), defaultPrecision(6), defaultWidth(0), defaultFill(' ') { }
        ~Writer() { flush(); }
        void flush() { putChar(EOF); }
        void setprecision(int precision) { defaultPrecision = precision; }
        void setw(int width) { defaultWidth = width; }
        void setfill(char fill) { defaultFill = fill; }
        int getPrecision() const { return defaultPrecision; }
        int getWidth() const { return defaultWidth; }
        char getFill() const { return defaultFill; }
        void putChar(char c) {
            if (pos == (int)buffer.size() || c == EOF) { 
                fwrite(&buffer[0], 1, pos, file); pos = 0; 
            }
            if (c != EOF) { buffer[pos++] = c; }
        }
        void putStr(const std::string& s) { for (auto it : s) putChar(it); }
        template<typename T> void putInt(T value, int width = 0, char fill = ' ') {
            bool positive = !(value < 0);
            if (value < 0) { value = -value; }
            char buf[24]; int p = 0;
            do { buf[p++] = char(value % 10 + '0'); value /= 10; } while (value > 0);
            if (!positive) { buf[p++] = '-'; }
            while (p < width) buf[p++] = fill;
            while (p > 0) putChar(buf[--p]);
        }
        template<typename T> void putReal(T value, int precision = 6, int width = 0, char fill = ' ') {
            putInt((long long)value, width - precision - 1, fill);
            value = std::abs(value-(long long)value);
            if (precision == 0) { return; }
            putChar('.');
            #define PRINT_PART(cnt, pow) \
                while (precision >= cnt) { \
                    value *= pow; \
                    putInt((int)value, cnt, '0'); \
                    value -= (int)value; \
                    precision -= cnt; \
                }
            PRINT_PART(6,1000000)
            PRINT_PART(3,1000)
            PRINT_PART(1,10)
            #undef PRINT_PART
        }
    };
    
    Writer& operator<<(Writer& writer, const char c) { return writer.putChar(c), writer; }
    
    Writer& operator<<(Writer& writer, const std::string& s) { return writer.putStr(s), writer; }
    
    template<class T> typename std::enable_if<std::is_floating_point<T>::value, Writer&>::type
    operator<<(Writer& writer, const T& t) {
        writer.putReal(t, writer.getPrecision(), writer.getWidth(), writer.getFill());
        return writer; 
    }
    
    template<class T> typename std::enable_if<std::is_integral<T>::value, Writer&>::type
    operator<<(Writer& writer, const T& t) { 
        writer.putInt(t, writer.getWidth(), writer.getFill());
        return writer;
    }
}

int main() {
    FastIO::Reader fin;
    FastIO::Writer fout; 
    int n;
    fin >> n;
    set<int> st;
    for (int i = 0; i < n; i++) {
        int f, t;
        fin >> f >> t;
        f--, t--;
        cin >> val[i];
        if (f >= 0) g[i].push_back(f);
        if (t >= 0) g[i].push_back(t);
    }

    Dfs(0);
    for (int i = 0; i < n; i++) {
        st.insert(x[i]);
        st.insert(y[i]);
    
    }
    int q;
    fin >> q;
    vector<pair<int,int>> qu(q);
    for (auto& [l, r] : qu) {
        fin >> l >> r;
        st.insert(l);
        st.insert(r);
    }
    
    {
        int itr = 0;
        map<int, int> mp;
        for (int val : st) mp[val] = itr++;
        for (int i = 0; i < n; i++) {
            x[i] = mp[x[i]];
            y[i] = mp[y[i]];
        }
        for (auto& [l, r] : qu) {
            l = mp[l];
            r = mp[r];
        }
    }
    
    
    SegmentTree2D* tree = new SegmentTree2D();
    
    for (int i = 0; i < n; i++) {
        tree->Add(tree->root, 0, MVAL, x[i], y[i]);
    }
    
    for (auto& [l, r] : qu) {
        int inside = tree->Get(tree->root, 0, MVAL, l, MVAL, 0, r + 1);
        int left = tree->Get(tree->root, 0, MVAL, 0, MVAL, 0, l);
        int right = tree->Get(tree->root, 0, MVAL, r + 1, MVAL, 0, MVAL);
        
        int cnt = n - inside - left - right;
        
        fout << cnt * 2 + 1 << '\n';
    }
    
    
    

}
