#include <bits/stdc++.h>

using namespace std;

vector<int> tree;
vector<int> newidx;

int treesz;

int dfs(int i)
{
  if (i >= treesz)
    return 0;
  int l = dfs(2 * i + 1), r = dfs(2 * i + 2);
  if (abs(l - r) > 1)
  {
    cout << -1;
    exit(0);
  }
  return l + r + tree[i];
}

void dfsans(int i)
{
  if (i > treesz || tree[i] == 0)
    return;
  cout << tree[i] << " ";
  for (int t = 2 * i + 1; t <= 2 * i + 2; t++)
  {
    if (t >= treesz || tree[t] == 0)
      cout << 0 << " ";
    else
      cout << newidx[t]  << " ";
  }
  cout << "\n";
}

int binpow(int a, int n)
{
  int res = 1;
  while (n)
  {
    if (n & 1)
      res *= a;
    a *= a;
    n >>= 1;
  }
  return res;
}

int mylog(int n)
{
  for (int i = 1;; ++i)
    if (binpow(2, i)-1 >= n)
      return binpow(2, i)-1;
}

int main()
{
  int a, b;
  cin >> a >> b;
  treesz = mylog(a + b);
  tree.resize(treesz);
  int lefta = a, leftb = b;
  auto pull_from_pool = [&]() {
    if (leftb > 0)
    {
      leftb--;
      return 2;
    }
    if (lefta > 0)
    {
      lefta--;
      return 1;
    }
    return 0;
  };

  for (int k = 0; binpow(2, k + 1) - 1 <= treesz; ++k)
  {
    vector<int> nodes;
    tree[binpow(2, k) - 1] = pull_from_pool();
    nodes.push_back(binpow(2, k) - 1);
    for (int step = k - 1; step >= 0; step--)
    {
      int ma_sz = nodes.size();
      for (int i = 0; i < ma_sz; ++i)
      {
        tree[nodes[i] + binpow(2, step)] = pull_from_pool();
        nodes.push_back(nodes[i] + binpow(2, step));
      }
    }
  }
  dfs(0);
  int cur = 1;
  newidx.resize(treesz);
  for (int i = 0; i < treesz; ++i)
    if (tree[i] != 0)
      newidx[i] = cur++;

  for (int i = 0; i < treesz; ++i)
    dfsans(i);

  return 0;
}